/***************************************************************************************************************************************/
/***************************************************************************************************************************************/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  									 							      **/
/**  							 Graphical MaxEnt							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/***************************************************************************************************************************************/
/***************************************************************************************************************************************/
/**  								 	 							      **/
/**  							    (possibly) 	 							      **/
/**  								 	 							      **/
/***************************************************************************************************************************************/










/***************************************************************************************************************************************/
/**  								 	 							      **/
/**  								 	 							      **/
/**  						Name a bad programming habbit.							      **/
/**  								 	 							      **/
/**  								 	 							      **/
/***************************************************************************************************************************************/
/**  								 	 							      **/
/**  								 	 							      **/
/**  							We have it.								      **/
/**  								 	 							      **/
/**  								 	 							      **/
/***************************************************************************************************************************************/








/*****************************************************************************************************************************************/
/** 						 CHANGELOG (after release 0.3)								**/
/*****************************************************************************************************************************************/
/** 																 	**/
/** Release 0.4 : - Adjust interval for writing out info in the non-verbose mode 							**/
/** 		  - Add TIME keyword 													**/
/** 	 	  - Add keywords GRAFirst and GRALevel for adjusting contouring of sections plotted with PGPLOT				**/
/** 	 	  - Add support for insertion of comments (preceded by #!*) in keyworded input files					**/
/** 	 																**/
/** Release 0.5 : - Keyword SHOW added to include a column with the value of entropy. 							**/
/** 	 	  - Attempt to incorporate an `informative' prior in Patterson function calculations : keyword PRIOr.			**/
/** 	 	    NOT VERY USEFUL (and very broken for non-primitive lattices).							**/
/** 	 	  - Keyword PHASeless <f> added to allow `free' phase refinement for reflections with low FOM.				**/
/** 		  - Square F000 internally in the case of Patterson function calculation						**/
/** 		  - Comments added to MAXENT_AUTO.IN											**/
/** 		  - LIMIT 0.5 is the default for Patterson function calculations							**/
/** 		  - Adjust target chi**2 value when PHASEless reflections are present 							**/
/** 	 	  - Add SWITch <f> keyword to allow switching to a phaseless calculation						**/
/** 	 	  - PSOUt keyword added to allow postscript output of sections (both conventional and maxent)				**/
/** 	 																**/
/** Release 0.6 : - Minor correction for .mtz handling							 				**/
/** 	 																**/
/** Release 0.7 : - Keyword GRAMaxcontours added to save us from wasting CPU time drawing contours at the origin peak.			**/
/** 	 																**/
/** Release 0.8 : - Limit on number of reflections increased to 120000									**/
/** 	 	  - Correct out-of-bounds bug in the calculation of normal probability plot						**/
/** 	 	  - Exiting in the case of 1D data removed (it can do 1D, so why stoping it ?)						**/
/** 	 	  - Keyword VT125 added to allow ploting (if PGPLOT permits) using sixel graphics on VTs (Y2K compliance achieved).	**/
/** 	 	  - Entropy (keyword SHOW) not on relative scale.									**/
/** 	 	  - Attempt to allow 1D plots to be constructed from current section only (not a general direction in 3D)		**/
/** 	 	    Keyword : ONEDime [u v] {start_u start_v}										**/
/** 	 	  - For Patterson functions, instead of using the largest amplitude as F000, use two times that				**/
/** 	 																**/
/** Release 0.9 : - Capture <CTRL-Z> and use it to exit gracefully	 								**/
/** 	 	  - Added periodic evaluation of the map entropy, plus user notification if this is not monotonically decreasing.	**/
/** 	 	    Also, once a divergence is detected, plotting of very low density areas may be switched-on with the keyword ZERO	**/
/** 	 	  - VERB with an argument, means "not VERB, but write out info every <given> cycles"					**/
/** 	 	  - When called as "graphent" (no capitals), enter QUIET mode (redirect stdout to /dev/null but retain stderr,	 	**/
/** 	 	    write more info on maxent map header (chi**2, current and target), etc.).						**/
/** 	 	  - Hard limit on number of contours (100) added.									**/
/** 	 																**/
/** Release 1.0 : - Keyword GRANsections added to allow plotting of "stack" of sections							**/
/** 	 	  - Plotting of the conventional map and of the final maxent map will use the mean & rmsd of the whole map and not	**/
/** 	 	    just the section that is being plotted.										**/
/** 	 																**/
/** Release 1.1 : - Added support for .mtz type combination GLGL (corresponding to an anomalous difference Patterson function).         **/
/**               - Adapt for threaded FFTW compilation (-DPARALLEL)          								**/
/**               - Fixed problem with marks on the horizontal axes                                                                 	**/
/** 	 	  - Changed the algorithm for FOM-weighted syntheses : more stable and fast but certainly not maxent :(			**/
/** 	 	  - Graphical user interface (wrapper to CCP4's sftools) added (when the program is called "graphent").			**/
/** 	 	  - Grid lines every 0.250 added to the section plots									**/
/** 	 																**/
/** 	 																**/
/**                                                                                                                                 	**/
/** 	 																**/
/** 	 																**/
/*****************************************************************************************************************************************/











#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <limits.h>
#include <values.h>
#include <unistd.h>
#include <signal.h>
#include <ctype.h>

#ifdef PARALLEL
#include <srfftw_threads.h>
#define 	NOF_THREADS	2
#else
#include <srfftw.h>
#endif





				/* Hmmm ... */
				/* I don't think that these can save us from serious troubles with VMS */
								
#ifdef VMS
#define 	strncasecmp 	strncmp
#define 	strcasecmp 	strcmp
#define		random 		rand
#define 	srandom 	srand 
#define		MAXRAND 	((float)(RAND_MAX)+1.0)
#endif




#ifndef VMS
#include <malloc.h>
#define		MAXRAND		((float)(INT_MAX)+1.0)
#endif



					
#define		GRID_FINE 	6.000		/* Grid size is [GRID_FINE x max(index)] rounded to the closest "good" FFT number  */
#define		MAX_NOF_REFL	120000
#define		MAX_REJ		1000
#define		LOG2(a)		(log10((double)(a))/log10(2.0))
#define         PI              (double)(3.14159265358979323846)
#define         PI2             (double)(1.57079632679489661923)
#define         PI4             (double)(0.78539816339744830962)
#define         min(a,b,c)      ((a)<=(b) && (a)<=(c) ? (a) : ((b)<=(c) ? (b) : (c)))
#define         max(a,b,c)      ((a)>=(b) && (a)>=(c) ? (a) : ((b)>=(c) ? (b) : (c)))
#define         max2(a,b)       ((a) >= (b) ? (a) : (b))
#define         min2(a,b)       ((a) <= (b) ? (a) : (b))
#define         getrand         ((float)(random())/MAXRAND)
#define         nearint(a)      ((a) < 0.0 ? (int)(a-0.50) : (int)(a+0.50))
#define		SQRT2 		(double)(1.414213562373095048801688724209698)   /* thanks to gnu, bc, dc and their arbitrary precision */

#define		GETTABLEVAL(n)	((int)(n)==0?0.010000:(  (int)(n)==1?0.01000*SQRT2:((int)(n)%2?(0.01000000*SQRT2*(2<<((int)(n)/2-1))):(0.01000000*(2<<((int)(n)/2-1))))))
												/* I can't read this either */






/**********************************************************************************************************************************/
/**   FFT definitions                                                                                                            **/
/**********************************************************************************************************************************/
rfftwnd_plan	p, pinv;
#define		SWAP(a,b)	tempr=(a) ; (a)=(b) ; (b)=tempr
#define 	FREE_ARG 	char*
#define		NR_END		1
#define		FORWARD		1
#define		INVERSE	       -1


/* Good (small prime) FFT numbers */

int good_numbers[51] = {
       1,       2,       4,       6,       8,      10,
      12,      14,      16,      20,      24,      28,
      30,      32,      40,      42,      48,      56,
      60,      64,      70,      80,      84,      96,
     112,     120,     128,     140,     160,     168,
     192,     210,     224,     240,     256,     280,
     320,     336,     384,     420,     448,     480,
     512,     560,     640,     672,     768,     840,
     896,     960,    1024  };
     
int	get_grid();     
     






/**********************************************************************************************************************************/
/**   MaxEnt definitions                                                                                                         **/
/**********************************************************************************************************************************/

float		CON	=	0.3750;		/* This is the assumed mean electron density of your (protein) crystals in e/A^3 */

/* Well, maybe not only maxent */
#define		YES		1
#define		NO		0









/**********************************************************************************************************************************/
/**   Other functions                                                                                                            **/
/**********************************************************************************************************************************/
float	maxent();
void	write_map();
void 	abortp();
void 	extram();
void    free_vector();
void	tona4();
void	plot_section();
void  	free_matrix();
void 	free_f3tensor();
float	**matrix( long nrl, long nrh, long ncl, long nch );
float	***f3tensor(long nrl, long nrh, long ncl, long nch, long ndl, long ndh );
void    nrerror( char error_text[]);
float   *vector();
void	normprob();
void	chidist();
double  fact();
double  findx();
float	lin_inter();
#ifndef NOPGPLOT
void	gui();
#endif


#ifndef VMS
void control_Z(int ignore);
#endif




/**********************************************************************************************************************************/
/**  CCP4                                                                                                                        **/
/**********************************************************************************************************************************/
#ifndef NOCCP4
extern	mtzini_();
extern	lropen_();
extern	lrcell_();
extern  lrncol_();
extern  lrclab_();
extern  lrclos_();
extern  lrrefl_();
extern  lrrefm_();
extern  mwrhdl_();
extern  msyput_();
extern  mspew_();
extern  mwclose_();
extern  lrsymi_();
#ifndef NONEWCCP4
extern ccp4h_init_lib_();
#endif
#endif




/**********************************************************************************************************************************/
/**   For plot_section()	                                                                                                 **/
/**********************************************************************************************************************************/
float	xmax, xmin, ymax, ymin;
float	angle;	
float 	tr[6];
float	cellf, cellm;
float	aspect;








/**********************************************************************************************************************************/
/**  Other                                                                                                                       **/
/**********************************************************************************************************************************/
int	verbose;
int	con_lambda;
int	extend;
float	cell[6];
int 	iuvw[3];
float 	refl[MAX_NOF_REFL][7];
int	spacegroup;
int	transform;
int	PATTERSON;
int	HAVE_FOM;
float	SQRT_SIGMA;
float	LIMIT_SIGMA;
float	AVER_SIGMA;
float	SCALE_FOM;
float	MAX_FOM;
float	MIN_FOM;
float	TARGET_CHI;
int	ORIGIN_REMOVED;
int	MAP_FORMAT;
int	GRAPH_INTER;
int	GRAPH_WAIT;
float	GRAPH_SECTION;
int	DO_PLOT;
int	GRAYSCALE;
int	KEEPCONV;
float	chicontrib[MAX_NOF_REFL];
int	chirefl[MAX_NOF_REFL][3];
int	chitable;
int	chipointers[MAX_NOF_REFL][3];
int	WILL_TEST;
int	DIFF_PATTERSON;
int	MTZ_HAVE_RES = NO;
int	HAVE_ZONE_SELECTION = NO;
double  normtab[2][4096];
int	DO_REJECT;
int	HAVE_F000 = NO;
int	SHOW_ENTROPY = NO;
int	VERB_INTERVAL = -1;
int	HAVE_TIME = NO;
float	CONTOUR_LEVEL = 0.5000;
float	FIRST_CONTOUR = 0.0000;
float	max_res;
int	MAKE_NONUNIFORM = NO;
float	PEAK_BACKGROUND = -1.0;
int	PHASELESS = NO;
float	FOM_PHASELESS;
float	SWITCH = -1.0;
int	total_number_of_obs;
float	excl_fom = -1.0;
int	MAKE_PS = NO;
int	MAX_GRCONT = -1;
int	VT125 = NO;
int	DO_1D = NO;
float	U_1D = 1.0;
float	V_1D = 1.0;
float	V_1START = 0.0;
float	U_1START = 0.0;
char	called[300];
int 	axial;
double	lambda;
int	PLOT_ZEROED = NO;
float	plot_zero_val;
int	DO_PLOT_ZEROED = NO;
int	QUIET = NO;
int	NOF_SECTIONS_TO_PLOT = 0;
int	DO_CALC_RMS = NO;
int	GUI = NO;
int	FORCE_F000 = NO;
int	FORCE_SQUARE_F000 = NO;
int	OVERFIT = NO;




/**********************************************************************************************************************************/
/**  Supported map types                                                                                                         **/
/**********************************************************************************************************************************/

#define		CCP4_MAP	1
#define		NA4_MAP		2
#define		ASCII_MAP	3











/**********************************************************************************************************************************/
/**  Two-level control (so that we can switch them off even if we do have them at compilation time                               **/
/**********************************************************************************************************************************/


#ifdef NOCCP4
int 	HAVE_CCP4 = NO;
#else
int	HAVE_CCP4 = YES;
#endif



#ifdef NOPGPLOT
int 	HAVE_PGPLOT = NO;
#else
#include "cpgplot.h"
int 	HAVE_PGPLOT = YES;
#endif




















main(argc, argv)
int     argc;
char    *argv[];
{

	/* Map handling */
	int 	test_file;
	int	ier;


	/* For FFT */
	float	***Fobs_1;    
	float	***SigF_1;    
	float	***PriorA_1;    
	FILE	*wisdom;


	/* Rest */   
	int	grid_x, grid_y, grid_z, size;
	int	i, m, n;
	int	thrown;
	double	ini_lambda;
	int	u, v, w;
	float	sum_dens, sum_sq;
	float	max, min, inte;
	float	val;
	float	scale;
	float	norm;
	float	R_factor;
	int	obs;
	float	average_F;
	float	amp, estimated_sigma, sig;
	FILE	*in;
	FILE 	*out;
	char	string[80];
	char	*name[80];
	float	Fo, Fc;	
	float	h, k, l, F, sigF, phi, fom;
	float	A, B;
	int	added_refl;
	float	search1, search2;
	time_t	t1, t2;	
	time_t  tjunk;
	float	rec_a, rec_b, rec_angle;
	float	length;
	float	psigA, psigB;
	char	jchar[80];
	char	envi[300]="SYMOP=";
	float	mean, rms, chi_limit;
	int	chi_above;
	char	line[ 300];
	float	q1, q2, q3, q4, q5, q6, q7, q8, q9;
	int	items;
	int	hmin,hmax,kmin,kmax,lmin,lmax;
	int	ht, kt, lt;
	int	hgrid, kgrid, lgrid;
	float	fph, sigfph;
	float	exclusion_limit;
	float	RES_LOW, RES_HIGH;
	char	zone[5];
	char	wisdom_name[300];
	int	brejected[3][MAX_REJ];
	FILE	*rej;
	int	nof_rej;
	int	SKIP;
	float	GLOBAL_SCALE = -1.0;	
	int	nof_unknown;
	int	c;
	char	details[81];
	char	junk[300];
	int	abs_hmax, abs_kmax, abs_lmax;
	int	phasenot = 0;
	float	mem_req;
	int	excluded_due_to_fom;
	int	verbose_flag_1;
	int	verbose_flag_2;
	int 	more_than_2sigma = 0;
	int	truespacegroup = 1;
	int	jmtz;
	char	jcmtz;
	char 	spname[10], pgname[10];
	
	


	
	
	



	strcpy( &called[0], argv[0] );
	

#ifndef VMS        
	signal( SIGFPE,  SIG_IGN );	/* Hmmm */
	signal( SIGTSTP, control_Z );
        setlinebuf( stdout ); 		/* Some people can't wait to see the next line in the LOG file */       
#endif	



										/* if called as "graphent", switch to quiet mode and */
										/* start gui */
	if ( strncmp( &argv[0][ strlen(argv[0]) -8], "graphent", 8) == 0 )
		{
			GUI = YES;
			QUIET = YES;
			freopen( "/dev/null", "w", stdout );

				}
		




	t1 = time(0);
	printf("\n\n\n\n\n\n\n\n");


	printf("\033[36m___________________________________________________________________________________________________________________________\033[0m\n");
	printf("\033[35m                                                                                    \n\n");
	printf("                                   ###   ###                   #######            #      \n");
	printf("                                    ##   ##                     #    #            #      \n");
	printf("                                    # # # #   ####   ### ###    #    # ## ###   ######   \n");
	printf("                                    # # # #  #    #   #   #     #  #    ##   #    #      \n");
	printf("                                    #  #  #       #    # #      ####    #    #    #      \n");
	printf("                                    #  #  #   #####     #       #  #    #    #    #      \n");
	printf("                                    #     #  #    #    # #      #    #  #    #    #      \n");
	printf("                                    #     #  #    #   #   #     #    #  #    #    #   #  \n");
	printf("                                   ###   ###  #### # ### ###   ####### ###  ###    ###   \033[36m\n");
	printf("                                                                                                 \n");
	printf("                                                    \033[1m\033[36mBeta, Release 1.1\033[0m\033[36m                         \n");
	printf("                                                                                                 \n");
	printf("                                 Gull, S.F. & Daniell, G.J. (1978), Nature, 272, 686-690         \n");
	printf("                                        Collins, D.M. (1982), Nature, 298, 49-51                 \n");
	printf("                                                                                                 \n");
	printf("                                                           NMG                                   \n");
	printf("                                                                                                     \n");
	printf("\033[36m___________________________________________________________________________________________________________________________\033[0m\n\n");










	/*********************************************************************************************************************************/
	/**  If we have CCP4, create an enviromental variable SYMOP pointing to the symmetry operators file 				**/
	/*********************************************************************************************************************************/
								

	if ( HAVE_CCP4 == YES )
		{
			if ( getenv("CLIBD") == NULL )
				{
					fprintf(stderr, "\033[31m\033[1mCCP4 symbol missing : CLIBD not defined. No support for CCP4.\033[0m\n");
					HAVE_CCP4 = NO;
							}
			else
			{	
			strcat( envi, getenv("CLIBD") );
			strcat( envi, "/symop.lib");
			putenv( envi );
				}
						}






				
	/*********************************************************************************************************************************/
	/**  In the case of a CCP4 run we may have zone definition and resolution limits (both required). 				**/
	/*********************************************************************************************************************************/


	if  ( HAVE_CCP4 == YES && ( argc == 3 || argc == 5 ))		/* We may have a zone definition.  */
		{
			if ( 	strcasecmp( argv[1],  "HK0" ) == 0  ||
				strcasecmp( argv[1],  "0KL" ) == 0  ||
				strcasecmp( argv[1],  "H0L" ) == 0  ||
				strcasecmp( argv[1],  "H00" ) == 0  ||
				strcasecmp( argv[1],  "0K0" ) == 0  ||
				strcasecmp( argv[1],  "00L" ) == 0  ||
				strcasecmp( argv[1],  "HH0" ) == 0  ||
				strcasecmp( argv[1], "-HH0" ) == 0  ||
				strcasecmp( argv[1],  "HHH" ) == 0  ||
				strcasecmp( argv[1],  "HHL" ) == 0 )
				{
					HAVE_ZONE_SELECTION = YES;
					strcpy( zone, argv[1] );
					if ( argc == 3 )
						{
							strcpy( argv[1], argv[2] );
							argc = 2;
								}
					else
						{
							strcpy( argv[1], argv[2] );
							strcpy( argv[2], argv[3] );
							strcpy( argv[3], argv[4] );
							argc = 4;
								}
						
				
					}
			else
				abortp();	
				
			
		}







	/*********************************************************************************************************************************/
	/**  If no argument is given, try to open a MAXENT.DAT file from the current directory						**/
	/*********************************************************************************************************************************/

	if ( argc == 1 )
		{
			test_file = open( "MAXENT.DAT", O_RDONLY, 0 );
			if ( test_file == -1 )
				abortp();
			close( test_file );
								}
	else
		if ( argc > 5 )
			abortp();
		
	else
	/*********************************************************************************************************************************/
	/**  Resolution limits for .mtz run												**/
	/*********************************************************************************************************************************/

		if ( argc == 4 )
			{
			if ( HAVE_CCP4 == YES && strncasecmp( &argv[3][strlen(argv[3])-4], ".MTZ", 4 ) == 0 )
			{
			if ( sscanf( argv[1], "%f", &RES_LOW ) == 1 && sscanf( argv[2], "%f", &RES_HIGH ) == 1 )
				{
					if ( RES_LOW < RES_HIGH )
						{
							val = RES_HIGH;
							RES_HIGH = RES_LOW;
							RES_LOW = val;
								}
					MTZ_HAVE_RES = YES;
					argc = 2;
					strcpy( argv[1], argv[3] );
									}
			else
				abortp();
			}
			else
				abortp();
			}
	else
		{
			test_file = open( argv[1], O_RDONLY, 0 );			
			if ( test_file == -1 )
				{
					fprintf(stderr, "\033[31m\033[1mCan not open %s\033[0m\n", argv[1]);
					abortp();
							}
			close( test_file );
								}
	







	/**************************************************************************************************************************/
	/**   If we have CCP4 and the file name ends in .mtz, start interpreting mtz file                                        **/
	/**************************************************************************************************************************/
#ifndef NOCCP4


#ifndef NOPGPLOT	
	if ( GUI == YES && argc == 2 && HAVE_CCP4 == YES && strncasecmp( &argv[1][strlen(argv[1])-4], ".MTZ", 4 ) == 0 )
		{

			gui( &argv[1][0] );

			test_file = open( "from_graphent.mtz", O_RDONLY, 0 );			
			if ( test_file == -1 )
				{
					fprintf(stderr, "\033[31m\033[1mFailed to prepare the file \"from_graphent.mtz\"\033[0m\n");
					fprintf(stderr, "\033[31m\033[1mProblem with the CCP4 being up-and-running ? \033[0m\n");
					fprintf(stderr, "\033[31m\033[1mCentrosymmetric space group in the %s file ?\033[0m\n", argv[1]);
					fprintf(stderr, "\033[31m\033[1mBug in this program ?\033[0m\n\n");

					fprintf(stderr, "\033[37m\033[1mPlease use the program in the non-gui mode (run it\033[0m\n");
					fprintf(stderr, "\033[37m\033[1mas \"GraphEnt\" instead of \"graphent\", see the documentation\033[0m\n");
					fprintf(stderr, "\033[37m\033[1mfor details on how to do that).\033[0m\n\n\n");
					
					exit(1);
							}
			close( test_file );


			strcpy( argv[1], "from_graphent.mtz" );
				}

#endif
				
					/* window-based column selection */
					


	if ( argc == 2 && HAVE_CCP4 == YES && strncasecmp( &argv[1][strlen(argv[1])-4], ".MTZ", 4 ) == 0 )
	{
        int     mindx;
        int     iprint;
        int     ifail;
        float   resol;
        float   adata[40];
        int     eof;
        int     i;
	int	ncolx;
	int	missing[40];
	char	clabs[40][30];
	char	ctyps[40][1];
	int	more_col;
	char	all[20];
	int	type;
	char	type_d[300];
	FILE	*out2, *out3;


	printf("\033[32m - Assuming that input is a .mtz file. Interpreting ...\033[0m\n\n");






	/*********************************************************************************************************************************/
	/**  MTZ stuff. Open mtz file, get column types and start comparing with supported modes of operation				**/
	/*********************************************************************************************************************************/

#ifndef NONEWCCP4
        mindx = -1;
        iprint = -1;
	ccp4h_init_lib_( &mindx, &iprint );
#endif

        mindx = 1;
        iprint = 0;
        mtzini_();
        lropen_( &mindx, &argv[1][0],  &iprint, &ifail, strlen(argv[1]) );

	if ( ifail == -1 )
		{
			fprintf(stderr, "\n\n\033[31m\033[1mMTZ error (lropen()). Abort.\033[0m\n\n");
			exit(1);
					}
	lrcell_( &mindx, &cell[0] );
	
	lrsymi_( &mindx, &jmtz, &jcmtz, &truespacegroup, &spname[0], &pgname[0] );
	
	lrncol_( &mindx, &ncolx );
	if ( ncolx > 28 )
		{
			fprintf(stderr, "\n\n\033[31m\033[1mToo many columns in .mtz. Abort.\033[0m\n\n");
			exit(1);
					}
	more_col = 30;
	lrclab_( &mindx, &clabs[0][0], &ctyps[0][0], &more_col );
	for ( i=0 ; i < more_col ; i++ )
		all[i] = ctyps[i][0];
	
	all[i] = 0;



	/* What we think we know what to do about */

	if ( strncmp(all,"HHHFQPW",7   ) == 0 )
		{
			type = 2;
			strcpy( type_d, "Synthesis with h,k,l,F,sig(F),phi and known FOMs");
				}
	else if ( strncmp(all,"HHHFQP",6) == 0 )
		{
			type = 1;
			strcpy( type_d, "Synthesis with h,k,l,F,sig(F),phi but without FOMs");
				}
	else if ( strncmp(all,"HHHFQFQDQ",9 ) == 0 )
		{
			type = 4;
			strcpy( type_d, "Isomorphous difference Patterson synthesis with h,k,l,FP,sig(FP),FPH,sig(FPH) (anomalous data present)");
				}
	else if ( strncmp(all,"HHHFQFQ",7   ) == 0 || strncmp(all,"HHHGLGL",7   ) == 0 )
		{
			type = 3;
			strcpy( type_d, "Isomorphous difference Patterson synthesis with h,k,l,FP,sig(FP),FPH,sig(FPH)");
				}
	else if ( strncmp(all,"HHHDQ" ,5    ) == 0 )
		{
			type = 5;
			strcpy( type_d, "Anomalous Patterson function with h,k,l,Danom,sig(Danom)");
				}
	else if ( strncmp(all,"HHHFQ", 5     ) == 0 )
		{
			type = 6;
			strcpy( type_d, "Patterson function calculation with h,k,l,F,sig(F)");
				}
	else
		type = 0;






	if ( type != 0 )
	{

	/*********************************************************************************************************************************/
	/**  Found a recognisable column type combination. 										**/
	/*********************************************************************************************************************************/
	lrclos_(&mindx);
	printf("\033[32m - Accepted column type combination found.\033[0m\n");
	







	/*********************************************************************************************************************************/
	/**  If we have a zone selection, run mtzutils on the input file								**/
	/*********************************************************************************************************************************/
	if ( HAVE_ZONE_SELECTION == YES )
	{

	printf("\033[32m - Zone selection with MTZUTILS.\033[0m\n");

	/* This will definetely not work with VMS */

	out = fopen( "MAXENT_script_for_mtzutils.in", "w" );
	fprintf( out, "\n\nmtzutils hklin %s hklout MAXENT_zone.mtz > MAXENT_MTZUTILS_RUN.LOG << eof\n", argv[1]);
	fprintf( out, "ONEFILE\n");
	fprintf( out, "INCLUDE ALL\n");
	fprintf( out, "AXIS %s\n", zone);
	fprintf( out, "RUN\n");
	fprintf( out, "eof\n");
	fclose(out);
	system("/bin/chmod 755 MAXENT_script_for_mtzutils.in ; ./MAXENT_script_for_mtzutils.in");





	/*********************************************************************************************************************************/
	/**  There must be better ways to confirm that everything went OK with mtzutils 						**/
	/*********************************************************************************************************************************/
	test_file = open( "MAXENT_zone.mtz", O_RDONLY, 0 );
	if ( test_file == -1 )
		{
			fprintf(stderr, "\n\n\033[31m\033[1mMTZUTILS failure ? Is CCP4 up and running ?\033[0m\n\n");
			exit(1);
					}
	close( test_file );
	}
	





	/*********************************************************************************************************************************/
	/**  Now, its CAD's turn to expand the data to P1										**/
	/*********************************************************************************************************************************/

	printf("\033[32m - Proceed to data expansion with CAD.\033[0m\n");

	out = fopen( "MAXENT_script_for_cad.in", "w" );
	if ( HAVE_ZONE_SELECTION == NO )
	fprintf( out, "\n\ncad hklin1 %s hklout FOR_MAXENT_P1.mtz > MAXENT_CAD_RUN.LOG << eof\n", argv[1]);
	else
	fprintf( out, "\n\ncad hklin1 MAXENT_zone.mtz hklout FOR_MAXENT_P1.mtz > MAXENT_CAD_RUN.LOG << eof\n");
	
	fprintf( out, "OUTLIM SPACEGROUP 1\n");
	fprintf( out, "LABIN FILE 1 ALL\n");
	fprintf( out, "END\n");
	fprintf( out, "eof\n");
	fclose(out);
	system("/bin/chmod 755 MAXENT_script_for_cad.in ; ./MAXENT_script_for_cad.in");

	/* Hmm ... */
	test_file = open( "FOR_MAXENT_P1.mtz", O_RDONLY, 0 );
	if ( test_file == -1 )
		{
			fprintf(stderr, "\n\n\033[31m\033[1mCAD failure ? Is CCP4 up and running ?\033[0m\n\n");
			exit(1);
					}
	close( test_file );
	





	/*********************************************************************************************************************************/
	/** In the final step, open .mtz file from CAD and prepare an AUTO labelled file with cell and reflections. 		 	**/
	/** The created MAXENT_FROM_MTZ.in will be further interpreted (as all AUTO-labelled files do).					**/ 
	/*********************************************************************************************************************************/
	
	printf("\033[32m - Final .mtz pass : preparing ascii file for MAXENT.\033[0m\n");
	printf("\033[33m   Synthesis type set to :\n   %s\033[0m\n", type_d );
        out = fopen( "MAXENT_FROM_MTZ.in", "w");
	fprintf( out, "AUTO % 14.5f  % 14.5f  % 14.5f  % 14.5f  % 14.5f  % 14.5f  %d\n", 
			cell[0], cell[1], cell[2], cell[3], cell[4], cell[5], truespacegroup );
	







	/*********************************************************************************************************************************/
	/**  Type 4 is isomomorphous difference Patterson function which includes anomalous data. Will create two additional files.	**/
	/**  The MAXENT_FROM_MTZ_ANOMALOUS.in contains DFano, whereas MAXENT_SUM_PATT.in contains sqrt(DFiso^2 + DFano^2) coefficients  **/
	/*********************************************************************************************************************************/
	if ( type == 4 )
		{
		        out2 = fopen( "MAXENT_FROM_MTZ_ANOMALOUS.in", "w");
			fprintf( out2, "AUTO % 14.5f  % 14.5f  % 14.5f  % 14.5f  % 14.5f  % 14.5f  1\n", 
					cell[0], cell[1], cell[2], cell[3], cell[4], cell[5] );

		        out3 = fopen( "MAXENT_SUM_PATT.in", "w");
			fprintf( out3, "AUTO % 14.5f  % 14.5f  % 14.5f  % 14.5f  % 14.5f  % 14.5f  1\n", 
					cell[0], cell[1], cell[2], cell[3], cell[4], cell[5] );
				}
	




	/*********************************************************************************************************************************/
	/**  Open mtz file and start reading reflection records 									**/
	/*********************************************************************************************************************************/
	mindx = 1;
        iprint = 1;
        mtzini_();
        lropen_( &mindx, "FOR_MAXENT_P1.mtz",  &iprint, &ifail, 17 );
	if ( ifail == -1 )
		{
			fprintf(stderr, "\n\n\033[31m\033[1mMTZ error (lropen()) ? Abort.\033[0m\n\n");
			exit(1);
					}
	

	lrrefl_(&mindx, &resol, &adata[0], &eof );
	lrrefm_(&mindx, &missing[0]);

	while( eof == 0 )
	{
	if ( MTZ_HAVE_RES == NO || (MTZ_HAVE_RES == YES && sqrt(1.0/resol) >= RES_HIGH && sqrt(1.0/resol) <= RES_LOW))
	{


	/*********************************************************************************************************************************/
	/**  Depending on the type of synthesis, export correct number and type of columns to the AUTO labelled file 			**/
	/*********************************************************************************************************************************/

	if ( type == 1 )
	{		
		if ( !(missing[3] | missing[4] | missing[5] ) )
		fprintf( out, "% 5d % 5d % 5d   % 15.5f % 15.5f % 10.5f\n", nearint(adata[0]), nearint(adata[1]), nearint(adata[2]), adata[3], adata[4], adata[5] );
	}
	else if ( type == 2 )
	{		
		if ( !(missing[3] | missing[4] | missing[5] | missing[6] ) )
		fprintf( out, "% 5d % 5d % 5d   % 15.5f % 15.5f % 10.5f % 10.7f\n", nearint(adata[0]), nearint(adata[1]), nearint(adata[2]), adata[3], adata[4], adata[5], adata[6] );
	}
	else if ( type == 3 )
	{									/* Some  people's .mtz dont't have MNFs */
		if ( !(missing[3] | missing[4] | missing[5] | missing[6] ) 
		&& !(( adata[3] < 0.0000000010 && adata[4] < 0.0000000010) || (adata[5] < 0.0000000010 && adata[6] < 0.0000000010)) )
		fprintf( out, "% 5d % 5d % 5d   % 15.5f % 15.5f % 15.5f % 15.5f\n", nearint(adata[0]), nearint(adata[1]), nearint(adata[2]), adata[3], adata[4], adata[5], adata[6] );
	}
	else if ( type == 4 )
	{									/* Some people's .mtz dont't have MNFs */
		if ( !(missing[3] | missing[4] | missing[5] | missing[6] ) 
		&& !(( adata[3] < 0.0000000010 && adata[4] < 0.0000000010) || (adata[5] < 0.0000000010 && adata[6] < 0.0000000010)) )
		fprintf( out,  "% 5d % 5d % 5d   % 15.5f % 15.5f % 15.5f % 15.5f\n", nearint(adata[0]), nearint(adata[1]), 
					nearint(adata[2]), adata[3], adata[4], adata[5], adata[6] );


							/* This is awful. I should be using symlib to check if the reflection is centric */

		if ( !(missing[7] | missing[8] ) && !( fabs(adata[7]) < 0.0000000010 && adata[8] < 0.0000000010) )
		fprintf( out2, "% 5d % 5d % 5d   % 15.5f % 15.5f\n", nearint(adata[0]), nearint(adata[1]), nearint(adata[2]), 
											fabs(adata[7]), adata[8] );
		
		

		/* This is for a "sum difference Patterson" (an approximation to FHLE). We explicitly square, and set phases to 0 */
		/* Note that for this calculation we need Kemp. Assume that 4 anomalous electrons is a reasonable number and cont. */
		/* Have both DFiso and DANO */
		if (
			!(missing[3] | missing[4] | missing[5] | missing[6] )
		     && !(( adata[3] < 0.0000000010 && adata[4] < 0.0000000010) || (adata[5] < 0.0000000010 && adata[6] < 0.0000000010))
		     && !(missing[7] | missing[8] ) && !( fabs(adata[7]) < 0.0000000010 && adata[8] < 0.0000000010) )
			fprintf( out3, "% 5d % 5d % 5d   % 15.5f % 15.5f  0.0\n", nearint(adata[0]), nearint(adata[1]), nearint(adata[2]),
					(adata[3]-adata[5])*(adata[3]-adata[5]) + (adata[7]*adata[7]),
					sqrt( 4.0*(adata[3]-adata[5])*(adata[3]-adata[5])*(adata[4]*adata[4]+adata[6]*adata[6]) +
					16.0*adata[7]*adata[7]*adata[8]*adata[8] ));
		else
		/* Only DFiso */
		if (
			!(missing[3] | missing[4] | missing[5] | missing[6] )
		     && !(( adata[3] < 0.0000000010 && adata[4] < 0.0000000010) || (adata[5] < 0.0000000010 && adata[6] < 0.0000000010)))
			fprintf( out3, "% 5d % 5d % 5d   % 15.5f % 15.5f  0.0\n", nearint(adata[0]), nearint(adata[1]), nearint(adata[2]),
					(adata[3]-adata[5])*(adata[3]-adata[5]) ,
					sqrt( 4.0*(adata[3]-adata[5])*(adata[3]-adata[5])*(adata[4]*adata[4]+adata[6]*adata[6]) ));
		else
		/* Only DFano */
		if ( !(missing[7] | missing[8] ) && !( fabs(adata[7]) < 0.0000000010 && adata[8] < 0.0000000010) ) 
			fprintf( out3, "% 5d % 5d % 5d   % 15.5f % 15.5f  0.0\n", nearint(adata[0]), nearint(adata[1]), nearint(adata[2]),
					(adata[7]*adata[7]), sqrt(16.0*adata[7]*adata[7]*adata[8]*adata[8] ));
		
		
		
		
	}
	else if ( type == 5 )						
	{					
		if ( !(missing[3] | missing[4] ) && !( adata[3] < 0.0000000010 && adata[4] < 0.0000000010) )
		fprintf( out, "% 5d % 5d % 5d   % 15.5f % 15.5f\n", nearint(adata[0]), nearint(adata[1]), nearint(adata[2]), adata[3], adata[4] );
	}
	else if ( type == 6 )
	{		
		if ( !(missing[3] | missing[4] ) && !( adata[3] < 0.0000000010 && adata[4] < 0.0000000010) )
		fprintf( out, "% 5d % 5d % 5d   % 15.5f % 15.5f\n", nearint(adata[0]), nearint(adata[1]), nearint(adata[2]), adata[3], adata[4] );
	}		
	}
	lrrefl_(&mindx, &resol, &adata[0], &eof );	
	lrrefm_(&mindx, &missing[0]);
	}
	
	fclose(out);
	if ( type == 4 )
		{
		fclose( out2 );
		fclose( out3 );
		}
	lrclos_(&mindx);		


	/*********************************************************************************************************************************/
	/**  For the rest of the program it would appear that you started the calculation with this ASCII (AUTO-labelled file)		**/
	/*********************************************************************************************************************************/
	strcpy( argv[1], "MAXENT_FROM_MTZ.in" );


	}
	else
	{

	/*********************************************************************************************************************************/
	/**  Column type combination not recognised.											**/
	/*********************************************************************************************************************************/

	fprintf(stderr, "\n\n\033[31m\033[1mFailed to guess intended map type from column types. Use CAD to select only relevant columns.\033[0m\n\n");
	exit( 1 );
	}

	/* Hoping that `rm' still means rm */ 
	system("/bin/rm -rf ./MAXENT_script_for_mtzutils.in");
	system("/bin/rm -rf ./FOR_MAXENT_P1.mtz");
	system("/bin/rm -rf ./MAXENT_CAD_RUN.LOG");
	system("/bin/rm -rf ./MAXENT_MTZUTILS_RUN.LOG");
	system("/bin/rm -rf ./MAXENT_zone.mtz");
	system("/bin/rm -rf ./MAXENT_script_for_cad.in");

	
	printf("\033[36m___________________________________________________________________________________________________________________________\033[0m\n\n");
	
	}
#endif	








	/**************************************************************************************************************************/
	/**   If the first string on the first line is AUTO, start creating an input file                                        **/
	/**************************************************************************************************************************/
	if ( argc == 1 )
		in = fopen("MAXENT.DAT", "r" );
	else
		in = fopen(argv[1], "r" ); 
	if ( in == NULL )
		{
			fprintf(stderr, "\n\n\033[31m\033[1mCan not open input file. Abort.\033[0m\n\n");
			exit(1);
		}
	
	if ( fscanf( in, "%s", &string[0] ) == EOF )
		{
			fprintf(stderr, "\n\n\033[31m\033[1mEmpty input file ? Abort.\033[0m\n\n\n");
			exit(1);
					}
	
	

	if ( strncasecmp( &string[0], "AUTO", 4) == 0 )
	{

	/* Well, you never know */
	if ( strcasecmp( &argv[1][0], "MAXENT_AUTO.IN" ) == 0 )
		{
			fprintf(stderr, "\n\n\033[31m\033[1mPlease give your input file a different name (MAXENT_AUTO.IN will be opened for writing).\033[0m\n");
			exit(1);
				}
	
	
	
	HAVE_FOM = NO;
	printf("\033[32m - AUTO keyword present. Interpreting input ...\033[0m\n");
	
	if ( fscanf( in, "%f %f %f %f %f %f %d", &cell[0], &cell[1], &cell[2], &cell[3], &cell[4], &cell[5], &spacegroup ) != 7 )
		{
			fprintf(stderr, "\033[31m\033[1m\n\nError. Expected format is 'AUTO a b c alpha beta gamma spacegroup_number'\033[0m\n\n");
			exit( 1 );
					}
	rewind( in );
	fgets( line, 299, in );
	fgets( line, 299, in );


	/* This is not a safe way to count columns in a line */
	items = sscanf( line, "%f %f %f %f %f %f %f %f",&q1,&q2,&q3,&q4,&q5,&q6,&q7,&q8 );
	
	if ( items >= 8 )
		{
			fprintf(stderr, "\033[31m\033[1m\n\nToo many (>=8) entries for each reflection record. Abort.\033[0m\n\n");
			exit( 1 );
					}
	if ( items < 5 )
		{
			fprintf(stderr, "\033[31m\033[1m\n\nToo few (<=4) entries for each reflection record. Abort.\033[0m\n\n");
			exit( 1 );
					}
			


	/*********************************************************************************************************************************/
	/**  Start preparing final input file (MAXENT_AUTO.IN)										**/
	/*********************************************************************************************************************************/
	out = fopen("MAXENT_AUTO.IN", "w");
	fprintf( out, "# \n");
	fprintf( out, "# \n");
	fprintf( out, "# Automatically produced by GraphEnt\n");
	fprintf( out, "# \n");
	fprintf( out, "# \n\n");
	



	fprintf( out, "#\n# Cell and space group number\n#\n");
	fprintf( out, "CELL              %7.3f  % 7.3f  % 7.3f  % 7.3f  % 7.3f  % 7.3f\n", 
			cell[0], cell[1], cell[2], cell[3], cell[4], cell[5] );
	fprintf( out, "SPACEGROUP        %d\n", spacegroup );


	fprintf( out, "\n#\n# Output map format\n#\n");
	if ( HAVE_CCP4 == YES )
		fprintf( out, "MAP_FORMAT        CCP4\n");
	else
		fprintf( out, "MAP_FORMAT        ASCII\n");
		
		
	if ( items == 5 )
		{
			printf(" - Five items found. Assuming these are h,k,l,F,sig(F) for a \033[31mPatterson\033[0m calculation.\n");
			fprintf( out, "\n#\n# Patterson calculation assumed. Exclude small differences.\n#\n");
			fprintf(out, "PATTERSON\n");
			fprintf(out, "LIMIT             0.50\n");
				}
	if ( items == 6 )
		printf(" - Six items found. Assuming these are h,k,l,F,sig(F) and phi.\n");
	if ( items == 7 )
	{
	while ( fgets( line, 299, in ) != NULL )   			
		{
			if ( sscanf( line, "%f %f %f %f %f %f %f",&q1,&q2,&q3,&q4,&q5,&q6,&q7 ) != 7 )
				{
					fprintf(stderr, "\n\n\033[31m\033[1mProblem with a reflection record : can not read seven items.\033[0m\n\n");
					exit(1);
							}
			if ( q7 > 1.010 )
				break;
								}
	if ( q7 > 1.0 )
		{
			printf(" - Seven items found and the last is not FOM. h,k,l,FP,sig(FP),FPH,sig(FPH) for difference \033[31mPatterson\033[0m assumed.\n");
			fprintf( out, "\n#\n# Difference Patterson calculation assumed. Exclude small differences.\n#\n");
			fprintf(out, "DIFF_PATT\n");
			fprintf(out, "LIMIT             0.50\n");
				}
	else
		{
			printf(" - Seven items found and the last is FOM. Synthesis with h,k,l,F,sig(F),phi,\033[31mFOM\033[0m assumed.\n");
			fprintf( out, "\n#\n# Phased synthesis with FOM present.\n#\n");
			fprintf(out, "FOM_PRESENT\n");					
			HAVE_FOM = YES;
				}
	}
	
	
	rewind(in);
	fgets( line, 299, in );



	/*********************************************************************************************************************************/
	/**  Indeces range for grid size estimation											**/
	/*********************************************************************************************************************************/

	printf(" - First pass to determine indeces ranges.\n");
	hmin =  10000;
	hmax = -10000;
	kmin =  10000;
	kmax = -10000;
	lmin =  10000;
	lmax = -10000;
	while ( fgets( line, 299, in ) != NULL )
		if ( sscanf( line, "%d %d %d", &ht, &kt, &lt ) != 3 )
			{
				fprintf(stderr, "\n\n\033[31m\033[1mProblem with reflection record : can not read indeces.\033[0m\n\n");
				exit(1);
						}
		else
			{
				
				if ( ht > hmax )
					hmax = ht;
				if ( ht < hmin  )	
					hmin  = ht;

				if ( kt > kmax )
					kmax = kt;
				if ( kt < kmin  )	
					kmin  = kt;

				if ( lt > lmax )
					lmax = lt;
				if ( lt < lmin  )	
					lmin  = lt;
								}

	
	
		
	
	
	/*********************************************************************************************************************************/
	/**  get_grid() returns a good FFT number close to the given argument							 	**/
	/*********************************************************************************************************************************/

	if ( hmin != 0 || hmax != 0 )
		hgrid = get_grid( GRID_FINE * max2( fabs(hmin), fabs(hmax) ));
	else
		hgrid = 1;

	if ( kmin != 0 || kmax != 0 )
		kgrid = get_grid( GRID_FINE * max2( fabs(kmin), fabs(kmax) ));
	else
		kgrid = 1;

	if ( lmin != 0 || lmax != 0 )
		lgrid = get_grid( GRID_FINE * max2( fabs(lmin), fabs(lmax) ));
	else
		lgrid = 1;


	/*********************************************************************************************************************************/
	/**  Few additional checks													**/
	/*********************************************************************************************************************************/

		
	if ( hgrid == 1 && kgrid == 1 && lgrid == 1 )
		{
			fprintf(stderr, "\n\n\033[31m\033[1mCan not do nought-dimensional syntheses.\033[0m\n\n");
			exit( 1 );
					}

	if ( hgrid == 1 && kgrid == 1 )
		{
			hgrid = 2;
			printf("\033[33m - One dimensional 00l synthesis. Dummy (h) dimension set to 2.\033[0m\n");
			fprintf(out, "\n#\n# One dimensional data set ...\n#\n");
			fprintf(out, "ONEDimensional    1.0 0.0 0.0 0.0\n");
				}
	if ( hgrid == 1 && lgrid == 1 )
		{
			hgrid = 2;
			printf("\033[33m - One dimensional 0k0 synthesis. Dummy (h) dimension set to 2.\033[0m\n");
			fprintf(out, "\n#\n# One dimensional data set ...\n#\n");
			fprintf(out, "ONEDimensional    0.0 1.0 0.0 0.0\n");
				}
	if ( kgrid == 1 && lgrid == 1 )
		{
			lgrid = 2;
			printf("\033[33m - One dimensional h00 synthesis. Dummy (l) dimension set to 2.\033[0m\n");
			fprintf(out, "\n#\n# One dimensional data set ...\n#\n");
			fprintf(out, "ONEDimensional    0.0 1.0 0.0 0.0\n");
				}
	


	/*********************************************************************************************************************************/
	/** Permutation selection. I bet that some of these change chirality. The point is that with 3D data in the correct hemisphere	**/
	/** the permutation will always be 312 (which I have repeatedly checked that gives the correct hand)				**/
	/*********************************************************************************************************************************/


	fprintf( out, "\n#\n# Axes permutation and grid spacing.\n#\n");
	if ( hgrid > 1 && kgrid > 1 && lgrid > 1 )
		{
			fprintf(out, "PERMUTATION       3 1 2\n");
			fprintf(out, "GRID              %d % 6d % 6d\n", lgrid, hgrid, kgrid);
				}
	else
		if ( hgrid == 1 )
		{
			fprintf(out, "PERMUTATION  	3 2 1\n");
			fprintf(out, "GRID         	%d % 6d % 6d\n", lgrid, kgrid, hgrid);
				}
	else
		if ( kgrid == 1 )
		{
			fprintf(out, "PERMUTATION  	3 1 2\n");
			fprintf(out, "GRID         	%d % 6d % 6d\n", lgrid, hgrid, kgrid);
				}
	else
		if ( lgrid == 1 )
		{
			fprintf(out, "PERMUTATION  	1 2 3\n");
			fprintf(out, "GRID         	%d % 6d % 6d\n", hgrid, kgrid, lgrid);
				}
	else
		{
			fprintf(stderr, "\n\n\033[31m\033[1mGRID selection failure. This shouldn't have happened. PANIC.\033[0m\n\n");
			exit( 1 );
					}
					
	if ( HAVE_PGPLOT == YES )
		{
			fprintf( out, "\n#\n# Graphics support and options.\n#\n");
			fprintf( out, "PSOUT\n");
			fprintf( out, "GRACYCLES    	%d\n", (int)(2621440 / (0.50 * hgrid * kgrid * lgrid)) > 1 ? 
					(int)(2621440 / (0.50 * hgrid * kgrid * lgrid)) : 2 );
			fprintf( out, "GRATWOWINDOWS\n");
				}
	

	/* Too much ? */
	/* 
	fprintf( out, "VERBOSE\n");
	*/	




	/*********************************************************************************************************************************/
	/**  Finally, write out reflection records											**/
	/*********************************************************************************************************************************/
	printf(" - Second (final) pass for output.\n");
	rewind(in);
	fgets( line, 299, in );
	obs = 0;
	fprintf( out, "\n#\n# Reflection records follow\n#\n");
	fprintf( out, "REFLECTIONS\n");
	if ( items == 5 )
		{
		while ( fscanf( in, "%d %d %d %f %f", &ht, &kt, &lt, &q1, &q2) == 5 )
			{
			fprintf( out, " % 5d % 5d % 5d   % 15.5f % 15.5f\n", ht, kt, lt, q1, q2 );
			obs++;
			}
		}
	else
		if ( items == 6 )
			{
			while ( fscanf( in, "%d %d %d %f %f %f", &ht, &kt, &lt, &q1, &q2, &q3) == 6 )
				{
				fprintf( out, " % 5d % 5d % 5d   % 15.5f % 15.5f % 15.5f\n", ht, kt, lt, q1, q2, q3 );
				obs++;
				}
			}
	else
		if ( items == 7 )
			{
			while ( fscanf( in, "%d %d %d %f %f %f %f", &ht, &kt, &lt, &q1, &q2, &q3, &q4) == 7 )
				{
				fprintf( out, " % 5d % 5d % 5d   % 15.5f % 15.5f % 15.5f % 15.5f\n", ht, kt, lt, q1, q2, q3, q4 );
				obs++;
				}
			}
	else
		{
			fprintf(stderr, "\n\n\033[31m\033[1mNumber of items outside range. This shouldn't have happened. PANIC.\033[0m\n\n");
			exit( 1 );
					}
	printf(" - %d reflections matched and output.\n", obs );
	
	



	/**************************************************************************************************************************/
	/**   If two pairs of measurements, and have graphics, do a normal probability plot                                      **/
	/**************************************************************************************************************************/
	if ( items == 7 && HAVE_FOM == NO && HAVE_PGPLOT == YES )
		normprob( in );
		
	
	
	
	printf("\033[36m___________________________________________________________________________________________________________________________\033[0m\n\n");
	fclose( in );
	fclose(out);		
	
	argc = 2;
	argv[1] = "MAXENT_AUTO.IN";
	
	}
	else
		fclose(in);
		
						




	/*********************************************************************************************************************************/
	/**  All processing of mtz and AUTO labelled is finished. We now have a keyworded input file to work with 			**/
	/*********************************************************************************************************************************/
	/**************************************************************************************************************************/
	/**   Now we are ready for business as usual 		                                                                 **/
	/**************************************************************************************************************************/



	ini_lambda = -1.0;
	verbose    = NO;
	con_lambda = NO;
	extend 	   = NO;
	grid_x	   = 0;
	iuvw[0]    = -1;
	cell[0]	   = 0.0;
	spacegroup = 0;
	verbose    = NO;
	extend     = NO;
	transform  = NO;
	PATTERSON  = NO;
	HAVE_FOM   = NO;
	SQRT_SIGMA = -1.0;
	AVER_SIGMA = -1.0;
	SCALE_FOM  = -1.0;
	MAX_FOM    = -1.0;
	MIN_FOM    = -1.0;
	TARGET_CHI = -1.0;
	ORIGIN_REMOVED 	= NO;
	GRAPH_INTER	= 10;
	GRAPH_SECTION 	= 0.00;
	GRAPH_WAIT	= NO;
	DO_PLOT	   	= NO;	
	GRAYSCALE 	= NO;
	KEEPCONV 	= NO;
	chi_limit	= 10.0;
	WILL_TEST 	= NO;
	DIFF_PATTERSON  = NO;
	exclusion_limit = -1.0;
	DO_REJECT = NO;
	LIMIT_SIGMA 	= -1.0;
	excl_fom 	= -1.0;
	MAX_GRCONT 	= -1;
	VT125		= NO;
	
	
	if ( HAVE_CCP4 == YES )
		MAP_FORMAT = CCP4_MAP;
	else
		MAP_FORMAT = ASCII_MAP;
		
	
	if ( argc == 1 )
		in = fopen("MAXENT.DAT", "r" );
	else
		in = fopen(argv[1], "r" ); 
	
	if ( in == NULL )
		{
			fprintf(stderr, "\n\n\033[31m\033[1mCan not open input file. Abort.\033[0m\n\n");
			exit(1);
		}


	/* You never know */
	for ( i=0 ; i < 200 ; i++ )
		if ( ( c = getc( in )) == EOF || isascii(c) == 0 )
			break;
	
	rewind(in);
	if ( i != 200 && c != EOF )
		fprintf(stderr, "\n\n\033[31m\033[1mThe input file must be a formatted (ASCII) file, but non-ASCII characters are present. Beware.\033[0m\n\n");
							
	

	
	/*********************************************************************************************************************************/
	/** This is one of the worst ways to read input (string-wise instead on line-wise)					 	**/
	/*********************************************************************************************************************************/
	/*********************************************************************************************************************************/
	/**  KEYWORDS AND FLAGS AND PARAMETERS 												**/
	/*********************************************************************************************************************************/
	nof_unknown = 0;
	while ( fscanf( in, "%s", &string[0] ) != EOF )
		{
			for ( i=0 ; i < 4 ; i++ )
				string[i] = toupper( string[i] );
				
			if ( strncasecmp( &string[0], "GRID", 4) == 0 )
				{
				if ( fscanf( in, "%d %d %d", &grid_y, &grid_x, &grid_z ) != 3 )
				{
					fprintf(stderr, "\033[31m\033[1mMalformed keyword (%s).\033[0m\n", &string[0] );
					exit(1);
							}
				else
				printf("\033[32mKeyword % 16s : Grid set to % 5d % 5d % 5d\033[0m\n", &string[0], grid_y, grid_x, grid_z );
					}
			else
			if ( strncasecmp( &string[0], "CELL", 4) == 0 )
				{ if ( fscanf( in, "%f %f %f %f %f %f", &cell[0], &cell[1], &cell[2], &cell[3], &cell[4], &cell[5] ) != 6 )
					{
					fprintf(stderr, "\033[31m\033[1mMalformed keyword (%s).\033[0m\n", &string[0] );
					exit(1);
							}				
				else
				printf("\033[32mKeyword % 16s : Cell dimensions set to %6.2f %6.2f %6.2f %6.2f %6.2f %6.2f\033[0m\n", 
					&string[0], cell[0], cell[1], cell[2], cell[3], cell[4], cell[5]  );
				}
			else
			if ( strncasecmp( &string[0], "PERM", 4) == 0 )
				{
				if ( fscanf( in, "%d %d %d", &iuvw[0], &iuvw[1], &iuvw[2] ) != 3 )
				{
					fprintf(stderr, "\033[31m\033[1mMalformed keyword (%s).\033[0m\n", &string[0] );
					exit(1);
							}			
				else
				printf("\033[32mKeyword % 16s : Permutation set to %d %d %d\033[0m\n", &string[0], 
						iuvw[0], iuvw[1], iuvw[2] );
				}
			else
			if ( strncasecmp( &string[0], "ONED", 4) == 0 )
				{
				DO_1D = YES;
				if ( fscanf( in, "%f %f %f %f", &U_1D, &V_1D, &U_1START, &V_1START ) != 4 )
				{
					fprintf(stderr, "\033[31m\033[1mMalformed keyword (%s).\033[0m\n", &string[0] );
					exit(1);
							}			
				else
				printf("\033[32mKeyword % 16s : 1D plot along [u=%d v=%d] starting from %f %f\033[0m\n", 
						&string[0], nearint(U_1D), nearint(V_1D), U_1START, V_1START );
				
				}
			else
			if ( strncasecmp( &string[0], "PHAS", 4) == 0 )
				{
				if ( fscanf( in, "%f", &FOM_PHASELESS ) != 1 )
				{
					fprintf(stderr, "\033[31m\033[1mMalformed keyword (%s).\033[0m\n", &string[0] );
					exit(1);
							}			
				else
				{
				PHASELESS = YES;
				printf("\033[32mKeyword % 16s : Reflections with FOM less than %5.3f will be treated as phase-less.\033[0m\n", 
									&string[0], FOM_PHASELESS );
				}
				}

			else
			if ( strncasecmp( &string[0], "EXFO", 4) == 0 )
				{
				if ( fscanf( in, "%f", &excl_fom ) != 1 )
				{
					fprintf(stderr, "\033[31m\033[1mMalformed keyword (%s).\033[0m\n", &string[0] );
					exit(1);
							}			
				else
				printf("\033[32mKeyword % 16s : Reflections with FOM less than %5.3f will be rejected.\033[0m\n", 
									&string[0], excl_fom );
				}

			else
			if ( strncasecmp( &string[0], "SWIT", 4) == 0 )
				{
				if ( fscanf( in, "%f", &SWITCH ) != 1 )
				{
					fprintf(stderr, "\033[31m\033[1mMalformed keyword (%s).\033[0m\n", &string[0] );
					exit(1);
							}			
				else
				{
				if ( SWITCH >= 1.0 || SWITCH <= 0.0 )
					SWITCH = -1.0;
				else
				{
				printf("\033[32mKeyword % 16s : After reaching an R-factor=%4.2f the calculation will proceed in phase-less mode.\033[0m\n", 
									&string[0], SWITCH );
				}
				}
				}

			else
			if ( strncasecmp( &string[0], "VERB", 4) == 0 )
				{
					long ffpos;
					
					ffpos = ftell( in );
					if ( fscanf( in, "%d", &VERB_INTERVAL ) != 1 )
						{
						fseek( in, ffpos, SEEK_SET);
						
						verbose = YES;
						printf("\033[32mKeyword % 16s : verbose mode set.\033[0m\n", &string[0]);
						}
					else
						{
						if ( VERB_INTERVAL > 0 )
							printf("\033[32mKeyword % 16s : info written out every %d cycles.\033[0m\n", &string[0], VERB_INTERVAL);					
						else
							{
							fprintf(stderr, "\033[31m\033[1mUnexpected argument to VERB (%d).\033[0m\n", VERB_INTERVAL );
							VERB_INTERVAL = -1;
							}
						}
						}
			else
			if ( strncasecmp( &string[0], "VT12", 4) == 0 )
				{
				if ( HAVE_PGPLOT == NO )
					fprintf(stderr, "\033[31m\033[1mKeyword % 16s given, but PGPLOT not defined.\033[0m\n", &string[0] );
				else
				{
					VT125 = YES;
					DO_PLOT = YES;
					printf("\033[32mKeyword % 16s : well done, ReGIS selected.\033[0m\n", &string[0]);
					}
						}
			else
			if ( strncasecmp( &string[0], "SHOW", 4) == 0 )
				{
					SHOW_ENTROPY = YES;
					printf("\033[32mKeyword % 16s : entropy value will be calculated.\033[0m\n", &string[0]);
						}
			else
			if ( strncasecmp( &string[0], "REJE", 4) == 0 )
				{
				
				
					/* If REJECT specified, open REJECT.HKL and read and store relection indeces for later use */
				
					DO_REJECT = YES;
					rej = fopen( "REJECT.HKL", "r");
					if ( rej == NULL )
						{
						fprintf(stderr, "\033[31m\033[1mKeyword REJEect specified, but file REJECT.HKL can not be opened.\033[0m\n");
						DO_REJECT = NO;
						}
					else
					{
					nof_rej = 0;
					while( fgets( line, 299, rej ) != NULL )
					{
					if ( sscanf( line, "%d %d %d", &brejected[0][nof_rej], &brejected[1][nof_rej], &brejected[2][nof_rej]) == 3 )
						nof_rej++;
					else
						fprintf(stderr, "\033[31m\033[1mProblem with reflection record in REJECT.HKL.\033[0m\n");
							
					}	
					fclose(rej);				
					printf("\033[32mKeyword % 16s : %d reflections specified in REJECT.HKL.\033[0m\n", &string[0], nof_rej );
					}
						}
			else		
			if ( strncasecmp( &string[0], "REMO", 4) == 0 )
				{
				ORIGIN_REMOVED = YES;
				printf("\033[32mKeyword % 16s : Origin-removed Patterson function.\033[0m\n", &string[0]);
				}
			else
			if ( strncasecmp( &string[0], "PRIO", 4) == 0 )
				{
				MAKE_NONUNIFORM = YES;
				if ( fscanf( in, "%f", &PEAK_BACKGROUND ) != 1 )
				{
					fprintf(stderr, "\033[31m\033[1mMalformed keyword (%s).\033[0m\n", &string[0] );
					exit(1);
							}				
				else
				printf("\033[32mKeyword % 16s : Non-uniform prior for Patterson function. Peak/background ratio set.\033[0m\n", &string[0]);
				
				if ( PEAK_BACKGROUND >= 0.990 || PEAK_BACKGROUND < 0.0 )
					PEAK_BACKGROUND = -1.0;
				}
			else
			if ( strncasecmp( &string[0], "SQRT", 4) == 0 )
				{
				if ( fscanf( in, "%f", &SQRT_SIGMA ) != 1 )
				{
					fprintf(stderr, "\033[31m\033[1mMalformed keyword (%s).\033[0m\n", &string[0] );
					exit(1);
							}				
				else
				printf("\033[32mKeyword % 16s : sigma(F)=%4.2f*SQRT(F).\033[0m\n", &string[0], SQRT_SIGMA);
				}

			else
			if ( strncasecmp( &string[0], "GRAL", 4) == 0 )
				{
				if ( fscanf( in, "%f", &CONTOUR_LEVEL ) != 1 )
				{
					fprintf(stderr, "\033[31m\033[1mMalformed keyword (%s).\033[0m\n", &string[0] );
					exit(1);
							}
				else
				if ( HAVE_PGPLOT == NO )
					fprintf(stderr, "\033[31m\033[1mKeyword % 16s given, but PGPLOT not defined.\033[0m\n", &string[0] );				
				else
				{
				if ( CONTOUR_LEVEL < 0.0010 || CONTOUR_LEVEL > 1000.0 )
					{
						fprintf(stderr, "\033[31m\033[1mArgument of GRALevel (%f) outside range. Set to 0.50.\033[0m\n", CONTOUR_LEVEL);
						CONTOUR_LEVEL = 0.5000;
									}
				else
					printf("\033[32mKeyword % 16s : contouring interval set to %f rmsd.\033[0m\n", &string[0], CONTOUR_LEVEL);
				}
				}

			else
			if ( strncasecmp( &string[0], "GRAF", 4) == 0 )
				{
				if ( fscanf( in, "%f", &FIRST_CONTOUR ) != 1 )
				{
					fprintf(stderr, "\033[31m\033[1mMalformed keyword (%s).\033[0m\n", &string[0] );
					exit(1);
							}
				else				
				if ( HAVE_PGPLOT == NO )
					fprintf(stderr, "\033[31m\033[1mKeyword % 16s given, but PGPLOT not defined.\033[0m\n", &string[0] );
				else
				{
				if ( FIRST_CONTOUR < -100.000 || FIRST_CONTOUR > 100.0 )
					{
						fprintf(stderr, "\033[31m\033[1mArgument of GRAFirst (%f) outside range. Set to 0.00\033[0m\n", FIRST_CONTOUR);
						FIRST_CONTOUR = 0.00000;
									}
				else
					printf("\033[32mKeyword % 16s : first contour at mean + %f rmsd.\033[0m\n", &string[0], FIRST_CONTOUR);
				}
				}

			else
			if ( strncasecmp( &string[0], "GRAM", 4) == 0 )
				{
				if ( fscanf( in, "%d", &MAX_GRCONT ) != 1 )
				{
					fprintf(stderr, "\033[31m\033[1mMalformed keyword (%s).\033[0m\n", &string[0] );
					exit(1);
							}
				else				
				if ( HAVE_PGPLOT == NO )
					fprintf(stderr, "\033[31m\033[1mKeyword % 16s given, but PGPLOT not defined.\033[0m\n", &string[0] );
				else
				{
				if ( MAX_GRCONT < 5 )
					{
						fprintf(stderr, "\033[31m\033[1mArgument of GRAMaxcontour (%d) outside range. Set to 5.\033[0m\n", MAX_GRCONT);
						MAX_GRCONT = 5;
									}
				else
					printf("\033[32mKeyword % 16s : no more that %d contours drawn.\033[0m\n", &string[0], MAX_GRCONT);
				}
				}

			else
			if ( strncasecmp( &string[0], "LIMI", 4) == 0 )
				{
				if ( fscanf( in, "%f", &LIMIT_SIGMA ) != 1 )
				{
					fprintf(stderr, "\033[31m\033[1mMalformed keyword (%s).\033[0m\n", &string[0] );
					exit(1);
							}				
				else
				printf("\033[32mKeyword % 16s : exclude reflections with |F|/sig(|F|)<%f.\033[0m\n", &string[0], LIMIT_SIGMA);
				}
			else
			if ( strncasecmp( &string[0], "TIME", 4) == 0 )
				{
				if ( fscanf( in, "%d", &HAVE_TIME ) != 1 )
				{
					fprintf(stderr, "\033[31m\033[1mMalformed keyword (%s).\033[0m\n", &string[0] );
					exit(1);
							}				
				else
				{
				if ( HAVE_TIME < 0 )
					{
						HAVE_TIME = 0;
						fprintf(stderr, "\033[31m\033[1mMalformed keyword (%s).\033[0m\n", &string[0] );
						}
				else
				{
				printf("\033[32mKeyword % 16s : time-out limit set to %d minutes.\033[0m\n", &string[0], HAVE_TIME);
				HAVE_TIME *= 60;
				}
				}
				}
			else
			if ( strncasecmp( &string[0], "CHIL", 4) == 0 )
				{
				if ( fscanf( in, "%f", &chi_limit ) != 1 )
				{
					fprintf(stderr, "\033[31m\033[1mMalformed keyword (%s).\033[0m\n", &string[0] );
					exit(1);
							}				
				else
				printf("\033[32mKeyword % 16s : limit for monitoring reflection contribution to chi^2 is set to %f.\033[0m\n", &string[0], chi_limit);
				}


			else
			if ( strncasecmp( &string[0], "F000", 4) == 0 )
				{
				if ( fscanf( in, "%f", &CON ) != 1 )
				{
					fprintf(stderr, "\033[31m\033[1mMalformed keyword (%s).\033[0m\n", &string[0] );
					exit(1);
							}				
				else
				{
				CON = fabs(CON);
				HAVE_F000 = YES;
				printf("\033[32mKeyword % 16s : F000 known and set to %f.\033[0m\n", &string[0], CON);
				}
				}

			else
			if ( strncasecmp( &string[0], "EXCL", 4) == 0 )
				{
				if ( fscanf( in, "%f", &exclusion_limit ) != 1 )
				{
					fprintf(stderr, "\033[31m\033[1mMalformed keyword (%s).\033[0m\n", &string[0] );
					exit(1);
							}				
				else
				printf("\033[32mKeyword % 16s : limit for FPH-FP differences set to %f.\033[0m\n", &string[0], exclusion_limit);
				}
			else
			if ( strncasecmp( &string[0], "GRAC", 4) == 0 )
				{
				if ( fscanf( in, "%d", &GRAPH_INTER ) != 1 )
				{
					fprintf(stderr, "\033[31m\033[1mMalformed keyword (%s).\033[0m\n", &string[0] );
					exit(1);
							}				
				else
				if ( HAVE_PGPLOT == NO )
					fprintf(stderr, "\033[31m\033[1mKeyword % 16s given, but PGPLOT not defined.\033[0m\n", &string[0] );
				else
				{
				printf("\033[32mKeyword % 16s : Plot every %d cycles.\033[0m\n", &string[0], GRAPH_INTER);
				DO_PLOT = YES;
				}
				}
			else
			if ( strncasecmp( &string[0], "GRAG", 4) == 0 )
				{
				if ( HAVE_PGPLOT == NO )
					fprintf(stderr, "\033[31m\033[1mKeyword % 16s given, but PGPLOT not defined.\033[0m\n", &string[0] );
				else
				{
				printf("\033[32mKeyword % 16s : Plot grayscale representation.\033[0m\n", &string[0]);
				GRAYSCALE = YES;
				}
				}

			else
			if ( strncasecmp( &string[0], "PSOU", 4) == 0 )
				{
				if ( HAVE_PGPLOT == NO )
					fprintf(stderr, "\033[31m\033[1mKeyword % 16s given, but PGPLOT not defined.\033[0m\n", &string[0] );
				else
				{
				printf("\033[32mKeyword % 16s : Will write out postscript files containing the map sections.\033[0m\n", &string[0]);
				MAKE_PS = YES;
				}
				}
			else
			if ( strncasecmp( &string[0], "ZERO", 4) == 0 )
				{
				if ( HAVE_PGPLOT == NO )
					fprintf(stderr, "\033[31m\033[1mKeyword % 16s given, but PGPLOT not defined.\033[0m\n", &string[0] );
				else
				{
				printf("\033[32mKeyword % 16s : Plot low density areas when iteration diverges.\033[0m\n", &string[0]);
				DO_PLOT_ZEROED = YES;
				}
				}
			else
			if ( strncasecmp( &string[0], "GRAT", 4) == 0 )
				{
				if ( HAVE_PGPLOT == NO )
					fprintf(stderr, "\033[31m\033[1mKeyword % 16s given, but PGPLOT not defined.\033[0m\n", &string[0] );
				else
				{
				printf("\033[32mKeyword % 16s : Will keep conventional map plot.\033[0m\n", &string[0]);
				KEEPCONV = YES;
				}
				}


			else
			if ( strncasecmp( &string[0], "GRAW", 4) == 0 )
				{
				GRAPH_WAIT = YES;
				if ( HAVE_PGPLOT == NO )
					fprintf(stderr, "\033[31m\033[1mKeyword % 16s given, but PGPLOT not defined.\033[0m\n", &string[0] );
				else
				{
				printf("\033[32mKeyword % 16s : Wait after each plot.\033[0m\n", &string[0]);
				DO_PLOT = YES;
				}
				
				}
			else
			if ( strncasecmp( &string[0], "GRAS", 4) == 0 )
				{
				if ( fscanf( in, "%f", &GRAPH_SECTION ) != 1 )
				{
					fprintf(stderr, "\033[31m\033[1mMalformed keyword (%s).\033[0m\n", &string[0] );
					exit(1);
							}				
				else
				if ( HAVE_PGPLOT == NO )
					fprintf(stderr, "\033[31m\033[1mKeyword % 16s given, but PGPLOT not defined.\033[0m\n", &string[0] );
				else
				{
				printf("\033[32mKeyword % 16s : Plot section %f (fractional coordinates).\033[0m\n", &string[0], GRAPH_SECTION);
				DO_PLOT = YES;
				}
				
				}

			else
			if ( strncasecmp( &string[0], "GRAN", 4) == 0 )
				{
				if ( fscanf( in, "%d", &NOF_SECTIONS_TO_PLOT ) != 1 )
				{
					fprintf(stderr, "\033[31m\033[1mMalformed keyword (%s).\033[0m\n", &string[0] );
					exit(1);
							}				
				else
				if ( HAVE_PGPLOT == NO )
					fprintf(stderr, "\033[31m\033[1mKeyword % 16s given, but PGPLOT not defined.\033[0m\n", &string[0] );
				else
				{
				if ( NOF_SECTIONS_TO_PLOT < 1 )
					{
						fprintf(stderr, "\033[31m\033[1mArgument of GRANsections (%d) outside range. Set to 1.\033[0m\n", NOF_SECTIONS_TO_PLOT);
						NOF_SECTIONS_TO_PLOT = 0;
									}
				else
					{
					printf("\033[32mKeyword % 16s : Stack of %d sections will be plotted.\033[0m\n", &string[0], NOF_SECTIONS_TO_PLOT);
					DO_PLOT = YES;
					NOF_SECTIONS_TO_PLOT -= 1;
					}
				}
				
				}



			else
			if ( strncasecmp( &string[0], "TARG", 4) == 0 )
				{
				if ( fscanf( in, "%f", &TARGET_CHI ) != 1 )
				{
					fprintf(stderr, "\033[31m\033[1mMalformed keyword (%s).\033[0m\n", &string[0] );
					exit(1);
							}				
				else
				printf("\033[32mKeyword % 16s : target value for chi^2 set to %5.2f\033[0m\n", &string[0], TARGET_CHI);
				}

			else
			if ( strncasecmp( &string[0], "SCAL", 4) == 0 )
				{
				if ( fscanf( in, "%f", &GLOBAL_SCALE ) != 1 )
				{
					fprintf(stderr, "\033[31m\033[1mMalformed keyword (%s).\033[0m\n", &string[0] );
					exit(1);
							}				
				else
				printf("\033[32mKeyword % 16s : data will be multiplied by %5.2f\033[0m\n", &string[0], GLOBAL_SCALE);
				}


			else
			if ( strncasecmp( &string[0], "AVER", 4) == 0 )
				{
				if ( fscanf( in, "%f", &AVER_SIGMA ) != 1 )
				{
					fprintf(stderr, "\033[31m\033[1mMalformed keyword (%s).\033[0m\n", &string[0] );
					exit(1);
							}				
				else
				printf("\033[32mKeyword % 16s : sigma(F)=%5.2f for every F.\033[0m\n", &string[0], AVER_SIGMA);
				}
			else
			if ( strncasecmp( &string[0], "KFOM", 4) == 0 )
				{
				if ( fscanf( in, "%f", &SCALE_FOM ) != 1 )
				{
					fprintf(stderr, "\033[31m\033[1mMalformed keyword (%s).\033[0m\n", &string[0] );
					exit(1);
							}				
				else	
				printf("\033[32mKeyword % 16s : FOMs will be multiplied by %5.2f.\033[0m\n", &string[0], SCALE_FOM);
				}

			else
			if ( strncasecmp( &string[0], "MAP", 3) == 0 )
				{

	/*********************************************************************************************************************************/
	/**  Map keyword. ASCII is the default												**/
	/*********************************************************************************************************************************/
				if ( fscanf( in, "%s", &jchar[0] ) != 1 )
				{
					fprintf(stderr, "\033[31m\033[1mMalformed keyword (%s).\033[0m\n", &string[0] );
					exit(1);
							}				
				else
				if ( jchar[0] == 'C' || jchar[0] == 'c' )
					{
						if ( HAVE_CCP4 == NO )
						{
						fprintf(stderr, "\033[31m\033[1mCCP4 map selected, but program compiled without CCP4 support. na4 set.\033[0m\n");
						MAP_FORMAT = NA4_MAP;
						}
						else
						{						
						MAP_FORMAT = CCP4_MAP;
						printf("\033[32mKeyword % 16s : CCP4 map file selected.\033[0m\n", &string[0]);
						}
							}
				else
				if ( jchar[0] == 'N' || jchar[0] == 'n' )
					{
						MAP_FORMAT = NA4_MAP;
						printf("\033[32mKeyword % 16s : na4 map file selected.\033[0m\n", &string[0]);
							}
				else
				if ( jchar[0] == 'A' || jchar[0] == 'a' )
					{
						MAP_FORMAT = ASCII_MAP;
						printf("\033[32mKeyword % 16s : ascii map file selected.\033[0m\n", &string[0]);
							}
				else
					{
						MAP_FORMAT = ASCII_MAP;
						fprintf(stderr, "\033[31m\033[1mUnknown map format selection. Using ASCII map format.\033[0m\n" );
						}
				}
			else
			if ( strncasecmp( &string[0], "MAXF", 4) == 0 )
				{
				if ( fscanf( in, "%f", &MAX_FOM ) != 1 )
				{
					fprintf(stderr, "\033[31m\033[1mMalformed keyword (%s).\033[0m\n", &string[0] );
					exit(1);
							}				
				else
				printf("\033[32mKeyword % 16s : maximum FOM value set to %5.3f.\033[0m\n", &string[0], MAX_FOM);
				}
			else
			if ( strncasecmp( &string[0], "MINF", 4) == 0 )
				{
				if ( fscanf( in, "%f", &MIN_FOM ) != 1 )
				{
					fprintf(stderr, "\033[31m\033[1mMalformed keyword (%s).\033[0m\n", &string[0] );
					exit(1);
							}				
				else
				printf("\033[32mKeyword % 16s : minimum FOM value set to %5.3f.\033[0m\n", &string[0], MIN_FOM);
				}
			else
			if ( strncasecmp( &string[0], "SPAC", 4) == 0 )
				{
				if ( fscanf( in, "%d", &spacegroup ) != 1 )
				{
					fprintf(stderr, "\033[31m\033[1mMalformed keyword (%s).\033[0m\n", &string[0] );
					exit(1);
							}
				else
				printf("\033[32mKeyword % 16s : space group number set to %d\033[0m\n", &string[0],spacegroup );
				}
			else
			if ( strncasecmp( &string[0], "LAMB", 4) == 0 )
				{
				if ( fscanf( in, "%f", &val ) != 1 )
				{
					fprintf(stderr, "\033[31m\033[1mMalformed keyword (%s).\033[0m\n", &string[0] );
					exit(1);
							}
				else
				{
				ini_lambda = (double)(val);
				printf("\033[32mKeyword % 16s : initial value for lambda set to %f\033[0m\n", &string[0], ini_lambda );
				}
				}
			else
                        if ( strncasecmp( &string[0], "CONS", 4) == 0 )
				{
				con_lambda = YES;
				printf("\033[32mKeyword % 16s : constant lambda run.\033[0m\n", &string[0]);
					}
			else	
                        if ( strncasecmp( &string[0], "TRAN", 4) == 0 )
				{
				transform = YES;
				printf("\033[32mKeyword % 16s : modulus of transform written.\033[0m\n", &string[0]);
				}
			else
                        if ( strncasecmp( &string[0], "EXTE", 4) == 0 )
				{
				extend = YES;
				printf("\033[32mKeyword % 16s : phase replacement run.\033[0m\n", &string[0]);
				}
			else	
                        if ( strncasecmp( &string[0], "PATT", 4) == 0 )
				{
				PATTERSON = YES;	
				if ( DIFF_PATTERSON == YES )
					{
						fprintf(stderr, "\n\n\033[31m\033[1mFlags PATTerson and DIFF_Patterson are mutually exclusive.\033[0m\n\n");
						exit(1);
							}
				printf("\033[32mKeyword % 16s : Patterson map run [h k l F sig(F)].\033[0m\n", &string[0]);
				}

			else	
                        if ( strncasecmp( &string[0], "DIFF", 4) == 0 )
				{
				DIFF_PATTERSON = YES;				
				if ( PATTERSON == YES )
					{
						fprintf(stderr, "\n\n\033[31m\033[1mFlags PATTerson and DIFF_Patterson are mutually exclusive.\033[0m\n\n");
						exit(1);
							}
				printf("\033[32mKeyword % 16s : Difference Patterson map run [h k l FP sig(FP) FPH sig(FPH)].\033[0m\n", &string[0]);
				}

			else
                        if ( strncasecmp( &string[0], "FOM", 3) == 0 )
				{
				HAVE_FOM = YES;				
				printf("\033[32mKeyword % 16s : foms available [h k l F sig(F) phi fom]\033[0m\n", &string[0]);
				}
			else
                        if ( strncasecmp( &string[0], "REFL", 4) == 0 )
				{


	/*********************************************************************************************************************************/
	/**  Reflection records interpretation											 	**/
	/*********************************************************************************************************************************/

					printf("\033[32mKeyword % 16s : start reading reflections.\033[0m\n", &string[0]);		

					for ( i=0 ; i < MAX_NOF_REFL ; i++ )
						refl[i][4] = 0.0;		
						
									
					average_F = 0.0;
					obs = 0;
					abs_hmax = 0;
					abs_kmax = 0;
					abs_lmax = 0;

					verbose_flag_1 = NO;
					

							/* For all in file ... */
					while( 1 )
					{
					if ( fscanf( in, "%f %f %f", &h, &k, &l ) != 3 )
						break;
					
									
					if ( abs( h ) > abs_hmax )
						abs_hmax = abs(h);
					if ( abs( k ) > abs_kmax )
						abs_kmax = abs(k);
					if ( abs( l ) > abs_lmax )
						abs_lmax = abs(l);
					

					
								/* Check whether it has to be rejected (file REJECT.HKL) */
					SKIP = NO;
					if ( DO_REJECT == YES )
						{
						for (i=0 ; i < nof_rej ; i++ )
							if ( nearint(h)==brejected[0][i] &&
							     nearint(k)==brejected[1][i] &&
							     nearint(l)==brejected[2][i])
							     {
							     printf("\033[33mReflection rejected : % 5d % 5d % 5d\033[0m\n", 
							     nearint(h), nearint(k), nearint(l) );
							     fgets( line, 299, in );
							     SKIP = YES;
							     obs--;
							     }
								}
					if ( fgets( line, 299, in ) == NULL )
						break;
						
	/*********************************************************************************************************************************/
	/**  Start with each of the various possible formats. 										**/
	/*********************************************************************************************************************************/



					if ( PATTERSON == YES && SKIP == NO)
						{
							if ( (i=sscanf( line, "%f %f",&F,&sigF )) == 2 )
								;
							else
								{
									fprintf(stderr, "\n\033[31m\033[1mProblem with reflection record number %d. Abort.\033[0m\n", obs+1);
									exit(1);
										}
							
							F = fabs(F);
							refl[obs][0] = h;
							refl[obs][1] = k;
							refl[obs][2] = l;
							refl[obs][3] = F*F;
							if ( SQRT_SIGMA > 0.0 )
								refl[obs][4] = SQRT_SIGMA*sqrt( refl[obs][3] );
							else if ( AVER_SIGMA > 0.0 )
								refl[obs][4] = AVER_SIGMA;
							else
								refl[obs][4] = 2.0*F*sigF + sigF*sigF;
							refl[obs][5] = 0.0000;
							
							if ( OVERFIT == YES && refl[obs][3]/refl[obs][4] > 2.0 )
								more_than_2sigma++;
							
							average_F += F*F;
										}
					else

					if ( DIFF_PATTERSON == YES && SKIP == NO )
						{
							if ( (i=sscanf( line, "%f %f %f %f",&F,&sigF,&fph, &sigfph )) == 4 )
								;
							else
								{
									fprintf(stderr, "\n\033[31m\033[1mProblem with reflection record number %d. Abort.\033[0m\n", obs+1);
									exit(1);
										}
							fph = fabs( fph );
							F   = fabs( F );
							if ( exclusion_limit > 0.0 && fabs( fph - F ) >= exclusion_limit )
							{
							obs--;
							printf("\033[33mLarge difference (excluded) : % 5d % 5d % 5d % 15.5f % 15.5f\033[0m\n",
								nearint(h),nearint(k),nearint(l),F,fph );
							}
							else
							{							
							refl[obs][0] = h;
							refl[obs][1] = k;
							refl[obs][2] = l;
							refl[obs][3] = (F-fph)*(F-fph);
							if ( SQRT_SIGMA > 0.0 )
								refl[obs][4] = SQRT_SIGMA*sqrt( refl[obs][3] );
							else if ( AVER_SIGMA > 0.0 )
								refl[obs][4] = AVER_SIGMA;
							else
								refl[obs][4] = 2.0*fabs( fph - F )*sqrt(sigF*sigF+sigfph*sigfph) + (sigF*sigF+sigfph*sigfph);
							refl[obs][5] = 0.0000;
							
							if ( OVERFIT == YES && refl[obs][3]/refl[obs][4] > 2.0 )
								more_than_2sigma++;
							
							average_F += refl[obs][3];
							}
										}
					else

					if ( HAVE_FOM == YES && SKIP == NO )
						{
							if ( (i=sscanf( line, "%f %f %f %f", &F,&sigF,&phi,&fom )) == 4 )
								;
							else
								{
									fprintf(stderr, "\n\033[31m\033[1mProblem with reflection record number %d. Abort.\033[0m\n", obs+1);
									exit(1);
										}
							
							if ( excl_fom > 0.0 && fom < excl_fom )
								{
									obs--;
									excluded_due_to_fom++;
									if ( verbose == YES )
										printf("\033[33mLow fom (excluded) : % 5d % 5d % 5d  % 5.3f\033[0m\n",
											nearint(h),nearint(k),nearint(l),fom );
											
								}
							else
							{
							
							if ( F < 0.00 )
								{
									if ( verbose == YES )
										printf("\033[31mReflection with negative modulus. Phase angle : +180.0 degrees.\033[0m\n");
									else
									if ( verbose_flag_1 == NO )
									{
									verbose_flag_1 = YES;
									printf("\033[31mReflection with negative modulus. Phase angle : +180.0 degrees.\033[0m\n");
									printf("\033[31mFurther occurences will not be reported.\033[0m\n");
									}
									
									F = fabs(F);
									if ( phi < 0.0 )
										phi += 180.000;
									else
										phi -= 180.000;
											}
							refl[obs][0] = h;
							refl[obs][1] = k;
							refl[obs][2] = l;
							refl[obs][3] = F;
							if ( SQRT_SIGMA > 0.0 )
								refl[obs][4] = SQRT_SIGMA*sqrt( F );
							else if ( AVER_SIGMA > 0.0 )
								refl[obs][4] = AVER_SIGMA;
							else
								refl[obs][4] = sigF;
							
							if ( SCALE_FOM > 0.0 )
								fom *= SCALE_FOM;
							
							if ( MAX_FOM > 0.0 && fom > MAX_FOM )
								fom = MAX_FOM;

							if ( MIN_FOM > 0.0 && fom < MIN_FOM )
								fom = MIN_FOM;
							
							
											/* FFTW uses exp(-2PIi) for forward trans */
							
							refl[obs][5] = -1.0*phi;
							refl[obs][6] = fom;
							average_F += F;
										}
											}
					else if ( SKIP == NO )
						{
							if ( (i=sscanf( line, "%f %f %f", &F,&sigF,&phi )) == 3 )
								;
							else
								{
									fprintf(stderr, "\n\033[31m\033[1mProblem with reflection record number %d. Abort.\033[0m\n", obs+1);
									exit(1);
										}

							if ( F < 0.00 )
								{
									if ( verbose == YES )
										printf("\033[31mReflection with negative modulus. Phase angle : +180.0 degrees.\033[0m\n");
									else
									if ( verbose_flag_1 == NO )
									{
									verbose_flag_1 = YES;
									printf("\033[31mReflection with negative modulus. Phase angle : +180.0 degrees.\033[0m\n");
									printf("\033[31mFurther occurences will not be reported.\033[0m\n");
									}
								
									F = fabs(F);
									if ( phi < 0.0 )
										phi += 180.000;
									else
										phi -= 180.000;
											}

							refl[obs][0] = h;
							refl[obs][1] = k;
							refl[obs][2] = l;
							refl[obs][3] = F;
							if ( SQRT_SIGMA > 0.0 )
								refl[obs][4] = SQRT_SIGMA*sqrt( F );
							else if ( AVER_SIGMA > 0.0 )
								refl[obs][4] = AVER_SIGMA;
							else
								refl[obs][4] = sigF;

											/* FFTW uses exp(-2PIi) for forward trans */
							
							refl[obs][5] = -1.0*phi;
							average_F += F;
										}
					obs++;

					if ( obs > MAX_NOF_REFL-2 )
						{
							fprintf(stderr, "\n\n\n\033[31m\033[1mToo many reflections (limit %d). Abort.\033[0m\n\n\n", MAX_NOF_REFL);
							exit( 0 );
									}

                          		}
					
					                                            		}
			else
			{
											/* this is a comment */
			if ( string[0] == '#' || string[0] == '!' || string[0] == '*' )
				{
				char junkk;
				
				fscanf( in, "%c", &junkk);
				while ( junkk != '\n' )
					fscanf(in, "%c", &junkk);
				
				}	
			else
			{
			fprintf(stderr, "\033[31m\033[1m[1mUnknown keyword : %s[0m\033[0m\n",  &string[0]);
			nof_unknown++;
			if ( nof_unknown > 10 )
				{
					fprintf(stderr, "\n\n\n\033[31m\033[1mToo many errors. A missing (or extra) argument ? Abort.\033[0m\n\n");
					exit(1);
						}
			}
			}					
							

														}



	fclose(in);
	
	/*********************************************************************************************************************************/
	/** End of input. Start doing things											 	**/
	/*********************************************************************************************************************************/

	if ( (average_F / (float)(obs)) < 0.00001000 )
		{
			fprintf(stderr, "\n\n\033[31m\033[1mThe average value of the amplitude terms is only %f (?) Abort.\033[0m\n\n", 
					(average_F / (float)(obs)));
			exit(1);
					}

	
	if ( obs == 0 )
		{
			fprintf(stderr, "\n\n\033[31m\033[1mNo reflections found (?).\033[0m\n\n");
			exit(1);
					}
	
	
	if ( excl_fom > 0.0 && HAVE_FOM == YES )
		printf("\033[33m%d reflections rejected due to FOM cutoff (Keyword EXFOm)\033[0m\n", excluded_due_to_fom );

	average_F /= (float)(obs);


	if ( OVERFIT == YES )
		{
			if ( more_than_2sigma > (obs / 50.0) )
				TARGET_CHI = more_than_2sigma;
			else
				TARGET_CHI = obs / 50.0;


			sprintf( line, "/bin/echo \"TARGET %f\" > GR_interm1 ; /bin/cat GR_interm1 MAXENT_AUTO.IN > GR_interm2 ; \
				/bin/mv -f GR_interm2 MAXENT_AUTO.IN ; /bin/rm -rf GR_interm1", \
				TARGET_CHI );
			system( line );
			
			printf("\033[32mOverfitting data : Target value for chi^2 set to %5.2f\033[0m\n", TARGET_CHI);
					}
					
	if ( VT125 == YES && KEEPCONV == YES )
		KEEPCONV = NO;
		




	/*********************************************************************************************************************************/
	/**  Attempt for origin-removed Patterson : unsuccessful									**/
	/*********************************************************************************************************************************/
	if ( (PATTERSON == YES || DIFF_PATTERSON == YES) && ORIGIN_REMOVED == YES )
	{
	for ( i=0 ; i < obs ; i++ )
		{
		amp = refl[i][3] - average_F;
		if ( amp < 0.0 )
			refl[i][5] = 180.000000000;
		refl[i][3] = fabs( amp );
		}
	average_F = 0.0;
	for ( i=0 ; i < obs ; i++ )
		average_F += refl[i][3];
	average_F /= (float)(obs);
	}
	


	/*********************************************************************************************************************************/
	/**  Highest resolution attainable												**/
	/*********************************************************************************************************************************/

	max_res = min( cell[0] / abs_hmax, cell[1] / abs_kmax, cell[2] / abs_lmax );
	



	/*********************************************************************************************************************************/
	/** Exclude reflections with F/sigF < LIMIT										 	**/
	/*********************************************************************************************************************************/

	if ( LIMIT_SIGMA > 0.0 )
	{
	thrown = 0;
	for ( i=0 ; i < obs ; i++ )
		if ( (refl[i][3] / refl[i][4]) < LIMIT_SIGMA )
			{
				thrown++;		
				refl[i][4] = -1.0;
					}
					
	printf("\033[33m%d reflections rejected due to sigma cutoff (Keyword LIMIt)\033[0m\n", thrown );
	
	for ( n=0 ; n < thrown ; n++)
	{
	for ( i=0 ; i < obs ; i++ )
		if ( refl[i][4] < 0.0 )
			break;
	
	for ( m=i+1 ; m < obs ; m++ )
		{
			refl[m-1][0] = refl[m][0];		
			refl[m-1][1] = refl[m][1];		
			refl[m-1][2] = refl[m][2];		
			refl[m-1][3] = refl[m][3];		
			refl[m-1][4] = refl[m][4];		
			refl[m-1][5] = refl[m][5];		
			refl[m-1][6] = refl[m][6];		
							}	

	}
	
			
	obs = obs - thrown;
	
	if ( obs <= 0 )
		{
			fprintf(stderr, "\n\n\033[31m\033[1mNo reflections found (?).\033[0m\n\n");
			exit(1);
					}
					

	average_F = 0.0;
	for ( i=0 ; i < obs ; i++ )
		average_F += refl[i][3];
	average_F /= (float)(obs);
	}


						



	/**************************************************************************************************************************/
	/**   Check presence of cards                                                                                            **/
	/**************************************************************************************************************************/

	printf("\033[36m___________________________________________________________________________________________________________________________\033[0m\n\n");

		
        if ( grid_x == 0 )
                {
                        fprintf(stderr, "\n\n\n\n\033[31m\033[1m Card GRID is not present. Abort.\033[0m\n\n");
                        exit( 1 );
                                        }
        if ( iuvw[0] == -1 )
                {
                        fprintf(stderr, "\n\n\n\n\033[31m\033[1m Card PERM is not present. Abort.\033[0m\n\n");
                        exit( 1 );
                                        }
        if ( cell[0] == 0.0 )
                {
                        fprintf(stderr, "\n\n\n\n\033[31m\033[1m Card CELL is not present. Abort.\033[0m\n\n");
                        exit( 1 );
                                        }
        if ( spacegroup == 0 )
                {
                        fprintf(stderr, "\n\n\n\n\033[31m\033[1m Card SPACE GROUP is not present. Abort.\033[0m\n\n");
                        exit( 1 );
                                        }



	/**************************************************************************************************************************/
	/**   Check fast axis                                                                                                    **/
	/**************************************************************************************************************************/
	for ( i=0 ; i < obs ; i++ )
		if ( refl[i][ iuvw[0] -1 ] < 0 )
			{
				printf("\033[31mThe fast changing index must be >= 0, but found a negative. Changing hemisphere ...\033[0m\n\n\n\n");
				break;
						}
	if ( i != obs )
		{
			for ( i=0 ; i < obs ; i++ )
				if ( refl[i][ iuvw[0] -1 ] < 0 )	
					{
						refl[i][0] *= -1.00000;
						refl[i][1] *= -1.00000;
						refl[i][2] *= -1.00000;
						refl[i][5] *= -1.0;		/* don't forget to reflect phase angle */
						
										}
											}
							

	added_refl = 0;
	/**************************************************************************************************************************/
	/** Check for missing axial reflections						                                         **/
	/**************************************************************************************************************************/
	for ( i=0 ; i < obs ; i++ )
		if ( nearint(refl[i][ iuvw[0] -1 ]) == 0 )
			{
			search1 = -1.0*refl[i][ iuvw[1] -1 ];
			search2 = -1.0*refl[i][ iuvw[2] -1 ]; 
			
							
			for ( m=i+1 ; m < obs   ; m++ )
				if ( nearint(refl[m][ iuvw[0] -1 ]) == 0
				  && nearint(refl[m][ iuvw[1] -1 ]) == nearint(search1)
				  && nearint(refl[m][ iuvw[2] -1 ]) == nearint(search2) )
						break;
			
			
			if ( m == obs )
				{	
					if ( verbose == YES )
					printf("   Added reflection % +4d % +4d % +4d   % +12.3f  % +12.3f   % +6.1f \n", 
						(int)(-1.0*refl[i][0]), (int)(-1.0*refl[i][1]), 0, refl[i][3], refl[i][4], -1.0*refl[i][5] );
					refl[obs+added_refl][ iuvw[1] -1 ] = search1;
					refl[obs+added_refl][ iuvw[2] -1 ] = search2;
					refl[obs+added_refl][ iuvw[0] -1 ] = 0.0;
					refl[obs+added_refl][3] = refl[i][3];
					refl[obs+added_refl][4] = refl[i][4];
					refl[obs+added_refl][5] = -1.0*refl[i][5];
					refl[obs+added_refl][6] = refl[i][6];
					added_refl++;
					if ( obs + added_refl > MAX_NOF_REFL-2 )
						{
						fprintf(stderr, "\n\n\n\033[31m\033[1mToo many reflections (limit %d). Abort.\033[0m\n\n\n", MAX_NOF_REFL);
						exit( 0 );
								}
					
										}
											}
								
	printf("\n");								
	obs = obs + added_refl;
	axial = 2 * added_refl;







	/* This is the interval for writing out info about the calculation when not in VERBose mode */
	/* It is also the interval (in number of cycles) for checking whether we exceeded the time limitations */

	if ( verbose == NO && VERB_INTERVAL < 0 )
		VERB_INTERVAL = (int)(2621440 / (8 * grid_x * grid_y * grid_z)) > 1 ? (int)(2621440 / (8 * grid_x * grid_y * grid_z)) : 2;
		
	if ( HAVE_TIME > 0 && VERB_INTERVAL < 0 )
		VERB_INTERVAL = (int)(2621440 / (8 * grid_x * grid_y * grid_z)) > 1 ? (int)(2621440 / (8 * grid_x * grid_y * grid_z)) : 2;
	



	/**************************************************************************************************************************/
	/**   F000 related arbitrariness                                                                                         **/
	/**************************************************************************************************************************/

	if ( HAVE_F000 == YES )							/* This is not ... */
		{
										/* Square for a Patterson */		
			if ( PATTERSON == YES || DIFF_PATTERSON == YES )
				{
					CON *= CON;
					printf(" - Square F000 for Patterson calculation, F000=%f.\n", CON );
					}
				
			CON /= (float)( grid_x * grid_y * grid_z );

		}
	else
		{					

			if ( DIFF_PATTERSON == NO && PATTERSON == YES && FORCE_F000 == NO )
			{
			printf("\033[33m___________________________________________________________________________________________________________________________\n");
			printf("___________________________________________________________________________________________________________________________\n\n");
			printf(" The program will use a value for the F000 term equal to twice the maximum observed amplitude. If what you are calculating\n");
			printf(" is not a difference Patterson function, you are better off defining explicitly a reasonable F000 value (keyword : F000).\n");
			printf("___________________________________________________________________________________________________________________________\n");
			printf("___________________________________________________________________________________________________________________________\033[0m\n\n\n");
			}


										/* ... but these are */
			if ( (PATTERSON == YES || DIFF_PATTERSON == YES) && FORCE_F000 == NO )
				{
					float maxF;
					
					maxF = 0.0;				/* If Patterson, just use the largest F : (2*F)^2 */  
					for ( i=0 ; i < obs ; i++ )
						if ( refl[i][3] > maxF )
							maxF = refl[i][3];
					
					maxF *= 4.00;

					CON = maxF / ( grid_x * grid_y * grid_z );
					printf("[1m - F000 not given. Set to %f[0m\n", maxF );
					 				
							}
			else
				{						/* else, calculate F000 assuming a mean electron */
										/* density of 0.375e/A^3                          */
 					float	Vol;
 					
 										/* First a quick check on cell (never know). */
 					if ( !(cell[0] > 0.0 && cell[1] > 0.0 && cell[2] > 0.0))
 						{
 							fprintf(stderr, "\n\n\033[31m\033[1mCell dimensions less or equal to zero ? Abort.\033[0m\n\n");
 							exit(1);
 									}
					
					
					/* Cell volume (hopefully in A^3) */
					
 					Vol = cell[0]*cell[1]*cell[2]*sqrt(1.000+2.00*cos(cell[3]*PI/180.0)*cos(cell[4]*PI/180.0)*
 					      cos(cell[5]*PI/180.0)-cos(cell[3]*PI/180.0)*cos(cell[3]*PI/180.0)	
 					      -cos(cell[4]*PI/180.0)*cos(cell[4]*PI/180.0)-cos(cell[5]*PI/180.0)*cos(cell[5]*PI/180.0));						
 					

					if ( FORCE_F000 == YES )
						{
						if ( FORCE_SQUARE_F000 == NO )
						{
						
						sprintf(line, "/bin/echo \"F000 %f\" > GR_interm1 ; /bin/cat GR_interm1 MAXENT_AUTO.IN > GR_interm2 ; \
							/bin/mv -f GR_interm2 MAXENT_AUTO.IN ; /bin/rm -rf GR_interm1", \
							(0.37500 * Vol) );
						system( line );
						}
						else
						{
						sprintf(line, "/bin/echo \"F000 %f\" > GR_interm1 ; /bin/cat GR_interm1 MAXENT_AUTO.IN > GR_interm2 ; \
							/bin/mv -f GR_interm2 MAXENT_AUTO.IN ; /bin/rm -rf GR_interm1", \
							(0.37500 * Vol * 0.37500 * Vol) );
						system( line );
						
						}
						CON = (0.37500 * Vol * 0.37500 * Vol) / ( grid_x * grid_y * grid_z );
	 					printf("[1m - F000 not given. Set to %f[0m\n", (0.37500*Vol*0.37500*Vol) );
	 					}
 					else
 						{
 						CON = 0.37500 * Vol / ( grid_x * grid_y * grid_z );
	 					printf("[1m - F000 not given. Set to %f[0m\n", (0.37500*Vol) );
 						}			
	
							}
 								}
	






	/**************************************************************************************************************************/
	/**   Info                                                                                                               **/
	/**************************************************************************************************************************/


        if ( ini_lambda < 0.0 )				/* This means lambda was not defined. Will try an automatic determination */                  	
                {
			WILL_TEST = YES;
			printf(" - Trial-and-error definition of initial lambda value.\n");
						} 
	else
	        printf(" - Initial lambda is %8.3f\n", ini_lambda );

	if ( verbose == NO )
        	printf(" - Only essential information will be written out.\n");
	else
        	printf(" - Verbose output requested.\n");
	if ( con_lambda == NO )
                printf(" - Lambda linearly depended on number of cycles.\n");
	else
		printf(" - Constant lambda requested.\n");
        if ( extend == YES )
		printf(" - Phase extension requested.\n"); 
	printf(" - Grid (along fast, medium and slow) % 5d  % 5d  % 5d\n", grid_y, grid_x, grid_z );
	printf(" - Axes permutation is fast-%c, medium-%c, slow-%c \n", ('W'+iuvw[0]), ('W'+iuvw[1]), ('W'+iuvw[2]));



	printf("\n\n");




	/**************************************************************************************************************************/
	/**   Check grid ...                                                                                                     **/
	/**************************************************************************************************************************/


	if ( get_grid( grid_x - 0.10 ) != grid_x )
		{
			fprintf(stderr, "\n\n\033[31m\033[1mNumber of grid points (%d) has a large prime factor.\033[0m\n\n", grid_x);
                        exit( 1 );
						}

	if ( get_grid( grid_y - 0.10 ) != grid_y )
		{
			fprintf(stderr, "\n\n\033[31m\033[1mNumber of grid points (%d) has a large prime factor.\033[0m\n\n", grid_y);
                        exit( 1 );
						}

	if ( get_grid( grid_z - 0.10 ) != grid_z )
		{
			fprintf(stderr, "\n\n\033[31m\033[1mNumber of grid points (%d) has a large prime factor.\033[0m\n\n", grid_z);
                        exit( 1 );
						}





/*****************************************************************************************************************************************/
/** 	Quick test on how much memory we are about to grab ... 									 	**/
/*****************************************************************************************************************************************/
	mem_req = grid_z * grid_x * (grid_y+2) * 6.0 * 4.0 / ( 1024.0 * 1024.0 ); 
	if ( mem_req < 64.0 )
		{
		if ( verbose == YES )
			printf(" - Data structures require %4.1f MBytes of memory.\n", mem_req );
		}
	else
		{
		fprintf(stderr, "\033[35m - Data structures require %4.1f MBytes of memory.\033[0m\n", mem_req );	
		fprintf(stderr, "\033[35m   Stop the program now if this is not what you intended ...\033[0m\n");
		sleep(2);
		fprintf(stderr, "\033[35m   If everything comes to a halt, you will know what went wrong.\033[0m\n");
		}
		



	/**************************************************************************************************************************/
	/**   Try to allocate space                                                                                              **/
	/**************************************************************************************************************************/
	if ( verbose == YES )
		printf(" - About to allocate memory.                                  \n");

	Fobs_1   = f3tensor( 1, grid_z, 1, grid_x, 1, grid_y+2 );  	/* These routines come from the public sector of NR */
	SigF_1   = f3tensor( 1, grid_z, 1, grid_x, 1, grid_y+2 );
	PriorA_1 = f3tensor( 1, grid_z, 1, grid_x, 1, grid_y+2 );

	for ( w = 1; w <= grid_z ; w++ )
    	   for ( v = 1; v <= grid_x ; v++ )
		for ( u = 1; u <= grid_y+2 ; u++ )
			{
				  Fobs_1[w][v][u] = 0.0;
				PriorA_1[w][v][u] = 0.0;
				  SigF_1[w][v][u] = 0.0;
                                      				}


#ifdef PARALLEL

	/**************************************************************************************************************************/
	/**   FFTW's parallelisation init					                                                 **/
	/**************************************************************************************************************************/

	if ( fftw_threads_init() )
		{
			printf("\033[31m - FFTW failed to initialise threads. Abort.\033[0m\n" );
			exit(1);
					}
					
#endif



	/**************************************************************************************************************************/
	/**   FFTW's Wisdom file and plan construction. See FFTW manual for more info                                            **/
	/**************************************************************************************************************************/

	/* I bet this won't work on VMS */
	
	if ( getenv("HOME") == NULL )
		{
			printf("\033[31mHOME symbol missing : Will write FFTW's wisdom file in the current directory.\033[0m\n");
			strcpy( wisdom_name, ".FFTW_wisdom");
			wisdom = fopen( ".FFTW_wisdom", "r" );			
						}
	else
		{
			strcpy( wisdom_name, getenv("HOME") );
			strcat( wisdom_name, "/.FFTW_wisdom");
			wisdom = fopen( wisdom_name, "r" );
								}




	if ( wisdom == NULL )
		printf("\033[32m - FFTW's wisdom file not present. It will be created.\033[0m\n");
	else
		{
		if ( FFTW_FAILURE == fftw_import_wisdom_from_file( wisdom ) )
			printf("\033[31m - FFTW failed to read the wisdom file (%s). Continue without wisdom.\033[0m\n", wisdom_name );
		else
			fclose( wisdom );	
		}
		

	if ( verbose == YES )
		printf(" - FFTW is learning how to do FFTs  ...  \n");



        p    = rfftw3d_create_plan( grid_z, grid_x, grid_y, FFTW_REAL_TO_COMPLEX,  FFTW_MEASURE | FFTW_IN_PLACE | FFTW_USE_WISDOM );
        pinv = rfftw3d_create_plan( grid_z, grid_x, grid_y, FFTW_COMPLEX_TO_REAL,  FFTW_MEASURE | FFTW_IN_PLACE | FFTW_USE_WISDOM );


	if ( verbose == YES )
		{
			printf(" - FFTW learned how to do FFTs.    \n");
			printf(" - Saving FFTW's wisdom file ...    \n");
				}
	



	wisdom = fopen( wisdom_name, "w" );
	if ( wisdom == NULL )
		{
			fprintf(stderr, "\033[31m\033[1mCan not open FFTW's wisdom file (?). Abort.\033[0m\n");
			exit(1);
							}
	fftw_export_wisdom_to_file( wisdom );
	fclose( wisdom );
	
	
		
								
	/**************************************************************************************************************************/
	/**   Load onto arrays ...                                                    		                                 **/
	/**************************************************************************************************************************/


	/* This is arbitrary, and probably wrong, but you can change it */
	
	 
	if ( 	(DIFF_PATTERSON == NO && PATTERSON == NO && average_F > 1000.0 ) ||
		((DIFF_PATTERSON == YES || PATTERSON == YES ) && average_F > 1000000.0 ))
	{
	printf("\033[31m___________________________________________________________________________________________________________________________\n");
	printf("___________________________________________________________________________________________________________________________\n\n");
	printf("    The mean amplitude of the input data appears to be too large. If the data are not on an (approximate) absolute scale\n");
	printf("    and you see very sharp peaks in the MaxEnt map, then beware : the calculation you are performing may be wrong.\n");
	printf("___________________________________________________________________________________________________________________________\n");
	printf("___________________________________________________________________________________________________________________________\033[0m\n\n");
	}


	


	
	if ( verbose == YES )
		printf("     There are %d observations with <F>=%10.2f                  \n", obs, average_F);


	verbose_flag_2 = NO;
	if ( GLOBAL_SCALE > 0.0 )
		{
			for ( i=0 ; i < obs ; i++ )
				{
					refl[i][3] *= GLOBAL_SCALE;
					refl[i][4] *= GLOBAL_SCALE;
					if ( refl[i][4] < 1.0 )				/* THIS IS ARBITRARY AND WRONG. HOPEFULLY NOT */
											/* MANY REFLECTIONS WILL HAVE a sig(F) < 1.0 */
					{						/* On a second thought, I don't understand */
											/* what this line is doing here. Watch this space*/
					if ( verbose == YES )
						printf("\033[31mReflection with sigma(|F|) < 1.0. Set to 1.0.\033[0m\n");
					else
					if ( verbose_flag_2 == NO )
					{
					verbose_flag_2 = YES;
					printf("\033[31mReflection with sigma(|F|) < 1.0. Set to 1.0.\033[0m\n");
					printf("\033[31mFurther occurences will not be reported.\033[0m\n");
					}
					
					
					refl[i][4] = 1.0;
						}
							}		
					
		}
	else
	{
	for ( i=0 ; i < obs ; i++ )
		if ( refl[i][4] < 1.0 )
			{
				if ( verbose == YES )
					printf("\033[31mReflection with sigma(|F|) < 1.0. Set to 1.0.\033[0m\n");
				else
				if ( verbose_flag_2 == NO )
					{
					verbose_flag_2 = YES;
					printf("\033[31mReflection with sigma(|F|) < 1.0. Set to 1.0.\033[0m\n");
					printf("\033[31mFurther occurences will not be reported.\033[0m\n");
					}

				refl[i][4] = 1.0;
						}
	}


	if ( verbose == YES )
		printf(" - Loading data on arrays ...                                 \n - Do not panic yet ...  \n");



	total_number_of_obs = obs;
	
	/*********************************************************************************************************************************/
	/**  Loading data on arays 													**/
	/*********************************************************************************************************************************/

	for ( i=0 ; i < obs ; i++ )
		{
										
			A = refl[i][3] * cos ( PI * refl[i][5] / 180.0 );	/* Real and imaginary */
			B = refl[i][3] * sin ( PI * refl[i][5] / 180.0 );
			w = refl[i][ iuvw[2] -1 ];				/* u,v,w are the coordinates of the reflection */ 
			v = refl[i][ iuvw[1] -1 ];				/* in the FFT array */
			u = 2*refl[i][ iuvw[0] -1 ] +1;
			
			if ( v < 0 )						/* The data structure for FFTW is described in its */
				v = grid_x + v;					/* manual, but the general idea is very similar to */
			if ( w < 0 )						/* the one seen in NR */
				w = grid_z + w;
			v++;
			w++;
			
			chirefl[i][0] = w;			/* This is for much later, when we will calculate the contribution */
			chirefl[i][1] = v;			/* of each reflection to the CHI**2 statistic */
			chirefl[i][2] = u;
			
			



	/*********************************************************************************************************************************/
	/**  First case : FOM not given													**/
	/*********************************************************************************************************************************/
			if ( HAVE_FOM == NO )			
			{
			PriorA_1[w][v][u]   = A;		
			PriorA_1[w][v][u+1] = B;
			Fobs_1[w][v][u]     = A;
			Fobs_1[w][v][u+1]   = B;
			SigF_1[w][v][u]     = refl[i][4];
			SigF_1[w][v][u+1]   = 0.0;
			}
			else
			{
 	/*********************************************************************************************************************************/
	/**  Second case : known FOM. We now have to convert the structure factor probability locus to a 2D Gaussian			**/
	/*********************************************************************************************************************************/

			PriorA_1[w][v][u]   = A*refl[i][6];	/* Conventional synthesis weighted by fom */
			PriorA_1[w][v][u+1] = B*refl[i][6];
			
			
										/* Living dangerously : phase-less reflections */
			if ( PHASELESS && ( refl[i][6] < FOM_PHASELESS ))
			{
			Fobs_1[w][v][u]     = A;
			Fobs_1[w][v][u+1]   = B;
			if ( refl[i][4] > 1.0 )
				SigF_1[w][v][u]     = -refl[i][4];
			else
				SigF_1[w][v][u] = -1.0;				/* We will use fom to adjust speed of convergence */
			SigF_1[w][v][u+1]   = refl[i][6];
			phasenot++;
			}
			else
			{


			Fobs_1[w][v][u]     = A;
			Fobs_1[w][v][u+1]   = B;
			SigF_1[w][v][u]     = refl[i][4];
			if ( refl[i][6] < 0.0010 )
				SigF_1[w][v][u+1]   = 0.0010;
			else
				if ( refl[i][6] > 0.9990 )
					SigF_1[w][v][u+1]   = 0.9990;
			else
				SigF_1[w][v][u+1]   = refl[i][6] ;

					}
				}
			}




							
	Fobs_1[1][1][1] = 0.0;		/* This is irrelevant : F000 is only used to define the mean density of the initial */
	Fobs_1[1][1][2] = 0.0;		/* uniform prior during the actual maxent iteration */
	SigF_1[1][1][1] = 0.0;
	SigF_1[1][1][2] = 0.0;
	PriorA_1[1][1][1] = 0.0;
	PriorA_1[1][1][2] = 0.0;

	if ( PHASELESS && HAVE_FOM )
	printf("\033[31m - %d reflections with FOM<%5.3f entered the calculation without phase restraints.\033[0m\n", phasenot, FOM_PHASELESS);
	



 	/*********************************************************************************************************************************/
	/**  This simply writtes out the modulus of the first section of the given data. Useful only for plotting 			**/
	/*********************************************************************************************************************************/
	if ( transform == YES )
		{
			if ( verbose == YES )
				printf(" - About to write out the zero section of the starting transform.\n");
			out = fopen("START_TRANS.dat", "w");
			for ( i=-grid_x/2 ; i <= grid_x/2 ; i++ )
				{
					for ( m=-grid_y+2 ; m <= grid_y-2 ; m+=2 )
						{
							rec_angle = PI - PI * cell[ 2 + iuvw[2]]/180.0;
							rec_a = (float)(i) / cell[iuvw[1]-1] + 0.50*m*cos(rec_angle)/cell[iuvw[0]-1];
							rec_b = 0.50*m*sin(rec_angle)/cell[iuvw[0]-1];
							
							u = m;
							v = i;
							if ( u < 0 )
								{
									u = -1 * u;
									v = -1 * v;
											}

							if ( v < 0 )
								v = grid_x + v;
							v++;
							u++;
							A = PriorA_1[1][v][u];
							B = PriorA_1[1][v][u+1];
							fprintf(out, " % 10.8f  % 10.8f  % 15.3f\n", rec_a, rec_b, sqrt( A*A + B*B ) );
									}
										}
			fclose(out);
											}
											 
						
						
			

 	/*********************************************************************************************************************************/
	/**  This the conventional map calculation ...											**/
	/*********************************************************************************************************************************/

	if ( verbose == YES )
		printf(" - About to calculate conventional Fourier transform of data   \n");
#ifdef PARALLEL
	rfftwnd_threads_one_complex_to_real( NOF_THREADS, pinv, (fftw_complex *)(&PriorA_1[1][1][1]), NULL );
#else
	rfftwnd_one_complex_to_real( pinv, (fftw_complex *)(&PriorA_1[1][1][1]), NULL );
#endif



 	/*********************************************************************************************************************************/
	/** ... and output.													 	**/
	/*********************************************************************************************************************************/

	if ( verbose == YES )
		printf(" - Write out conventional Fourier transform (file conventional.map)\n");
	name[0] = "conventional.map";
	tjunk = time(0);
	sprintf( &junk[0], "GraphEnt : conventional synthesis, %s", ctime( &tjunk ) );
	strncpy ( &details[0], &junk[0], 80 );
	write_map( &name[0], PriorA_1, grid_z, grid_x, grid_y, iuvw, 2, &details[0] );
	










 	/*********************************************************************************************************************************/
	/** Plot a (user defined) section from the conventional map using PGPLOT routines. 					 	**/
	/*********************************************************************************************************************************/

	
#ifndef NOPGPLOT
	if ( DO_PLOT == YES )
	{


		
						/* Make a postscript file containing a section from the conventional map */
	if ( MAKE_PS == YES )
	{

	if( cpgopen("CONVENTIONAL.ps/cps") <= 0 )
		{
			fprintf(stderr, "\033[31m\033[1mCan not open postscript file for plot. PSOUt unset.\033[0m\n");
			MAKE_PS = NO;
					}
	else
		{
 	/*********************************************************************************************************************************/
	/**  Colours for contours 													**/
	/*********************************************************************************************************************************/

			cpgscir( 27, 255 );
			cpgscr( 16, 1.0, 0.0 ,0.0);
			cpgscr( 17, 0.9, 0.0 ,0.1);
			cpgscr( 18, 0.8, 0.0 ,0.2);
			cpgscr( 19, 0.7, 0.0 ,0.3);
			cpgscr( 20, 0.6, 0.0 ,0.4);
			cpgscr( 21, 0.5, 0.0 ,0.5);
			cpgscr( 22, 0.4, 0.0 ,0.6);
			cpgscr( 23, 0.3, 0.0 ,0.7);
			cpgscr( 24, 0.2, 0.0 ,0.8);
			cpgscr( 25, 0.1, 0.0 ,0.9);
			cpgscr( 26, 0.0, 0.0 ,1.0);


 	/*********************************************************************************************************************************/
	/**  Depending on the axes permutation, calculate angle and cell axes lengths for the section					**/
	/*********************************************************************************************************************************/

			if ( iuvw[2] == 2 )
				{
					angle = cell[4] * PI / 180.0;
					if ( iuvw[0] == 1 )
						{
						cellf = cell[0];
						cellm = cell[2];
						}
					else
						{
						cellf = cell[2];
						cellm = cell[0];
						}
							}
			else
			if ( iuvw[2] == 1 )
				{
					angle = cell[3] * PI / 180.0;
					if ( iuvw[0] == 3 )
						{
						cellf = cell[2];
						cellm = cell[1];				
						}
					else
						{
						cellf = cell[1];
						cellm = cell[2];				
						}
							}
			else
				{
					angle = cell[5] * PI / 180.0;
					if ( iuvw[0] == 1 )
						{
						cellf = cell[0];
						cellm = cell[1];				
						}
					else
						{
						cellf = cell[1];
						cellm = cell[0];				
						}
							}


 	/*********************************************************************************************************************************/
	/**  This is the transformation  matrix for PGPLOT 										**/
	/*********************************************************************************************************************************/
	
	
			tr[0] = - cellf / grid_y - cellm * cos(angle) / grid_x;
			tr[1] = cellf / grid_y;
			tr[2] = cellm * cos(angle) / grid_x;
			tr[3] = - cellm * sin(angle) / grid_x;
			tr[4] = 0.0;
			tr[5] = cellm * sin(angle) / grid_x;

 	/*********************************************************************************************************************************/
	/**  and this is the range of values along the horizontal and vertical axes 							**/
	/*********************************************************************************************************************************/
			
			if ( angle >= PI2 )
				{
					xmin = cellm * cos( angle );
					xmax = cellf;
							}
			else
				{
					xmin = 0.0;
					xmax = cellf + cellm * cos( angle );
							}
			ymin = 0.0 ; 
			ymax = cellm * sin( angle );


			aspect = ymax / ( xmax-xmin);
			cpgswin( xmin, xmax, ymin, ymax );

									}
	



	if ( GRAPH_SECTION < 0.0 || GRAPH_SECTION >= 1.0 )
		{
			fprintf(stderr, "\033[31m\033[1mSection for plot outside limits. Set to 0.0.\033[0m\n");
			GRAPH_SECTION = 0.0;
						}




 	/*********************************************************************************************************************************/
	/**  The function plot_section() is actually doing the plot									**/
	/*********************************************************************************************************************************/

	if ( DO_PLOT == YES )
		{
		DO_CALC_RMS = YES;
		plot_section( "Conventional map", PriorA_1, grid_z, grid_x, grid_y);
		DO_CALC_RMS = NO;
		}
		

	cpgclos();

	}




				
					/* Now, repeat for X-window */
				
				


	if ( ( VT125 == NO && cpgopen("/XWIN") <= 0 ) || ( VT125 == YES && cpgopen("/VT125") <= 0 ) )
		{
			fprintf(stderr, "\033[31m\033[1mCan not open graphics window. Graphics set to OFF.\033[0m\n");
			DO_PLOT = NO;
					}
	else
		{
			if ( GRAPH_WAIT == YES )
				cpgask(1);
			else
				cpgask(0);



 	/*********************************************************************************************************************************/
	/**  Colours for contours depend on whether we also plot a grayscale representation or not					**/
	/*********************************************************************************************************************************/

			if  (GRAYSCALE == YES )
			{
			cpgscir( 27, 255 );
			cpgscr( 16, 1.0, 0.0 ,0.0);
			cpgscr( 17, 0.9, 0.0 ,0.1);
			cpgscr( 18, 0.8, 0.0 ,0.2);
			cpgscr( 19, 0.7, 0.0 ,0.3);
			cpgscr( 20, 0.6, 0.0 ,0.4);
			cpgscr( 21, 0.5, 0.0 ,0.5);
			cpgscr( 22, 0.4, 0.0 ,0.6);
			cpgscr( 23, 0.3, 0.0 ,0.7);
			cpgscr( 24, 0.2, 0.0 ,0.8);
			cpgscr( 25, 0.1, 0.0 ,0.9);
			cpgscr( 26, 0.0, 0.0 ,1.0);
			}
			else
			{
			cpgscr( 16, 1.0, 0.0 ,0.0);
			cpgscr( 17, 1.0, 0.1 ,0.1);
			cpgscr( 18, 1.0, 0.2 ,0.2);
			cpgscr( 19, 1.0, 0.3 ,0.3);
			cpgscr( 20, 1.0, 0.4 ,0.4);
			cpgscr( 21, 1.0, 0.5 ,0.5);
			cpgscr( 22, 1.0, 0.6 ,0.6);
			cpgscr( 23, 1.0, 0.7 ,0.7);
			cpgscr( 24, 1.0, 0.8 ,0.8);
			cpgscr( 25, 1.0, 0.9 ,0.9);
			cpgscr( 26, 1.0, 1.0 ,1.0);
			}


 	/*********************************************************************************************************************************/
	/**  Depending on the axes permutation, calculate angle and cell axes lengths for the section					**/
	/*********************************************************************************************************************************/

			if ( iuvw[2] == 2 )
				{
					angle = cell[4] * PI / 180.0;
					if ( iuvw[0] == 1 )
						{
						cellf = cell[0];
						cellm = cell[2];
						}
					else
						{
						cellf = cell[2];
						cellm = cell[0];
						}
							}
			else
			if ( iuvw[2] == 1 )
				{
					angle = cell[3] * PI / 180.0;
					if ( iuvw[0] == 3 )
						{
						cellf = cell[2];
						cellm = cell[1];				
						}
					else
						{
						cellf = cell[1];
						cellm = cell[2];				
						}
							}
			else
				{
					angle = cell[5] * PI / 180.0;
					if ( iuvw[0] == 1 )
						{
						cellf = cell[0];
						cellm = cell[1];				
						}
					else
						{
						cellf = cell[1];
						cellm = cell[0];				
						}
							}


 	/*********************************************************************************************************************************/
	/**  This is the transformation  matrix for PGPLOT 										**/
	/*********************************************************************************************************************************/
	
	
			tr[0] = - cellf / grid_y - cellm * cos(angle) / grid_x;
			tr[1] = cellf / grid_y;
			tr[2] = cellm * cos(angle) / grid_x;
			tr[3] = - cellm * sin(angle) / grid_x;
			tr[4] = 0.0;
			tr[5] = cellm * sin(angle) / grid_x;

 	/*********************************************************************************************************************************/
	/**  and this is the range of values along the horizontal and vertical axes 							**/
	/*********************************************************************************************************************************/
			
			if ( angle >= PI2 )
				{
					xmin = cellm * cos( angle );
					xmax = cellf;
							}
			else
				{
					xmin = 0.0;
					xmax = cellf + cellm * cos( angle );
							}
			ymin = 0.0 ; 
			ymax = cellm * sin( angle );


			aspect = ymax / ( xmax-xmin);
			cpgswin(  xmin, xmax, ymin, ymax );

									}
	



	if ( GRAPH_SECTION < 0.0 || GRAPH_SECTION >= 1.0 )
		{
			fprintf(stderr, "\033[31m\033[1mSection for plot outside limits. Set to 0.0.\033[0m\n");
			GRAPH_SECTION = 0.0;
						}


							}


 	/*********************************************************************************************************************************/
	/**  The function plot_section() is actually doing the plot									**/
	/*********************************************************************************************************************************/

	if ( DO_PLOT == YES )
		{
		DO_CALC_RMS = YES;
		plot_section( "Conventional map", PriorA_1, grid_z, grid_x, grid_y);
		DO_CALC_RMS = NO;
		}
				
#endif			
		







	/**************************************************************************************************************************/
	/**   Trial-and-error to get a reasonable initial value for lambda                                                       **/
	/**************************************************************************************************************************/
	if ( WILL_TEST == YES )
	{
	printf("\033[36m___________________________________________________________________________________________________________________________\033[0m\n");

	
	ini_lambda = 0.01000000;				/* This arbitrary assumption can get us into trouble with some data sets */
	printf("\n - Now trying lambda = % 12.3f\n", ini_lambda );
	while( maxent( Fobs_1, SigF_1, PriorA_1, ini_lambda, grid_z, grid_x, grid_y ) > 0.0 )
		{
			ini_lambda *= (double)(10.00000);
			if ( verbose == YES )
				printf("\n\n");
			printf(" - Now trying lambda = % 12.3f\n", ini_lambda );
					}
					
	ini_lambda /= (double)(10.0000);
	printf("\n - Initial value for lambda set to %f\n", ini_lambda );
	WILL_TEST = NO;
	}
	





 	/*********************************************************************************************************************************/
	/**  Do the same thing (as with the conventional synthesis above) for opening the graphics window for the maxent map.	 	**/
	/*********************************************************************************************************************************/

		
#ifndef NOPGPLOT
	if ( KEEPCONV == YES )
	{

	if ( ( VT125 == NO && cpgopen("/XWIN") <= 0 ) || ( VT125 == YES && cpgopen("/VT125") <= 0 ) )
		{
			fprintf(stderr, "\033[31m\033[1mCan not open graphics window. Graphics set to OFF.\033[0m\n");
			DO_PLOT = NO;
					}
	else
		{
			if ( GRAPH_WAIT == YES )
				cpgask(1);
			else
				cpgask(0);

			if  (GRAYSCALE == YES )
			{
			cpgscir( 27, 255 );
			cpgscr( 16, 1.0, 0.0 ,0.0);
			cpgscr( 17, 0.9, 0.0 ,0.1);
			cpgscr( 18, 0.8, 0.0 ,0.2);
			cpgscr( 19, 0.7, 0.0 ,0.3);
			cpgscr( 20, 0.6, 0.0 ,0.4);
			cpgscr( 21, 0.5, 0.0 ,0.5);
			cpgscr( 22, 0.4, 0.0 ,0.6);
			cpgscr( 23, 0.3, 0.0 ,0.7);
			cpgscr( 24, 0.2, 0.0 ,0.8);
			cpgscr( 25, 0.1, 0.0 ,0.9);
			cpgscr( 26, 0.0, 0.0 ,1.0);
			}
			else
			{
			cpgscr( 16, 1.0, 0.0 ,0.0);
			cpgscr( 17, 1.0, 0.1 ,0.1);
			cpgscr( 18, 1.0, 0.2 ,0.2);
			cpgscr( 19, 1.0, 0.3 ,0.3);
			cpgscr( 20, 1.0, 0.4 ,0.4);
			cpgscr( 21, 1.0, 0.5 ,0.5);
			cpgscr( 22, 1.0, 0.6 ,0.6);
			cpgscr( 23, 1.0, 0.7 ,0.7);
			cpgscr( 24, 1.0, 0.8 ,0.8);
			cpgscr( 25, 1.0, 0.9 ,0.9);
			cpgscr( 26, 1.0, 1.0 ,1.0);
			}


			if ( iuvw[2] == 2 )
				{
					angle = cell[4] * PI / 180.0;
					if ( iuvw[0] == 1 )
						{
						cellf = cell[0];
						cellm = cell[2];
						}
					else
						{
						cellf = cell[2];
						cellm = cell[0];
						}
							}
			else
			if ( iuvw[2] == 1 )
				{
					angle = cell[3] * PI / 180.0;
					if ( iuvw[0] == 3 )
						{
						cellf = cell[2];
						cellm = cell[1];				
						}
					else
						{
						cellf = cell[1];
						cellm = cell[2];				
						}
							}
			else
				{
					angle = cell[5] * PI / 180.0;
					if ( iuvw[0] == 1 )
						{
						cellf = cell[0];
						cellm = cell[1];				
						}
					else
						{
						cellf = cell[1];
						cellm = cell[0];				
						}
							}
	
	
			tr[0] = - cellf / grid_y - cellm * cos(angle) / grid_x;
			tr[1] = cellf / grid_y;
			tr[2] = cellm * cos(angle) / grid_x;
			tr[3] = - cellm * sin(angle) / grid_x;
			tr[4] = 0.0;
			tr[5] = cellm * sin(angle) / grid_x;
			
			if ( angle >= PI2 )
				{
					xmin = cellm * cos( angle );
					xmax = cellf;
							}
			else
				{
					xmin = 0.0;
					xmax = cellf + cellm * cos( angle );
							}
			ymin = 0.0 ; 
			ymax = cellm * sin( angle );


			aspect = ymax / ( xmax-xmin);
			cpgswin(  xmin, xmax, ymin, ymax );

									}
										}
#endif	
	
	printf("\n\n\n");












 	/*********************************************************************************************************************************/
	/** Ready to roll ...													 	**/
	/*********************************************************************************************************************************/


	printf("\033[36m___________________________________________________________________________________________________________________________\033[0m\n\n");
	printf(" - MAXENT starts here                                   \n\n");


 


 	/*********************************************************************************************************************************/
	/**  This is the maxent iteration												**/
	/*********************************************************************************************************************************/

 	R_factor = maxent( Fobs_1, SigF_1, PriorA_1, ini_lambda, grid_z, grid_x, grid_y );











	if ( PLOT_ZEROED == YES )
	{
	printf("\033[35m[1m___________________________________________________________________________________________________________________________\n");
	printf("___________________________________________________________________________________________________________________________\n\n");
	printf("                   The entropy of the GraphEnt map did not decrease monotonically during the iteration.                    \n");
	printf("    With a reasonable F000 value (keyword F000), a sufficiently fine grid (keyword GRID) and an internally consistent      \n");
	printf("  data set this should not have happened. Please review the results with scepticism and caution (or simply delete them).   \n");
	printf("___________________________________________________________________________________________________________________________\n");
	printf("___________________________________________________________________________________________________________________________[0m\033[0m\n\n\n\n");
	}
	else
	printf("\033[36m___________________________________________________________________________________________________________________________\033[0m\n\n\n\n");
	









 	/*********************************************************************************************************************************/
	/**  Write postscript if requested												**/
	/*********************************************************************************************************************************/





#ifndef NOPGPLOT

	if ( MAKE_PS == YES )
	{


	if( cpgopen("GRAPHENT.ps/cps") <= 0 )
		{
			fprintf(stderr, "\033[31m\033[1mCan not open postscript file for plot. PSOUt unset.\033[0m\n");
			MAKE_PS = NO;
					}
	else
		{
			cpgscir( 27, 255 );
			cpgscr( 16, 1.0, 0.0 ,0.0);
			cpgscr( 17, 0.9, 0.0 ,0.1);
			cpgscr( 18, 0.8, 0.0 ,0.2);
			cpgscr( 19, 0.7, 0.0 ,0.3);
			cpgscr( 20, 0.6, 0.0 ,0.4);
			cpgscr( 21, 0.5, 0.0 ,0.5);
			cpgscr( 22, 0.4, 0.0 ,0.6);
			cpgscr( 23, 0.3, 0.0 ,0.7);
			cpgscr( 24, 0.2, 0.0 ,0.8);
			cpgscr( 25, 0.1, 0.0 ,0.9);
			cpgscr( 26, 0.0, 0.0 ,1.0);


			if ( iuvw[2] == 2 )
				{
					angle = cell[4] * PI / 180.0;
					if ( iuvw[0] == 1 )
						{
						cellf = cell[0];
						cellm = cell[2];
						}
					else
						{
						cellf = cell[2];
						cellm = cell[0];
						}
							}
			else
			if ( iuvw[2] == 1 )
				{
					angle = cell[3] * PI / 180.0;
					if ( iuvw[0] == 3 )
						{
						cellf = cell[2];
						cellm = cell[1];				
						}
					else
						{
						cellf = cell[1];
						cellm = cell[2];				
						}
							}
			else
				{
					angle = cell[5] * PI / 180.0;
					if ( iuvw[0] == 1 )
						{
						cellf = cell[0];
						cellm = cell[1];				
						}
					else
						{
						cellf = cell[1];
						cellm = cell[0];				
						}
							}
	
	
			tr[0] = - cellf / grid_y - cellm * cos(angle) / grid_x;
			tr[1] = cellf / grid_y;
			tr[2] = cellm * cos(angle) / grid_x;
			tr[3] = - cellm * sin(angle) / grid_x;
			tr[4] = 0.0;
			tr[5] = cellm * sin(angle) / grid_x;
			
			if ( angle >= PI2 )
				{
					xmin = cellm * cos( angle );
					xmax = cellf;
							}
			else
				{
					xmin = 0.0;
					xmax = cellf + cellm * cos( angle );
							}
			ymin = 0.0 ; 
			ymax = cellm * sin( angle );


			aspect = ymax / ( xmax-xmin);
			cpgswin(  xmin, xmax, ymin, ymax );

									}

		plot_section( "GraphEnt synthesis", PriorA_1, grid_z, grid_x, grid_y);
		cpgclos();
										}
#endif	







 	/*********************************************************************************************************************************/
	/**  If returned value is negative : convergence not achieved									**/
	/*********************************************************************************************************************************/


	if ( R_factor < 0.0 )
		{
			fprintf(stderr, "\n\nCONVERGENCE NOT ACHIEVED.\n");
			printf("The final R-factor between the observed\n");
			printf("and calculated amplitudes is %10.7f \n\n\n", fabs( R_factor ));
                        printf("If the R-factor is higher than the Rsymm of the data\n");
                        printf("you can try decreasing the initial value of lambda  \n");
                        printf("and run the programme again. See the documentation  \n");
                        printf("for details on how to do that.                \n\n\n\n");
                                       								}
	else
		{
			printf("\n\nCONVERGENCE ACHIEVED.\n");
			printf("The final R-factor between the observed\n");
			printf("and calculated amplitudes is %10.7f \n\n\n", fabs( R_factor ));
													}









 	/*********************************************************************************************************************************/
	/**  I haven't used this option for ages and I don't know if it works, and it is not in the documentation, and forget it	**/
	/*********************************************************************************************************************************/
	/**************************************************************************************************************************/
	/**   If phase extension requested : transform MAXENT, and for every grid point in Fobs, assign PHIc to Fo.              **/
	/**   Then, transform FoPHIc and write out new (conventional) map.                                                       **/
	/**************************************************************************************************************************/
	if ( extend == YES && R_factor > 0.000)
	{
	norm = 1.0 / ( grid_z * grid_x * grid_y );
#ifdef PARALLEL
	rfftwnd_threads_one_real_to_complex( NOF_THREADS, p, (fftw_real *)(&PriorA_1[1][1][1]), NULL );
#else
	rfftwnd_one_real_to_complex( p, (fftw_real *)(&PriorA_1[1][1][1]), NULL );
#endif



	for ( w = 1; w <= grid_z ; w++ )
	for ( v = 1; v <= grid_x ; v++ )
	for ( u = 1; u <= grid_y ; u += 2 )
		if ( (int)( Fo = sqrt( Fobs_1[w][v][u]*Fobs_1[w][v][u] + Fobs_1[w][v][u+1]*Fobs_1[w][v][u+1] )) != 0 &&
		     (int)( Fc = sqrt( PriorA_1[w][v][u]*PriorA_1[w][v][u] + PriorA_1[w][v][u+1]*PriorA_1[w][v][u+1])) != 0 )
			{
	  		 	Fobs_1[w][v][u]   = PriorA_1[w][v][u]   * Fo / Fc;
	  		 	Fobs_1[w][v][u+1] = PriorA_1[w][v][u+1] * Fo / Fc;
						}

#ifdef PARALLEL
	rfftwnd_threads_one_complex_to_real( NOF_THREADS, pinv, (fftw_complex *)(&Fobs_1[1][1][1]), NULL );
#else
	rfftwnd_one_complex_to_real( pinv, (fftw_complex *)(&Fobs_1[1][1][1]), NULL );
#endif

	for ( w = 1; w <= grid_z ; w++ )
	for ( v = 1; v <= grid_x ; v++ )
	for ( u = 1; u <= grid_y ; u++  )
              	Fobs_1[w][v][u] *= norm;
					
			
	if ( verbose == YES )
		printf(" - About to write out extend.map                              \n");
	name[0] = "extend.map";
	tjunk = time(0);
	sprintf( &junk[0], "GraphEnt : extension synthesis, %s", ctime( &tjunk ) );
	strncpy ( &details[0], &junk[0], 80 );
	write_map( &name[0], Fobs_1, grid_z, grid_x, grid_y, iuvw, 2, &details[0] );
	printf("\n\n\n");
	



#ifdef PARALLEL
	rfftwnd_threads_one_complex_to_real( NOF_THREADS, pinv, (fftw_complex *)(&PriorA_1[1][1][1]), NULL );
#else
	rfftwnd_one_complex_to_real( pinv, (fftw_complex *)(&PriorA_1[1][1][1]), NULL );
#endif

	for ( w = 1; w <= grid_z ; w++ )
	for ( v = 1; v <= grid_x ; v++ )
	for ( u = 1; u <= grid_y ; u++  )
              	PriorA_1[w][v][u] *= norm;
									}









	/* Save maxent map in Fobs array for latter */
	
	memcpy( &Fobs_1[1][1][1], &PriorA_1[1][1][1], grid_z*grid_x*(grid_y+2)*sizeof( float));
	


	/**************************************************************************************************************************/
	/**   Now write out MAXENT.MAP                                                                                           **/
	/**************************************************************************************************************************/


	if ( verbose == YES )
		printf(" - Write out maxent.map map file.                                     \n");
	name[0] = "maxent.map";
	tjunk = time(0);
	sprintf( &junk[0], "GraphEnt : maxent (?) synthesis, %s", ctime( &tjunk ) );
	strncpy ( &details[0], &junk[0], 80 );
	write_map( &name[0], PriorA_1, grid_z, grid_x, grid_y, iuvw, 2,  &details[0] );
	printf("\n\n\n");


 	/*********************************************************************************************************************************/
	/**  This is the modulus of the zero section of the maxent's map transform. For preparing graphs only				**/
	/*********************************************************************************************************************************/
	if ( transform == YES )
		{
#ifdef PARALLEL
			rfftwnd_threads_one_real_to_complex( NOF_THREADS, p, (fftw_real *)(&PriorA_1[1][1][1]), NULL );
#else
			rfftwnd_one_real_to_complex( p, (fftw_real *)(&PriorA_1[1][1][1]), NULL );
#endif

			if ( verbose == YES )
				printf(" - About to write out the zero section of the maxent transform.\n");
			out = fopen("MAXENT_TRANS.dat", "w");
			for ( i=-grid_x/2 ; i <= grid_x/2 ; i++ )
				{
					for ( m=-grid_y+2 ; m <= grid_y-2 ; m+=2 )
						{

							rec_angle = PI - PI * cell[ 2 + iuvw[2]]/180.0;
							rec_a = (float)(i) / cell[iuvw[1]-1] + 0.5*m*cos(rec_angle)/cell[iuvw[0]-1];
							rec_b = 0.5*m*sin(rec_angle)/cell[iuvw[0]-1];
							
							u = m;
							v = i;
							if ( u < 0 )
								{
									u = -1 * u;
									v = -1 * v;
											}

							if ( v < 0 )
								v = grid_x + v;
							v++;
							u++;

							A = PriorA_1[1][v][u];
							B = PriorA_1[1][v][u+1];
							fprintf(out, " % 10.8f  % 10.8f  % 15.3f\n", rec_a, rec_b, sqrt( A*A + B*B ) );
									}
					fprintf(out, "\n");
										}
			fclose(out);
											}
											 




 	/*********************************************************************************************************************************/
	/**  Calculate contribution of each reflection to the CHI^2 test. This uses information produced from the maxent() function	**/
	/*********************************************************************************************************************************/
							
	if ( R_factor > 0.000 )
	{

	if ( verbose == YES )
		printf(" - Calculating table of largest contributions to chi**2\n");
		
	mean = 0.0;
	max  = 0.0;
	for ( i=0 ; i < chitable ; i++ )
		{
			val = chicontrib[i]*chicontrib[i];
			mean += val;
			if ( val > max )
				max = val;
						}
	mean /= (float)(chitable);

	rms  = 0.0;						/* Find rms contribution of all reflections to chi**2 */
	for ( i=0 ; i < chitable ; i++ )
		rms += (chicontrib[i]*chicontrib[i]-mean)*(chicontrib[i]*chicontrib[i]-mean);
	rms /= (float)(chitable-1);
	rms = sqrt( rms );
	
	if ( verbose == YES )
		printf(" - Will write out all reflections contributing to chi^2 by more than %f times the rmsd of all contributions.\n",
			chi_limit );
			
 	/*********************************************************************************************************************************/
	/** and this plots a graph of the CHI^2 contributions 										**/
	/*********************************************************************************************************************************/

#ifndef NOPGPLOT
	if ( DO_PLOT == YES )
	{


	/*********************************************************************************************************************************/
	/**  First to a postscript file ...											   	**/
	/*********************************************************************************************************************************/

	if( cpgopen("CHIcontributions.ps/cps") <= 0 )
		{
			fprintf(stderr, "\033[31m\033[1mCan not open postscript file for plot.\033[0m\n");
			DO_PLOT = NO;
					}
	else
		{
			cpgslw(1);
    			cpgsci(2);
			cpgswin( 0, chitable, 0.0, max*1.050 );
			cpgbox("bcts", 0.0, 0, "bcts", 0.0, 0);
			cpgmtxt("t", 1.0, 0.0, 0.0, "chi**2 contributions");

    			cpgsci(3);
    			cpgsls(1);
    			cpgslw(10);
			for ( i=0 ; i < chitable ; i++ )
				cpgpt1( (float)(i), chicontrib[i]*chicontrib[i], -2 );
			
			cpgslw(1);
			cpgsls(4);
    			cpgsci(14);
			for ( val = mean + rms ; val < max ; val += rms )
				{
					cpgmove( 0.0, val );
					cpgdraw( (float)(chitable), val );
						}
						
						}

	cpgclos();



	/* and then to interactive device */
	

	if ( ( VT125 == NO && cpgopen("/XWIN") <= 0 ) || ( VT125 == YES && cpgopen("/VT125") <= 0 ) )
		{
			fprintf(stderr, "\033[31m\033[1mCan not open graphics window.\033[0m\n");
			DO_PLOT = NO;
					}
	else
		{
			if ( GRAPH_WAIT == YES )
				cpgask(1);
			else
				cpgask(0);

			cpgslw(1);
    			cpgsci(2);
			cpgswin( 0, chitable, 0.0, max*1.050 );
			cpgbox("bcts", 0.0, 0, "bcts", 0.0, 0);
			cpgmtxt("t", 1.0, 0.0, 0.0, "chi**2 contributions");

    			cpgsci(3);
    			cpgsls(1);
    			cpgslw(10);
			for ( i=0 ; i < chitable ; i++ )
				cpgpt1( (float)(i), chicontrib[i]*chicontrib[i], -2 );
			
			cpgslw(1);
			cpgsls(4);
    			cpgsci(14);
			for ( val = mean + rms ; val < max ; val += rms )
				{
					cpgmove( 0.0, val );
					cpgdraw( (float)(chitable), val );
						}
			

 
						}




					/* Distribution of fo-fc/sig(fo) & reflection file */
	if ( GRAPH_WAIT == NO )
	{
	int c;
			
	while ( (c = getchar()) == EOF )
			;


	if ( c == 'h' || c == 'H' )
	{
	FILE 	*reflout;
	float	MAXENT_F000;
	float	x,y;
	char 	c;
	int	cc;	
	
	chidist();		/* Do the plot */




	/* Take transform of maxent map, create an intermediate file with all data in P1, run f2mtz, cad on it. Make a .phs file as well */
	
#ifdef PARALLEL
	rfftwnd_threads_one_real_to_complex( NOF_THREADS, p, (fftw_real *)(&Fobs_1[1][1][1]), NULL );
#else
	rfftwnd_one_real_to_complex( p, (fftw_real *)(&Fobs_1[1][1][1]), NULL );
#endif

	MAXENT_F000 = sqrt( Fobs_1[1][1][1]*Fobs_1[1][1][1] + Fobs_1[1][1][2]*Fobs_1[1][1][2]);

	reflout = fopen( "yet_another_intermediate.hkl", "w");
	for ( w = 1; w <= grid_z ; w++ )
	for ( v = 1; v <= grid_x ; v++ )
	for ( u = 1; u <= grid_y ; u += 2 )
		{
			int	index[3];
			float	PHIc;
			float	amp;
			float	sig;
			
			amp = sqrt( Fobs_1[w][v][u]*Fobs_1[w][v][u] + Fobs_1[w][v][u+1]*Fobs_1[w][v][u+1]);
			if ( SigF_1[w][v][u] > 1 )
				{
				if ((PATTERSON == YES || DIFF_PATTERSON == YES))
					sig = sqrt( SigF_1[w][v][u] );
				else
					sig = SigF_1[w][v][u];
				}
			else
				sig = 1.0;
			
			if ((PATTERSON == YES || DIFF_PATTERSON == YES))
				amp = sqrt( amp );
			if ( (int)(amp) > 0 && ( ! ( w == 1 && v == 1 && u == 1 )) )
			{
				
				index[ iuvw[0] -1 ] = ( u - 1 ) / 2 ;
				index[ iuvw[2] -1] = w - 1;
				if ( index[ iuvw[2] -1] > grid_z / 2 )
					index[ iuvw[2] -1] = index[ iuvw[2] -1] - grid_z;
				index[ iuvw[1] -1] = v - 1;
				if ( index[ iuvw[1] -1] > grid_x / 2 )
					index[ iuvw[1] -1] = index[ iuvw[1] -1] - grid_x;
				
				PHIc = 180.0 * atan2( -Fobs_1[w][v][u+1], Fobs_1[w][v][u] ) / PI;
				if ( (PATTERSON == YES || DIFF_PATTERSON == YES) )
				fprintf(reflout, " %5d %5d %5d %15.5f %10.3f\n", index[0], index[1], index[2], amp, sig );
				else
				fprintf(reflout, " %5d %5d %5d %15.5f %10.3f %10.3f\n", index[0], index[1], index[2], amp, sig, PHIc );


						}
							}
	fclose( reflout );




	if ( HAVE_CCP4 == YES )
	{
	out = fopen( "MAXENT_script_for_f2mtz.in", "w" );
	fprintf( out, "\n\nf2mtz hklin yet_another_intermediate.hkl hklout yet_another_intermediate.mtz > MAXENT_F2MTZ_RUN.LOG << eof\n");
	fprintf( out, "TITLE From GraphEnt, F000=%d\n", (int)(MAXENT_F000));
	fprintf( out, "CELL %f %f %f %f %f %f\n", cell[0], cell[1], cell[2], cell[3], cell[4], cell[5]);
	fprintf( out, "SYMMETRY %d\n", truespacegroup );
	if ( (PATTERSON == YES || DIFF_PATTERSON == YES) )
	{
	fprintf( out, "LABOUT  H K L F SIGF\n");
	fprintf( out, "CTYPOUT H H H F Q   \n");
	}
	else
	{
	fprintf( out, "LABOUT  H K L F SIGF PHI\n");
	fprintf( out, "CTYPOUT H H H F Q    P\n");
	}
	fprintf( out, "END\n");
	fprintf( out, "eof\n");
	fclose(out);
	system("/bin/chmod 755 MAXENT_script_for_f2mtz.in ; ./MAXENT_script_for_f2mtz.in");


	out = fopen( "MAXENT_script_for_cad.in", "w" );
	fprintf( out, "\n\ncad hklin1 yet_another_intermediate.mtz hklout maxent_coefficients.mtz > MAXENT_CAD_RUN.LOG << eof\n");
	fprintf( out, "OUTLIM SPACEGROUP %d\n", truespacegroup);
	fprintf( out, "LABIN FILE 1 ALL\n");
	fprintf( out, "END\n");
	fprintf( out, "eof\n");
	fclose(out);
	system("/bin/chmod 755 MAXENT_script_for_cad.in ; ./MAXENT_script_for_cad.in");

	if ( ! (PATTERSON == YES || DIFF_PATTERSON == YES) )
	{
	out = fopen( "MAXENT_script_for_mtz2various.in", "w" );
	fprintf( out, "\n\nmtz2various hklin maxent_coefficients.mtz hklout maxent_coefficients.phs > MAXENT_mtz2various_RUN.LOG << eof\n");
	fprintf( out, "OUTPUT USER '(3I4,2F15.4,F12.3)'\n");
	fprintf( out, "LABIN FP=F SIGFP=SIGF PHIB=PHI\n");
	fprintf( out, "END\n");
	fprintf( out, "eof\n");
	fclose(out);
	system("/bin/chmod 755 MAXENT_script_for_mtz2various.in ; ./MAXENT_script_for_mtz2various.in");
	
	}


	system("/bin/rm -rf ./MAXENT_CAD_RUN.LOG ./MAXENT_F2MTZ_RUN.LOG ./MAXENT_mtz2various_RUN.LOG");
	system("/bin/rm -rf ./MAXENT_script_for_cad.in ./MAXENT_script_for_f2mtz.in ./MAXENT_script_for_mtz2various.in");
	system("/bin/rm -rf ./yet_another_intermediate.hkl ./yet_another_intermediate.mtz");

	cpgcurs( &x, &y, &c );



	}

	system("/bin/rm -rf ./MAXENT_FROM_MTZ.in");


						/* All done. */
	while ( (cc = getchar()) == EOF )
			;
				}

						}
					
	
			
	
	cpgend();



	}
#endif	


 	/*********************************************************************************************************************************/
	/**  Write indeces of reflections with a large contribution to CHI^2 to a file (suspect data)					**/
	/*********************************************************************************************************************************/

	
	out = fopen("CHIcontributions.dat", "w" );

	for ( i=0 ; i < chitable ; i++ )
		if ( (chicontrib[i]*chicontrib[i]-mean)/rms > chi_limit )
		{
		w = chipointers[i][0];
		v = chipointers[i][1];
		u = chipointers[i][2];
		
		for ( m=0 ; m < obs ; m++ )
			if ( chirefl[m][0] == w && chirefl[m][1] == v && chirefl[m][2] == u  )
				{
				fprintf( out, " % 4d % 4d % 4d   % 15.5f\n", nearint(refl[m][0]), nearint(refl[m][1]), 
									     nearint(refl[m][2]), chicontrib[i]*chicontrib[i] );
				break;
				}
			
		if ( m == obs )
			fprintf(out, "Can not find reflection index (???). Panic.\n");
		}
	fclose( out  );
	}


	t2 = time(0);
	printf("\n\n\nNormal termination ? (%d seconds)\n", (int)(t2-t1));
	



}


































































































/**********************************************************************************************************************************/
/**	                                                                                                                         **/
/**	Maximise configurational entropy of image subject to the constrain that its Fourier components are consistent with       **/
/**	the observed data. Gull, S.F. & Daniell, G.J., 1978, Nature, 272, 686-690                                                **/
/**	                                                                                                                         **/
/**********************************************************************************************************************************/
float	maxent( Fobs_1, SigF_1, PriorA_1, ini_lambda, grid_z, grid_x, grid_y )
float	***Fobs_1;
float	***SigF_1;
float	***PriorA_1;
double	ini_lambda;
int	grid_z, grid_x, grid_y;
{

	/* For FFT */
	float	***PriorB_1;    
	float	***Backup;    


	/* For fast access */
	float	*Fobs, *SigF, *PriorA, *PriorB, *Back;


	/* Rest */   
	float	chi_p;	
	float	d_chi;
   	int	u, v, w;
	float	sum1, sum2;
	float	amp1, amp2;
	float	s, sph;
	float	norm;
        float	val;
	float	sumFo;
	int	nof_obs;
	float	A, B;
	int	cycle;
	int	converged;
	float	ac,bc,ao,bo,pho,phc,phdif; 
	float	ampo, ampc, phase, ampd;
	float	jjj, backup_chi;
	float	phase_diff;
	char	pgtitle[300];
	float	intersum;
	int	c;
	int	gridprod;
	int	index;
	time_t	tstart, tend, ttest;
	float	sig1, sig2;
	float	sum, ent;	
	double 	const_ent;
	int	nof_phaseless;
	int	FALSE_ALARM = NO;
	int	grid_bytes;
	int	zeroed;	
	float	lowest_entropy;
	int	HAVE_CHI_TABLE = NO ;


	Fobs 	= &Fobs_1[1][1][1];
	SigF 	= &SigF_1[1][1][1];
	PriorA 	= &PriorA_1[1][1][1];
	gridprod= grid_z * grid_x * (grid_y+2);
	
	grid_bytes = gridprod * sizeof( float);

	/**************************************************************************************************************************/
	/**   Number of observed components and Sum(Fo) for R-factor.                                                            **/
	/**************************************************************************************************************************/
	norm = 1.0 / ( grid_z * grid_x * grid_y );

	nof_obs = 0;
	sumFo   = 0.0;
	nof_phaseless = 0;
	for ( w = 1; w <= grid_z ; w++ )
	   for ( v = 1; v <= grid_x ; v++ )
	       for ( u = 1; u <  grid_y ; u += 2 )
			if ( (int)(SigF_1[w][v][u]) != 0 )
				{

					if ( (int)(SigF_1[w][v][u]) < 0 )
						nof_phaseless++;
						
					nof_obs++;
					sumFo += sqrt( Fobs_1[w][v][u]*Fobs_1[w][v][u] + Fobs_1[w][v][u+1]*Fobs_1[w][v][u+1] );
                                  					}
	nof_obs = nof_obs - (axial/2);

	if ( HAVE_FOM == YES )
		nof_obs = (nof_obs-nof_phaseless)*2 + nof_phaseless;
						




	/**************************************************************************************************************************/
	/**   Allocate space for second copy of prior & back-up                                                                  **/
	/**************************************************************************************************************************/
	PriorB_1 = f3tensor( 1, grid_z, 1, grid_x, 1, grid_y+2 );
	Backup   = f3tensor( 1, grid_z, 1, grid_x, 1, grid_y+2 );

	PriorB = &PriorB_1[1][1][1];
	Back   = &Backup[1][1][1];




	/**************************************************************************************************************************/
	/**   Prepare initial (uniform) prior.                                                                                   **/
	/**************************************************************************************************************************/
	for ( index=0 ; index < gridprod ; index ++ )
	
		{
								/* CON has been calculated from main() based on the assigned or */
                                PriorA[index] = CON;            /* given value of the F000 term. Note that we do not */
                                PriorB[index] = CON;            /* expicitly constrain F000 during the iteration */

                                      				}





	/**************************************************************************************************************************/
	/** A non-uniform prior for Patterson functions ? : NOT GOOD (CAN'T DEAL WITH NON-PRIMITIVE, ADDITONAL AD HOCKERIES, ... **/
	/**************************************************************************************************************************/
		
	if ( (PATTERSON == YES || DIFF_PATTERSON == YES) && MAKE_NONUNIFORM == YES )
	{
	float	fooo;
	float	pseudo_at;
	float	dens_origin;
	float	res;
	float	fr[3];
	int	uu, vv, ww;
	float	sum, scale, con;
	
	fooo 	      = CON * grid_z * grid_x * grid_y;			/* This is the given F000 */
	pseudo_at     = sqrt(fooo) / 12.0;				/* Let's call this `effective number of carbon atoms' */
	dens_origin   = fooo / pseudo_at;				/* expected density of origin peak */
	
	for ( w = 1; w <= grid_z ; w++ )
	   for ( v = 1; v <= grid_x ; v++ )
	       for ( u = 1; u <= grid_y/2+1 ; u++ )
			{						
									/* fr[] are fractional coordinates of grid point along a,b,c */
									
				fr[ iuvw[0]-1] = (float)(u-1) / (float)(grid_y);
				fr[ iuvw[1]-1] = (float)(v-1) / (float)(grid_x);
				fr[ iuvw[2]-1] = (float)(w-1) / (float)(grid_z);
				if ( fr[0] > 0.50 )
					fr[0] -= 1.00;
				if ( fr[1] > 0.50 )
					fr[1] -= 1.00;
				if ( fr[2] > 0.50 )
					fr[2] -= 1.00;
					
				res = sqrt(  fr[0]*fr[0]*cell[0]*cell[0]
				           + fr[1]*fr[1]*cell[1]*cell[1]
				           + fr[2]*fr[2]*cell[2]*cell[2]
				           + 2.0*fr[1]*fr[2]*cell[1]*cell[2]*cos(PI*cell[3]/180.0)
				           + 2.0*fr[0]*fr[2]*cell[0]*cell[2]*cos(PI*cell[4]/180.0)
					   + 2.0*fr[0]*fr[1]*cell[0]*cell[1]*cos(PI*cell[5]/180.0) );

				PriorA_1[w][v][u] = 10000.0 * exp( -11.0450 * ( res * res) / (max_res * max_res )); 
				
				
									/* Use centre of symmetry to generate the other half of the */
									/* origin peak (want to make sure that our prior has a centre of*/
									/* symmetry) */
				uu = -u+1;
				vv = -v+1;
				ww = -w+1;
				PriorA_1[ww < 0 ? grid_z + ww + 1 : ww + 1]
				        [vv < 0 ? grid_x + vv + 1 : vv + 1]
				        [uu < 0 ? grid_y + uu + 1 : uu + 1] = PriorA_1[w][v][u];
				        
				
					}
					
	
	if ( PEAK_BACKGROUND > 0.0 )
	{
	for ( w = 1; w <= grid_z ; w++ )
	   for ( v = 1; v <= grid_x ; v++ )
	       for ( u = 1; u <= grid_y ; u++ )
	       		PriorA_1[w][v][u] = PriorA_1[w][v][u] + 10000.0 * PEAK_BACKGROUND * (1.0000 - PEAK_BACKGROUND);
	}
	
					
	sum = 0.0;
	for ( w = 1; w <= grid_z ; w++ )
	   for ( v = 1; v <= grid_x ; v++ )
	       for ( u = 1; u <= grid_y ; u++ )
			sum += PriorA_1[w][v][u];
	
	
	if ( PEAK_BACKGROUND > 0.0 )
	{
	scale = fooo / sum;
	con   = 0.0;
	}
	else
	{
	scale = dens_origin / sum;
	con   = (fooo - dens_origin) / (grid_z*grid_x*grid_y);
	}
		
	for ( w = 1; w <= grid_z ; w++ )
	   for ( v = 1; v <= grid_x ; v++ )
	       for ( u = 1; u <= grid_y ; u++ )
			{
				PriorA_1[w][v][u] = PriorA_1[w][v][u]*scale + con;
				PriorB_1[w][v][u] = PriorA_1[w][v][u];
					}
					
	}
		
				








	/**************************************************************************************************************************/
	/**   Start iteration.                                                                                                   **/
	/**************************************************************************************************************************/
	chi_p  = 0.0;
	d_chi  = 1000000000;
	lambda = ini_lambda;
	cycle  = 0;


	tstart = time(NULL);
	while ( 1 )
	{






	if ( con_lambda == NO && cycle > 1  )		/* As long as the calculation is not diverging, increase lambda on every cycle */
		lambda *= (double)(1.0200000000);


		
												/* Plot section in graphics window */
	if ( DO_PLOT == YES && (cycle)%GRAPH_INTER == 0 && (cycle > 0 || MAKE_NONUNIFORM == YES ) && WILL_TEST == NO )
		{
		if ( GRAPH_WAIT == YES )
			printf("\n");
		if ( !QUIET)
			sprintf( pgtitle, "Maxent map, Cycle %d", cycle );
		else
			{
				if ( cycle < 2 )
					sprintf( pgtitle, "Maxent map, Cycle %d", cycle );
				else
					{
					if ( chi_p < INT_MAX && TARGET_CHI < INT_MAX )
					sprintf( pgtitle, "Maxent map, Cycle %d, Chi-squared %5.3f, R-factor %5.3f", cycle, 
							(chi_p / nof_obs), (sum2/sumFo) );
					else
						sprintf( pgtitle, "Maxent map, Cycle %d", cycle );
					}
					}
					
		plot_section( pgtitle, PriorA_1, grid_z, grid_x, grid_y);
		}





	/**************************************************************************************************************************/
	/**   Calculate entropy of current map                                                                                   **/
	/**************************************************************************************************************************/


	if ( WILL_TEST == NO && (cycle%VERB_INTERVAL == 0 || (verbose == YES && SHOW_ENTROPY == YES ) || (verbose == YES && cycle%4 == 0 )))
	
						/* This calculates the relative entropy as a fraction of its maximum value (for a */
	{					/* uniform map). */
	int	w, v, u;
	double  summ, entt, vall;
	
	summ = 0.0;
        for ( w=1 ; w <= grid_z ; w++ )
        for ( v=1 ; v <= grid_x ; v++ )
        for ( u=1 ; u <= grid_y ; u++ )
		summ += PriorA_1[w][v][u];

	entt = 0.0;
        for ( w=1 ; w <= grid_z ; w++ )
        for ( v=1 ; v <= grid_x ; v++ )
        for ( u=1 ; u <= grid_y ; u++ )
                {
                        vall = PriorA_1[w][v][u];
			entt += -( vall / summ ) * log( vall / summ );
				}
	ent = entt;
	
	if ( cycle == 0 )
		lowest_entropy = ent;
	
	}





	/**************************************************************************************************************************/
	/**   Take transform of current prior.                                                                                   **/
	/**************************************************************************************************************************/
#ifdef PARALLEL
	rfftwnd_threads_one_real_to_complex( NOF_THREADS, p, (fftw_real *)(PriorA), NULL );
#else
	rfftwnd_one_real_to_complex( p, (fftw_real *)(PriorA), NULL );
#endif










	/**************************************************************************************************************************/
	/**   If about to finish, re-calc and save contribution of each reflection to chi**2 for data diagnostic purposes         */
	/**************************************************************************************************************************/

	if ( cycle > 0 && WILL_TEST == NO && (( TARGET_CHI > 0.0 && (chi_p-d_chi) < TARGET_CHI ) || (chi_p-d_chi) < (nof_obs)) )
	{

	HAVE_CHI_TABLE = YES ;

	if ( HAVE_FOM == NO )
	{
	chitable = 0;
	for ( w = 1; w <= grid_z ; w++ )
	   for ( v = 1; v <= grid_x ; v++ )
		for ( u = 1; u <  grid_y ; u += 2 )
			{
				if ( (int)(SigF_1[w][v][u]) != 0 )
					{
					s  = SigF_1[w][v][u];
					ac = PriorA_1[w][v][u];
					bc = PriorA_1[w][v][u+1];
					ao = Fobs_1[w][v][u];
					bo = Fobs_1[w][v][u+1];
					amp1 = sqrt( ac*ac + bc*bc );
					amp2 = sqrt( ao*ao + bo*bo );
					chipointers[chitable][0] = w;
					chipointers[chitable][1] = v;
					chipointers[chitable][2] = u;
					chicontrib[chitable++] = ( amp1 - amp2 ) / s;
                                        							}
 													}
	}
	else
	{
	chitable = 0;
	for ( w = 1; w <= grid_z ; w++ )
	   for ( v = 1; v <= grid_x ; v++ )
		for ( u = 1; u <  grid_y ; u += 2 )
			{
			if ( PHASELESS && ( (int)(SigF_1[w][v][u]) < 0 ) )
			{

					s  = fabs(SigF_1[w][v][u]);
					ac = PriorA_1[w][v][u];
					bc = PriorA_1[w][v][u+1];
					ao = Fobs_1[w][v][u];
					bo = Fobs_1[w][v][u+1];
					amp1 = sqrt( ac*ac + bc*bc );
					amp2 = sqrt( ao*ao + bo*bo );
					chipointers[chitable][0] = w;
					chipointers[chitable][1] = v;
					chipointers[chitable][2] = u;
					chicontrib[chitable++] = ( amp1 - amp2 )  / s;
			}
			else

				if ( (int)(SigF_1[w][v][u]) != 0 )		
					{	

					s  = fabs(SigF_1[w][v][u]);
					ac = PriorA_1[w][v][u];
					bc = PriorA_1[w][v][u+1];
					ao = Fobs_1[w][v][u];
					bo = Fobs_1[w][v][u+1];
					amp1 = sqrt( ac*ac + bc*bc );
					amp2 = sqrt( ao*ao + bo*bo );
					chipointers[chitable][0] = w;
					chipointers[chitable][1] = v;
					chipointers[chitable][2] = u;
					chicontrib[chitable++] = ( amp1 - amp2 ) / s;
			
                                        							}
 													}
	
	}
	}







	/**************************************************************************************************************************/
	/**   Calculate chi**2 & update FT(prior)                                                                                **/
	/**************************************************************************************************************************/
	if ( HAVE_FOM == NO )
	{
	sum1 = 0.0;
	sum2 = 0.0;
	for ( index = 0 ; index < gridprod ; index += 2 )
		{
			if ( (int)(SigF[index]) != 0 )
				{
					s  = SigF[index];
					s *= s;
					ac = PriorA[index];
					bc = PriorA[index+1];
					ao = Fobs[index];
					bo = Fobs[index+1];
					amp1 = sqrt( ac*ac + bc*bc );
					amp2 = sqrt( ao*ao + bo*bo );
					sum1 += ( amp1 - amp2 ) * ( amp1 - amp2 ) / s;
					sum2 += fabs( fabs( amp2 ) - fabs( amp1 ));
					PriorA[index]   = ( ao - ac ) / s;
					PriorA[index+1] = ( bo - bc ) / s;
                                        							}
			else
				{
					PriorA[index] 	= 0.0;
					PriorA[index+1] = 0.0;
									}

 													}
	}
	else
	{
	sum1 = 0.0;
	sum2 = 0.0;
	phase_diff = 0.0;
	for ( index = 0 ; index < gridprod ; index += 2 )
		{
			if ( PHASELESS && (int)(SigF[index]) < 0 )
			{

					s   = fabs(SigF[index]);
					s  *= s;
					sph = SigF[index+1];
					ac = PriorA[index];
					bc = PriorA[index+1];
					ao = Fobs[index];
					bo = Fobs[index+1];
					amp1 = sqrt( ac*ac + bc*bc );
					amp2 = sqrt( ao*ao + bo*bo );
					sum1 += ( amp1 - amp2 ) * ( amp1 - amp2 ) / s;
					sum2 += fabs( fabs( amp2 ) - fabs( amp1 ));

					if ( cycle )
						{
							ao = ac * amp2 / amp1;
							bo = bc * amp2 / amp1;
										}
							
					PriorA[index]   =  sph * ( ao - ac ) / s;  		/* We use the figure of merit to adjust */
					PriorA[index+1] =  sph * ( bo - bc ) / s;	     	/* how quickly we move towards |F| */

			}
			else
			if ( (int)(SigF[index]) != 0 )
				{
					

					s   = SigF[index];			/* This is sigma */
					sph = SigF[index+1];			/* and this is FOM */
					
					ac = PriorA[index];			/* real and imaginary components of prior */
					bc = PriorA[index+1];
					ao = Fobs[index];			/* and Fo */
					bo = Fobs[index+1];
					
					pho = atan2( bo, ao ); 			/* their phases */
					phc = atan2( bc, ac );
										/* and phase difference */
					phdif = acos( cos( pho - phc ));	/* take care of 2PI periodicity */
					phase_diff += phdif;
					
					amp1 = sqrt( ac*ac + bc*bc );		/* Finally, amplitudes */
					amp2 = sqrt( ao*ao + bo*bo );	
					
					sum1 += ( amp1 - amp2 ) * ( amp1 - amp2 ) / (s*s);
					sum2 += fabs( fabs( amp2 ) - fabs( amp1 ));

					sig2 = amp1 -amp2;
					sig1 = 1.0 + s *  exp( -(phdif/acos(sph))*(phdif/acos(sph))) * exp( - (sig2/s)*(sig2/s));
					sig1 *= sig1;
					if ( sig1 < 1.0 )
						sig1 = 1.0;
					
					PriorA[index]   = ( ao - ac ) /  sig1;
					PriorA[index+1] = ( bo - bc ) /  sig1;
					
                                        							}
			else
				{
					PriorA[index]   = 0.0;
					PriorA[index+1] = 0.0;
									}

 													}
	
	}






	/**************************************************************************************************************************/
	/**   Info													          */
	/**************************************************************************************************************************/


        if ( verbose == YES )
		{
		if ( SHOW_ENTROPY == NO )
		{
		if (HAVE_FOM == NO)
			printf("\n Chi**2 : % 15.3f     R : %6.4f       Lambda : % 12.5f       Nobs : % 7d ", 
								sum1, (sum2/sumFo), lambda , (int)(nof_obs) );
  		else
			printf("\n Chi**2 : % 15.3f     R : %6.4f       DeltaPhi : % 8.3f       Lambda : % 12.5f       Nobs : % 7d ", 
									sum1, (sum2/sumFo), 180.0*phase_diff / (PI*(nof_obs/2+axial/2)), 
									lambda , (int)(nof_obs) );
		}
		else
		{
		if (HAVE_FOM == NO)
			printf("\n Chi**2 : % 15.3f     R : %6.4f       Lambda : % 12.5f       Nobs : % 7d     Ent : %8.6f ", 
								sum1/nof_obs, (sum2/sumFo), lambda , (int)(nof_obs), ent );
  		else
			printf("\n Chi**2 : % 15.3f     R : %6.4f       DeltaPhi : % 8.3f       Lambda : % 12.5f       Nobs : % 7d     Ent : %8.6f ", 
									sum1, (sum2/sumFo), 180.0*phase_diff / (PI*(nof_obs/2+axial/2)), 
									lambda , (int)(nof_obs), ent );
		
		}
		
		

		if ( WILL_TEST == NO && cycle % 4 == 0 && ent > lowest_entropy && sum1 < chi_p )
		{
		
		
		fprintf(stderr, "\n\033[35m[1mCAUTION : \033[31m\033[1mEntropy of current prior is higher than the last noted value.\033[0m"); 
		lowest_entropy = ent;

		if ( PLOT_ZEROED == NO && DO_PLOT_ZEROED == YES )
		{
		plot_zero_val = MAXFLOAT;
		for ( index = 0 ; index < gridprod ; index++ )
			if ( PriorB[index] < plot_zero_val )
				plot_zero_val = PriorB[index];
		fprintf(stderr, "\n\033[35m[1mCAUTION : \033[31m\033[1mPlotting of low density areas has been enabled.\033[0m"); 	
		}


		PLOT_ZEROED = YES;
		}
		
		
		if ( WILL_TEST == NO && ent < lowest_entropy && sum1 < chi_p )
			lowest_entropy = ent;
					
		
		
		
		}


	if ( verbose == NO && cycle%VERB_INTERVAL == 0 && WILL_TEST == NO )
		{
		if ( SHOW_ENTROPY == NO )
		{
		if (HAVE_FOM == NO)
			printf("\n Chi**2 : % 15.3f     R : %6.4f       Lambda : % 12.5f       Nobs : % 7d ", 
								sum1, (sum2/sumFo), lambda , (int)(nof_obs) );
  		else
			printf("\n Chi**2 : % 15.3f     R : %6.4f       DeltaPhi : % 8.3f       Lambda : % 12.5f       Nobs : % 7d ", 
									sum1, (sum2/sumFo), 180.0*phase_diff / (PI*(nof_obs/2+axial/2)), 
									lambda , (int)(nof_obs) );
		}
		else
		{
		if (HAVE_FOM == NO)
			printf("\n Chi**2 : % 15.3f     R : %6.4f       Lambda : % 12.5f       Nobs : % 7d     Ent : %8.6f ", 
								sum1, (sum2/sumFo), lambda , (int)(nof_obs), ent );
  		else
			printf("\n Chi**2 : % 15.3f     R : %6.4f       DeltaPhi : % 8.3f       Lambda : % 12.5f       Nobs : % 7d     Ent : %8.6f ", 
									sum1, (sum2/sumFo), 180.0*phase_diff / (PI*(nof_obs/2+axial/2)), 
									lambda , (int)(nof_obs), ent );
		
		}

		
		
		if ( ent > lowest_entropy && PLOT_ZEROED == NO && sum1 < chi_p )
		{

		fprintf(stderr, "\n\033[35m[1mCAUTION : \033[31m\033[1mEntropy of current prior is higher than the last noted value.\033[0m");
		fprintf(stderr, "\n\033[35m[1mCAUTION : \033[31m\033[1mFurther occurences will not be reported.\033[0m\n"); 
		lowest_entropy = ent;


		if ( PLOT_ZEROED == NO && DO_PLOT_ZEROED == YES )
		{
		plot_zero_val = MAXFLOAT;
		for ( index = 0 ; index < gridprod ; index++ )
			if ( PriorB[index] < plot_zero_val )
				plot_zero_val = PriorB[index];
		fprintf(stderr, "\n\033[35m[1mCAUTION : \033[31m\033[1mPlotting of low density areas has been enabled.\033[0m"); 	
		}



		PLOT_ZEROED = YES;
		}
		
		
		if ( ent < lowest_entropy && sum1 < chi_p )
			lowest_entropy = ent;
					
		

		}
	
	



	
	




	/*********************************************************************************************************************************/
	/**  A quick death														**/
	/*********************************************************************************************************************************/

	if ( cycle == 0 && (( TARGET_CHI > 0.0 && sum1 < TARGET_CHI ) || (TARGET_CHI < 0.0 && sum1 <= nof_obs )))
		{
			fprintf(stderr, "\n\n\n\n\n\n\n\n\n\033[31m\033[1mThe input data are consistent with a uniform map.\033[0m\n\n\n");
			exit(1);
					}





	/**************************************************************************************************************************/
	/**   Save current prior so that we can go back if iteration gets out of control				          */
	/**************************************************************************************************************************/

	if ( cycle > 2 && sum1 < chi_p )
		{
			backup_chi = chi_p;
			memcpy( Back, PriorB, grid_bytes );
					}

  




	/*********************************************************************************************************************************/
	/**  Switching to phaseless mode. Unfortunately, we have to reload everything on the Fobs and sigma arrays			**/
	/*********************************************************************************************************************************/


	if ( SWITCH > 0.0 && HAVE_FOM && (sum2/sumFo) <= SWITCH && WILL_TEST == NO )
	{
	int i;
	

	SWITCH = -1.0;
	PHASELESS = YES;
	FALSE_ALARM = YES;
	


	
	printf("\n \033[31mSwitching to phaseless mode ...\033[0m\n");


	for ( i=0 ; i < gridprod ; i++ )
		{
			Fobs[i] = 0.0;
			SigF[i] = 0.0;
					}
						

	/* Repeating code I'm afraid ... */
	
	for ( i=0 ; i < total_number_of_obs ; i++ )
		{
										
			A = refl[i][3] * cos ( PI * refl[i][5] / 180.0 );	/* Real and imaginary */
			B = refl[i][3] * sin ( PI * refl[i][5] / 180.0 );
			w = refl[i][ iuvw[2] -1 ];				/* u,v,w are the coordinates of the reflection */ 
			v = refl[i][ iuvw[1] -1 ];				/* in the FFT array */
			u = 2*refl[i][ iuvw[0] -1 ] +1;
			
			if ( v < 0 )						/* The data structure for FFTW is described in its */
				v = grid_x + v;					/* manual, but the general idea is very similar to */
			if ( w < 0 )						/* the one seen in NR */
				w = grid_z + w;
			v++;
			w++;
			
			Fobs_1[w][v][u]     = A;
			Fobs_1[w][v][u+1]   = B;
			if ( refl[i][4] > 1.0 )
				SigF_1[w][v][u]     = -refl[i][4];
			else
				SigF_1[w][v][u] = -1.0;				/* We will use fom to adjust speed of convergence */
			SigF_1[w][v][u+1]   = refl[i][6];
			}



	sum1 = 0.0;
	for ( index = 0 ; index < gridprod ; index += 2 )
			{

					s   = fabs(SigF[index]);
					s  *= s;
					sph = SigF[index+1];
					ac = PriorA[index];
					bc = PriorA[index+1];
					ao = Fobs[index];
					bo = Fobs[index+1];
					amp1 = sqrt( ac*ac + bc*bc );
					amp2 = sqrt( ao*ao + bo*bo );
					sum1 += ( amp1 - amp2 ) * ( amp1 - amp2 ) / s;
					sum2 += fabs( fabs( amp2 ) - fabs( amp1 ));
						}


	memcpy( PriorA, Back, grid_bytes);
	memcpy( PriorB, Back, grid_bytes);

							

	chi_p = sum1;
	backup_chi = sum1;
	cycle = 0;


	}
	else
	{






	/**************************************************************************************************************************/
	/**   Take transform of it, normalise, multiply with lambda, exponentiate, multiply with prior				 **/
	/**************************************************************************************************************************/
#ifdef PARALLEL
	rfftwnd_threads_one_complex_to_real( NOF_THREADS, pinv, (fftw_complex *)(&PriorA_1[1][1][1]), NULL );
#else
	rfftwnd_one_complex_to_real( pinv, (fftw_complex *)(&PriorA_1[1][1][1]), NULL );
#endif

	for ( index = 0 ; index < gridprod ; index++ )
              	PriorA[index] *= norm;


	for ( index = 0 ; index < gridprod ; index++ )
		{
			val = PriorA[index];
			PriorA[index] = PriorB[index] * exp(lambda * val);

											}






	/**************************************************************************************************************************/
	/**   This is for the case we run maxent() in order to determine a suitable initial lambda value		         **/
	/**************************************************************************************************************************/
	if ( WILL_TEST == YES )
		{
			if ( chi_p == 0.0 )
				;
			else
				{
					d_chi = chi_p - sum1;
					if ( d_chi < 0.0 )
						{
						free_f3tensor( PriorB_1, 1, grid_z, 1, grid_x, 1, grid_y+2 );
						free_f3tensor( Backup, 1, grid_z, 1, grid_x, 1, grid_y+2 );
						return( d_chi );
						}
					else
						if ( cycle > 3 || d_chi == 0.0)
						{
						free_f3tensor( PriorB_1, 1, grid_z, 1, grid_x, 1, grid_y+2 );
						free_f3tensor( Backup, 1, grid_z, 1, grid_x, 1, grid_y+2 );
						return( 1.0 );
						}
									}
										}
										














	/**************************************************************************************************************************/
	/**   Reach target ? If not update d_chi for determining next lambda                                                     **/
	/**************************************************************************************************************************/
	if ( TARGET_CHI > 0.0 )
		{
			if ( sum1 < TARGET_CHI && HAVE_CHI_TABLE == YES )
				{
        				converged = YES;
					break;
							}
								}
	else	
	if ( sum1 < (nof_obs) && HAVE_CHI_TABLE == YES )
		{
        		converged = YES;
			break;
						}


	if ( HAVE_TIME > 0 && cycle%VERB_INTERVAL == 0 )
		{
			ttest = time(NULL);
			if ( (ttest - tstart) > HAVE_TIME )
				{
					printf("\n\n\n\n\n\n\n Timed-out (keyword TIME). Exit.\n\n");
					converged = YES;
					break;
						}
							}
							



	if ( chi_p == 0.0 )
		;
	else
		d_chi = chi_p - sum1;
	

	if ( d_chi == 0.0  )		
		{
			printf("\n\n\n\n\n\n  Failed to reach convergence. Run the program again with\n");
			printf("  a different starting value for lambda (keyword LAMBDA).\n\n\n\n"); 
			converged = NO;
			break;
					}


/*
	if ( FALSE_ALARM == YES && d_chi > 0.0 )
		FALSE_ALARM = NO;
*/

	cycle++;





	/*********************************************************************************************************************************/
	/**  The iteration get out of control. Go back and decrease lambda								**/
	/*********************************************************************************************************************************/

	if (  d_chi < 0.0 )
		{
		
						/* This can not happen in the automatic lambda determination mode (hopefully). */
		if ( cycle < 4 && FALSE_ALARM == NO )
			{
				fprintf(stderr, "\n\n\n\033[31m\033[1mThe starting value of lambda is too large. Reduce and re-run.\033[0m\n\n\n");
				exit(1);
						}

		if ( FALSE_ALARM == YES )
			{
				cycle  = 0;
						}
			


		/*****************************************************************************************************************/
		/**    Go back                                                                                                  **/
		/*****************************************************************************************************************/
		memcpy( PriorA, Back, grid_bytes );
		memcpy( PriorB, Back, grid_bytes );

					
		if ( con_lambda == YES )
			lambda *= (double)(0.900000);
		else
			{
				con_lambda = YES;
				lambda *= (double)(0.900000);
							}


	        if ( verbose == YES )
			printf(" *** "); 		


		chi_p = backup_chi;

						}

	else
	{
	/**************************************************************************************************************************/
	/**    Copy new prior.                                                                                                   **/
	/**************************************************************************************************************************/
	memcpy( PriorB, PriorA, grid_bytes );

	chi_p = sum1;
	}
	
	
									}
	

        	 								}


	if ( DO_PLOT == YES && WILL_TEST == NO )
		{
		if ( GRAPH_WAIT == YES )
			printf("\n");

		sprintf( pgtitle, "Maxent map");

		DO_CALC_RMS = YES;
		plot_section( pgtitle, PriorA_1, grid_z, grid_x, grid_y);
	
		if ( VT125 == YES )
			{
				while ( getchar() == EOF )
					;
						}
							
		

		}


	tend = time(NULL);
	printf("\n\n\033[33m Chi**2 : % 15.3f     R : %6.4f       Lambda : % 12.5f       Nobs : % 7d \033[0m\n", 
							sum1, (sum2/sumFo), lambda , (int)(nof_obs) );
	printf("\033[33m %d cycles in %d seconds, giving an average of %5.3f seconds per cycle.\033[0m\n", cycle, (tend-tstart), 
				(float)(tend-tstart)/cycle );


	free_f3tensor( PriorB_1, 1, grid_z, 1, grid_x, 1, grid_y+2 );
	free_f3tensor( Backup, 1, grid_z, 1, grid_x, 1, grid_y+2 );

	return( (converged==YES)?(sum2/sumFo):(-(sum2/sumFo)) );

}































































































/*********************************************************************************************************************************/
/** Write out the map in one of the three available formats : ASCII, NA4, CCP4						 	**/
/*********************************************************************************************************************************/

void	write_map( title, data, slow, med, fast, iuvw, mode, details )
char	*title[];
float	***data;
int	iuvw[3];
int	slow;
int	med;
int	fast;
int	mode;
char 	*details;
{
	FILE	*file;
	int	u, v, w;
	float	val;
	int	x, y, z;
	float	min, max, mean, rms;
	float	scale, plus;
	int	m;
	int	INDXR4_1, INDXR4_2;
	int	I, J, N;
	float	A, P;
	char 	string[4];
	int	mxyz[3];
	char	ntitle[82];
	double	sum, ent;






	for ( m = 0 ; m <= strlen( &details[0] ) ; m++ )
		if ( details[m] == '\n' )
			details[m] = 0;



	/*********************************************************************************************************************************/
	/**  Calculate map statistics, scale to a maximum of 999									**/
	/*********************************************************************************************************************************/
			

        max  = data[1][1][1];
	mean = 0.0;
        for ( w=1 ; w <= slow ; w++ )
        for ( v=1 ; v <= med  ; v++ )
        for ( u=1 ; u <= fast ; u++ )
		{
		val = data[w][v][u];
                if ( val > max )
			max = val;
		mean += val;
				}
	printf(" - Sum and average of densities are %12.4f and %12.4f.\n", mean, mean / (slow*med*fast) );
	

	scale = 999.0 / max;
	printf(" - Scale factor applied : %15.8f.\n", scale );
        for ( w=1 ; w <= slow ; w++ )
        for ( v=1 ; v <= med  ; v++ )
        for ( u=1 ; u <= fast ; u++ )
		data[w][v][u] *= scale;		
		


        min  = data[1][1][1];
        max  = min;
        mean = 0.0;
        rms  = 0.0;
        for ( w=1 ; w <= slow ; w++ )
        for ( v=1 ; v <= med  ; v++ )
        for ( u=1 ; u <= fast ; u++ )
                {
                        val = data[w][v][u];
                        if ( val > max )
                                max = val;
                        if ( val < min )
                                min = val;
                        mean += val;
                                                }
        mean /= (float)(slow*med*fast);

        for ( w=1 ; w <= slow ; w++ )
        for ( v=1 ; v <= med  ; v++ )
        for ( u=1 ; u <= fast ; u++ )
                {
                        val = data[w][v][u];
			rms += ( val - mean ) * ( val - mean );
				}
        rms = (float)(sqrt( rms / (double)(slow*med*fast - 1.0)));





	/*********************************************************************************************************************************/
	/**  Calculate relative entropy of map 												**/
	/*********************************************************************************************************************************/

	if ( min >= 0.0000 )
	{
	sum = 0.0;
        for ( w=1 ; w <= slow ; w++ )
        for ( v=1 ; v <= med  ; v++ )
        for ( u=1 ; u <= fast ; u++ )
		sum += 	data[w][v][u];

	ent = 0.0;
        for ( w=1 ; w <= slow ; w++ )
        for ( v=1 ; v <= med  ; v++ )
        for ( u=1 ; u <= fast ; u++ )
                {
                        val = data[w][v][u];
			ent += -( val / sum ) * log( val / sum );
				}
	printf(" - Map entropy is %f.\n\n", ent );
	}
	else
	{
		printf(" - Map entropy is undefined (negative values are present).\n\n");
		
	}	






			
	/*********************************************************************************************************************************/
	/**  NA4 format.														**/
	/*********************************************************************************************************************************/


	if ( MAP_FORMAT == NA4_MAP )
	{

	/* Re-writing FORTRAN ... */
	

	A = max2( fabs(min), fabs(max));
	P = 24.0 - log( A ) / log( 2.0 );
	if ( P < 0.0 )
		I = P - 1;
	else
		I = P;
	
	if ( I == 0 )
		N = A;
	else
		if ( I == 1 )
			N = 2 * A;
		else
			N = A * ( 2 << (I-1));
	
	if ( N < (2 << 22)) 
		I = I + 1;
	else
	if ( N > (2 << 23))
		I = I - 1;
		

	N = 0;
	if ( min < 0.0 )
		N = N - 1;
	else
		if ( min > 0.0 )
			N = N + 1;
	if ( max < 0.0 )
		N = N - 1;
	else
		if ( max > 0.0 )
			N = N + 1;
		
	INDXR4_1 = N;
	if ( N == 0 )
		INDXR4_2 = I - 1;
	else
		INDXR4_2 = I;
	
	


	file = fopen( title[0], "w" );
	if ( file == NULL )
		{
			fclose ( file );
			printf("Failed to create the output map file.\n\n\n");
			exit( 0 );
						}


	if ( iuvw[0] == 1 )
		x = fast;
	if ( iuvw[0] == 2 )
		y = fast;
	if ( iuvw[0] == 3 )
		z = fast;
	if ( iuvw[1] == 1 )
		x = med;
	if ( iuvw[1] == 2 )
		y = med;
	if ( iuvw[1] == 3 )
		z = med;
	if ( iuvw[2] == 1 )
		x = slow;
	if ( iuvw[2] == 2 )
		y = slow;
	if ( iuvw[2] == 3 )
		z = slow;


	fprintf(file, "MAPTONA4 HEADER\n");
	fprintf(file, "TITLE   \n");
	fprintf(file, "%s\n", &details[0]);
	fprintf(file, "AXIS           %c       %c       %c\n", 'X'+iuvw[0]-1, 'X'+iuvw[1]-1, 'X'+iuvw[2]-1 );
	fprintf(file, "GRID       % 5d   % 5d   % 5d\n", x, y, z);
	fprintf(file, "XYZLIM         0   % 5d       0   % 5d       0   % 5d\n", x-1, y-1, z-1);
	fprintf(file, "SPACEGROUP          % 4d\n",spacegroup);
	fprintf(file, "MODE           %d\n", mode);
	fprintf(file, "CELL    % 10.3f% 10.3f% 10.3f% 10.3f% 10.3f% 10.3f\n",cell[0],cell[1],cell[2],cell[3],cell[4],cell[5]);
	fprintf(file, "RHOLIM% 16.6f% 16.6f% 16.6f% 16.6f\n", min, max, mean, rms);
	fprintf(file, "INDXR4  % 4d% 4d\n", INDXR4_1, INDXR4_2);
	fprintf(file, "END HEADER\n");


        for ( w=1 ; w <= slow ; w++ )
	{
	fprintf( file , "\nSECTION% 8d\n\n", w-1 );
	
        for ( v=1 ; v <= med  ; v++ )
        for ( u=1 ; u <= fast ; u += 20 )
                {
			for ( m=u ; m < ( fast < (u+20) ? fast+1 : u+20 ) ; m++ )
				{
				tona4( &string[0], data[w][v][m], INDXR4_1, INDXR4_2);
				fprintf(file,"%c%c%c%c", string[0], string[1], string[2], string[3]);
				}
			fprintf(file, "\n");
					}
						}
						
			
			
			



	fclose(file);

	}
	else


	/*********************************************************************************************************************************/
	/**  ASCII map 															**/
	/*********************************************************************************************************************************/
	if ( MAP_FORMAT == ASCII_MAP )
	{
	
	file = fopen( title[0], "w" );
	if ( file == NULL )
		{
			fclose ( file );
			printf("Failed to create the output map file.\n\n\n");
			exit( 0 );
						}
	
	for ( w = 1; w <= slow ; w++ )
	{
	fprintf(file, "\n");
	for ( v = 1; v <= med  ; v++ )
	{
	fprintf(file, "\n");
	for ( u = 1; u <= fast ; u++ )
		fprintf(file, " % 8.3f", data[w][v][u] );
							}
								}
	printf("\n");
	fclose(file);
	}
	else



	/*********************************************************************************************************************************/
	/**  Binary CCP4 														**/
	/*********************************************************************************************************************************/
	if ( MAP_FORMAT == CCP4_MAP )
	{
#ifndef NOCCP4	
	int 	unit, ist;
	int	nw1, nu1, nu2, nv1, nv2;
	float	***inter;
	int	mindx, iprint ;	
	


	if ( iuvw[0] == 1 )
		x = fast;
	if ( iuvw[0] == 2 )
		y = fast;
	if ( iuvw[0] == 3 )
		z = fast;
	if ( iuvw[1] == 1 )
		x = med;
	if ( iuvw[1] == 2 )
		y = med;
	if ( iuvw[1] == 3 )
		z = med;
	if ( iuvw[2] == 1 )
		x = slow;
	if ( iuvw[2] == 2 )
		y = slow;
	if ( iuvw[2] == 3 )
		z = slow;	


#ifndef NONEWCCP4
        mindx = -1;
        iprint = -1;
	ccp4h_init_lib_( &mindx, &iprint );
#endif
		
	unit = 1;
	ist  = 24;
	mxyz[0] = x;
	mxyz[1] = y;
	mxyz[2] = z;
	nw1 = 0;
	nu1 = 0;
	nu2 = fast-1;
	nv1 = 0;
	nv2 = med-1;

	strncpy( &ntitle[0], &details[0], 80 );

	mwrhdl_( &unit, title[0], ntitle, &slow, &iuvw[0], &mxyz[0], &nw1, &nu1, &nu2, &nv1, &nv2, &cell[0], 
			&spacegroup, &mode, strlen( title[0] ), 80 );
	msyput_( &ist, &spacegroup, &unit );
	inter = f3tensor( 1, 1, 1, med, 1, fast );
	for ( w = 1; w <= slow ; w++ )
		{
	        for ( v=1 ; v <= med  ; v++ )
	        for ( u=1 ; u <= fast ; u++ )
		inter[1][v][u] = data[w][v][u];

		mspew_( &unit, &inter[1][1][1] );
			}
	
	free_f3tensor( inter,  1, 1, 1, med, 1, fast );
	
	mwclose_( &unit );
	
#endif
	}

}











/*********************************************************************************************************************************/
/** Oops														 	**/
/*********************************************************************************************************************************/	

void 	abortp()
{


	if ( HAVE_CCP4 == YES )
	{
        fprintf(stderr, "\n\n\n\033[31mUsage :   %s [<ascii file name>]\033[0m\n", called );
        fprintf(stderr, "\033[31m          %s [zone] [<low_res> <high_res>] <CCP4 mtz file>\033[0m\n", called );
        fprintf(stderr, "\033[31m          where {zone} = {H00,0K0,00L,HH0,-HH0,HHH,HK0,0KL,H0L,HHL}.\033[0m\n\n\n\n\n");
	}
	else
	{
        fprintf(stderr, "\n\n\n\033[31mUsage :   %s [<ascii file name>]\033[0m\n\n\n\n\n", called );
	}
	
	exit(1);
}








/*********************************************************************************************************************************/
/** Hmm...														 	**/
/*********************************************************************************************************************************/

void 	extram()
{

	printf("\033[35m    Note well (i) : The axes permutation must be chosen in such a way   \n");
	printf("   		    that the fast index is always positive or zero.     \n");
	printf("                    To avoid problems, use the CCP4 convention (as      \n");
	printf("		    described below) with PERM 3 1 2 or 3 2 1.          \n");
	printf("    Note well (ii): If you expanded the data to P1 (using CAD ?), then  \n");
	printf("                    reflections that belong to the same hemisphere but  \n");
	printf("                    related by the inverion centre will, naturally, be  \n");
	printf(" 		    absent. The program needs these reflections and     \n");
	printf("  		    will generate them if they are not present. The 	 \n");
	printf("		    convention assumed is the same as for CCP4, namely  \n");
	printf("		    hkl : l>=0,      hk0 : h>=0,       0k0 : k>=0       \033[0m\n");
	
	
	printf("\n\n\n\n\n");
}



















	
	
/* Re-writing FORTRAN : routine from maptona4 (Phil Evans), originally due to Ian Tickle, Birkbeck. */

void tona4( string, val, INDXR4_1, INDXR4_2)
char 	*string;
float	val;
int	INDXR4_1, INDXR4_2;
{

	int 	I, J, M, N;
	const char	CHRTAB[65] = "0123456789-+ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
	
	
	if ( val == 0.0 )
		strncpy( string, "0000", 4);
	
	else
		{
			if ( INDXR4_2 == 0 )
				N = nearint( fabs(val) );
			else
			if ( INDXR4_2 == 1 )
				N = nearint( 2 * fabs(val) );
			else
				N = nearint( fabs(val) * ( 2 << (INDXR4_2-1)) );
			
			if ( INDXR4_1 == 0 )
				M = 2 << 22;
			else
				M = 2 << 23;
			
			if ( N == M )
				N = M - 1;
			else
			if ( N > M )
				{
				strncpy( string, "****", 4);
				return;
				}
			
			if ( INDXR4_1 == 0 && val < 0.0 )
				N = ( 2 << 23 ) - N;
			
			for ( I=4 ; I >= 1 ; I-- )
				{
					M = N / 64;
					J = N - 64*M;
					string[I-1] = CHRTAB[J];
					N = M;
						}
							}
	return;
}






void	plot_section( title, data, slow, med, fast)
char	*title;
float	***data;
int	slow;
int	med;
int	fast;
{
	int	u, v, w;
	float	val;
	int	x, y, z;
	int 	i, j, k, lw, ci, ls;
	float	min, max, mean, rms;
	float	scale, plus;
	int	m;
	float	alev;
	float	j1, j2, j3, j4;
	float	***inter;
	float	*faster;
	int	nof_contours;

	float	OneD[10000];
	int	nof_points;
	float	u1d, v1d;
	float	whole_rms;
	float	whole_mean;	
	float	x1,y1,x2,y2;	
	int	gridprod;

	if ( HAVE_PGPLOT == NO )
		return;
	

	
	if ( DO_CALC_RMS == YES )
		{
		whole_mean = 0.0;
		faster = &data[1][1][1];
		
		for ( w=0 ; w < slow  ; w++ )
		for ( v=0 ; v < med  ; v++ )
		for ( u=0 ; u < fast ; u++ )
			whole_mean += faster[w*med*(fast+2) + v*(fast+2) + u];
		
		whole_mean /= (float)(slow*med*fast);
		
		whole_rms = 0.0;
		for ( w=0 ; w < slow  ; w++ )
		for ( v=0 ; v < med  ; v++ )
		for ( u=0 ; u < fast ; u++ )
			whole_rms += ( faster[w*med*(fast+2) + v*(fast+2) + u] - whole_mean ) * ( faster[w*med*(fast+2) + v*(fast+2) + u] - whole_mean );
		
		whole_rms = sqrt( whole_rms / (float)(slow*med*fast) );
		
		}



#ifndef NOPGPLOT
	inter = f3tensor( 1, 1, 1, med, 1, fast );
	w = nearint( slow * GRAPH_SECTION) + 1;


	cpgbbuf();
	

							/* Attempt to add support for 1D data */	
	if ( DO_1D == YES )
	{
	float	y1min, y1max;
	int	nof_steps;
	
		

	cpgswin( 0.0, 1.0, 0.0, 1.0 );

							/* copy section data */
	for ( v=1 ; v <= med  ; v++ )
	for ( u=1 ; u <= fast ; u++ )
		inter[1][v][u] = data[w][v][u];

							/* The user defines direction as a zone axis [u v] in the frame */
							/* of the permuted axes ie. the first number is along fast, the */
							/* second along the medium axis. Easy for us but not the user.  */		
							/* These number are given on input as U_1D and V_1D  */
	
	
	
	
							/* Number of steps to divide one period along this axis */
	nof_steps = (int)(sqrt(U_1D*U_1D+V_1D*V_1D) * max2( med, fast ));

	nof_points = 0;
	
	if ( fabs(U_1D) >= fabs(V_1D) )
	{
	float	pu;
	float	pv;
	
	for ( u1d = 0.0 ; u1d <= fabs(U_1D)+0.2*fabs(U_1D) / nof_steps ; u1d += fabs(U_1D) / nof_steps )
		{
		if ( U_1D < 0.0 )
			pu = -1.0 * u1d;
		else
			pu = u1d;
			
		pv = u1d * V_1D / U_1D;
		
		pu += U_1START;
		pv += V_1START;
		
		OneD[nof_points] = lin_inter( inter, pv, pu, med, fast );
		
		nof_points++;
		if ( nof_points >= 9999 )
			{
				fprintf(stderr, "\n\n\n\033[31m\033[1mToo many points for the requested 1D distribution.\033[0m\n\n\n");
				exit(1);
						}
		}
	}
	else
	{
	float	pu;
	float	pv;
	
	for ( v1d = 0.0 ; v1d <= fabs(V_1D)+0.2*fabs(V_1D) / nof_steps ; v1d += fabs(V_1D) / nof_steps )
		{
		if ( V_1D < 0.0 )
			pv = -1.0 * v1d;
		else
			pv = v1d;
			
		pu = v1d * U_1D / V_1D;

		
		pu += U_1START;
		pv += V_1START;

		
		OneD[nof_points] = lin_inter( inter, pv, pu, med, fast );
		
		nof_points++;
		if ( nof_points >= 9999 )
			{
				fprintf(stderr, "\n\n\n\033[31m\033[1mToo many points for the requested 1D distribution.\033[0m\n\n\n");
				exit(1);
						}
		}
	}
	
	
	
							
	
	
	
					/* strange things do happen */
	if ( nof_points == 0 )
		{
			fprintf(stderr, "\n\n\n\033[31m\033[1mStrange zone axis definition. Aborting.\n\n\n\033[0m");
			exit(1);
					}
	
	
					/* Get mean & y limits */
	y1min =  100000000000000.0;
	y1max = -100000000000000.0;
	mean = 0.0;
	for ( i=0 ; i < nof_points ; i++ )
		{
			val = OneD[i];
			if ( val > y1max )
				y1max = val;
			if ( val < y1min )
				y1min = val;
			mean += val;
							}
		
				/* leave some space around the plot */
	if ( y1max > 0.0 )
		y1max *= 1.050;
	else
		y1max -= y1max * 0.050;
	
	if ( y1min < 0.0 )
		y1min *= 1.050;
	else
		y1min -= y1min * 0.050;
		
	
	
	mean /= (float)(nof_points);			
	

					/* Get sigma */	
	rms = 0.0;
	for ( i=0 ; i < nof_points ; i++ )
		{
			val = OneD[i];
			rms += ( val - mean ) * ( val - mean );
				}

        rms = (float)(sqrt( rms / (double)(nof_points)));

	
	
				
				/* strange things may happen */
	if ( rms == 0.0 )
		rms = 0.000000000000100;
	

	
	if ( DO_CALC_RMS == YES )
		{
			mean = whole_mean;
			rms  = whole_rms;
					}
					
	

	cpgpage();
	cpgsvp( 0.0 , 1.0 , 0.0 , 0.95 );
	cpgbox("bc", 4, 2, "bc", 4, 2);
	cpgmtxt("t", 1.0, 0.0, 0.0, title);


	cpgsci(11);
	cpgsls(4);
	cpgmove( 0.0, (mean-y1min)/(y1max-y1min) );
	cpgdraw( 1.0, (mean-y1min)/(y1max-y1min) );
	cpgsls(1);
		
	for ( i=1 ; i <= ((int)((y1max-mean)/rms)<10?(int)((y1max-mean)/rms):10) ; i++ )
	{
	cpgmove( 0.000, (mean+i*rms-y1min)/(y1max-y1min) );
	cpgdraw( 0.010, (mean+i*rms-y1min)/(y1max-y1min) );
	cpgmove( 0.490, (mean+i*rms-y1min)/(y1max-y1min) );
	cpgdraw( 0.510, (mean+i*rms-y1min)/(y1max-y1min) );
	cpgmove( 0.990, (mean+i*rms-y1min)/(y1max-y1min) );
	cpgdraw( 1.000, (mean+i*rms-y1min)/(y1max-y1min) );
	}



	if ( VT125 == YES )
	{

    	cpgslw(2);
    	cpgsls(1);
	
	cpgsci(8);
	
	cpgmove( 0.0, (OneD[0]-y1min)/(y1max-y1min) );
	for ( i=1 ; i < nof_points ; i++ )
		{
		cpgsci(17);
		cpgdraw( (float)(i) / (nof_points-1), (OneD[i]-y1min)/(y1max-y1min) );
		}

  	cpgslw(1);
  	cpgsls(1);
  	cpgsci(1);
	
	}
	else
	{

    	cpgslw(2);
    	cpgsls(1);
	
	cpgsci(8);
	cpgpt1( 0.0, (OneD[0]-y1min)/(y1max-y1min), 17 );

	cpgmove( 0.0, (OneD[0]-y1min)/(y1max-y1min) );
	for ( i=1 ; i < nof_points ; i++ )
		{
		cpgsci(17);
		cpgdraw( (float)(i) / (nof_points-1), (OneD[i]-y1min)/(y1max-y1min) );

		if ( PLOT_ZEROED == NO || DO_PLOT_ZEROED == NO )
		{
		cpgsci(8);
		cpgpt1( (float)(i) / (nof_points-1), (OneD[i]-y1min)/(y1max-y1min), 17 );
		}
		else
		{
		if ( OneD[i] < plot_zero_val )
		{
		cpgsci(6);
		cpgpt1( (float)(i) / (nof_points-1), (OneD[i]-y1min)/(y1max-y1min), 14 );
		}
		else
		{
		cpgsci(8);
		cpgpt1( (float)(i) / (nof_points-1), (OneD[i]-y1min)/(y1max-y1min), 17 );		
		}
		
		}
		
		
		}



  	cpgslw(1);
  	cpgsls(1);
  	cpgsci(1);
	}








									/* "Normal" 2D contour plots */	
	}
	else
	{
	int	ww;

	for ( v=1 ; v <= med  ; v++ )
	for ( u=1 ; u <= fast ; u++ )
		inter[1][v][u] = -1000000000000000000000000000000000000.0;


	for (ww=w ; ww <= ((w+NOF_SECTIONS_TO_PLOT) <= slow ? (w+NOF_SECTIONS_TO_PLOT) : slow) ; ww++ )
	for ( v=1 ; v <= med  ; v++ )
	for ( u=1 ; u <= fast ; u++ )
		if ( data[ww][v][u] > inter[1][v][u] )
			inter[1][v][u] = data[ww][v][u];

	faster = &inter[1][1][1];
	gridprod = med * fast;

        mean = 0.0000000000;
	max  = inter[1][1][1];
	for ( i=0 ; i < gridprod ; i++ )
		{
			val = faster[i];
			mean = mean + faster[i];
                        if ( val > max )
                                max = val;
				}

	mean = mean / (float)(gridprod) ;
        rms  = 0.0;
	for ( i=0 ; i < gridprod ; i++ )
                {
                        val = faster[i];
			rms += (val - mean)*(val - mean);
								}

        rms = (float)(sqrt( rms / (double)(med*fast - 1.0)));

	if ( DO_CALC_RMS == YES )
		{
			rms = whole_rms;
			mean = whole_mean;
				}
				

	if ( MAX_GRCONT > 0 )
		nof_contours = MAX_GRCONT;
	else
		nof_contours = ((int)(((max-mean-rms*FIRST_CONTOUR) / rms) / CONTOUR_LEVEL) +1) < 100 ? ((int)(((max-mean-rms*FIRST_CONTOUR) / rms) / CONTOUR_LEVEL) +1) : 100;
	
	
	cpgpage();

	cpgqvsz(1, &j1, &j2, &j3, &j4 );
	if (  (j4/j2) > aspect )
		{
			cpgsvp( 0.0000010 , 1.0 , 0.000000000000 , aspect / (j4/j2)  );
		}
	else
		{
			cpgsvp( 0.0000010 , (j4/j2) / aspect, 0.000000000000000 , 0.95 );
			
		}
		

	cpgmtxt("t", 1.0, 0.0, 0.0, title);
	cpgbox("bcts", (xmax-xmin)/2.0, 2, "bcts", (ymax-ymin)/2.0, 2);

	


	if ( GRAYSCALE == YES )
		cpggray( &inter[1][1][1], fast, med, 1, fast, 1, med, 4*rms+mean+ rms*FIRST_CONTOUR, mean+ rms*FIRST_CONTOUR, tr);
	



	/* Grid at 0, 0.25, 0.5, 0.75	*/
	
	cpgsls( 4 );
	cpgslw( 1 );
	cpgsci( 14 );
	cpgmove( tr[0] + tr[1]* 1.0  + tr[2] * (med*0.250 + 1.0),  tr[3] + tr[4]* 1.0  + tr[5] * (med*0.250 + 1.0) );
	cpgdraw( tr[0] + tr[1]* fast + tr[2] * (med*0.250 + 1.0),  tr[3] + tr[4]* fast + tr[5] * (med*0.250 + 1.0) );	

	cpgmove( tr[0] + tr[1]* 1.0  + tr[2] * (med*0.50 + 1.0),  tr[3] + tr[4]* 1.0  + tr[5] * (med*0.50 + 1.0) );
	cpgdraw( tr[0] + tr[1]* fast + tr[2] * (med*0.50 + 1.0),  tr[3] + tr[4]* fast + tr[5] * (med*0.50 + 1.0) );	
	
	cpgmove( tr[0] + tr[1]* 1.0  + tr[2] * (med*0.750 + 1.0),  tr[3] + tr[4]* 1.0  + tr[5] * (med*0.750 + 1.0) );
	cpgdraw( tr[0] + tr[1]* fast + tr[2] * (med*0.750 + 1.0),  tr[3] + tr[4]* fast + tr[5] * (med*0.750 + 1.0) );	

	cpgmove( tr[0] + tr[1]* (fast*0.250 + 1.0)  + tr[2] * 1.0,  tr[3] + tr[4]* (fast*0.250 + 1.0)  + tr[5] * 1.0 );
	cpgdraw( tr[0] + tr[1]* (fast*0.250 + 1.0)  + tr[2] * med,  tr[3] + tr[4]* (fast*0.250 + 1.0)  + tr[5] * med );	

	cpgmove( tr[0] + tr[1]* (fast*0.50 + 1.0)  + tr[2] * 1.0,  tr[3] + tr[4]* (fast*0.50 + 1.0)  + tr[5] * 1.0 );
	cpgdraw( tr[0] + tr[1]* (fast*0.50 + 1.0)  + tr[2] * med,  tr[3] + tr[4]* (fast*0.50 + 1.0)  + tr[5] * med );	

	cpgmove( tr[0] + tr[1]* (fast*0.750 + 1.0)  + tr[2] * 1.0,  tr[3] + tr[4]* (fast*0.750 + 1.0)  + tr[5] * 1.0 );
	cpgdraw( tr[0] + tr[1]* (fast*0.750 + 1.0)  + tr[2] * med,  tr[3] + tr[4]* (fast*0.750 + 1.0)  + tr[5] * med );	




	
	
	/* Contours */


    	for (i=0; i <= nof_contours ; i++) 
		{
		
    		alev = mean + rms*FIRST_CONTOUR + i*rms * CONTOUR_LEVEL;
		if ( alev > max )
			break;
			
    		lw = 1 ;
    		ls = (i==0)?4 :1;
    		cpgslw(lw);
    		cpgsci( i <= 10 ? i + 16 : 26);
    		cpgsls(ls);
    		cpgcont(&inter[1][1][1], fast, med, 1, fast, 1, med, &alev, -1, tr);
		}
  	cpgslw(1);
  	cpgsls(1);
  	cpgsci(1);
	}
	

	if ( PLOT_ZEROED == YES && DO_PLOT_ZEROED == YES )
	{
	
	cpgslw(1);	
	cpgsci(6);
	cpgsls(1);
	alev = plot_zero_val;
	cpgconf(&inter[1][1][1], fast, med, 1, fast, 1, med, 0.0000, alev, tr);
 	cpgslw(1);
  	cpgsls(1);
  	cpgsci(1);
	
	}
	


	free_f3tensor( inter,  1, 1, 1, med, 1, fast );

	cpgebuf();
	
#endif

	return;
}
	












float	lin_inter( data, v, u, med, fast)
float	***data;
float	v, u;
int	med;
int	fast;
{
	int 	i;
	int	vv, uu, vv1, uu1;
	float	vf, uf;
	float	a1, a2, a5, a6;


	i = (int)( max2(fabs(v), fabs(u)) +0.5)+1;
	v = med  * fmod( v + i, 1.000);
	u = fast * fmod( u + i, 1.000);

	vv = (int)(v);
	uu = (int)(u);
	
	vf = v - (float)(vv);
	uf = u - (float)(uu);
	
	vv++;
	uu++;
	
	
	if ( vv == med+1 )
		vv = 1;
	if ( uu == fast+1 )
		uu = 1;
	vv1 = vv + 1;
	uu1 = uu + 1;
	if ( vv1 == med+1 )
		vv1 = 1;
	if ( uu1 == fast+1 )
		uu1 = 1;
		

	a1 = data[1][vv ][uu ];
	a2 = data[1][vv ][uu1];
	a5 = data[1][vv1][uu ];
	a6 = data[1][vv1][uu1];

	return( vf*(uf*(a6-a5)+a5) + (1.0-vf)*(uf*(a2-a1)+a1) );



}



























/**********************************************************************************************************************************/
/**   Public domain  memory allocation routines from Numerical recipes.                                                          **/
/**********************************************************************************************************************************/

float *vector(long nl, long nh)
/* allocate a float vector with subscript range v[nl..nh] */
{
        float *v;

        v=(float *)malloc((size_t) ((nh-nl+1+NR_END)*sizeof(float)));
        if (!v) nrerror("allocation failure in vector()");
        return v-nl+NR_END;
}


void free_vector(float *v, long nl, long nh)
/* free a float vector allocated with vector() */
{
        free((FREE_ARG) (v+nl-NR_END));
}

void    	nrerror( char error_text[])
{
	fprintf(stderr, "\n\033[31m\033[1m%s\033[0m\n", &error_text[0] );
	exit( 1 );
}



float	**matrix( long nrl, long nrh, long ncl, long nch )
{
	long 	i, nrow=nrh-nrl+1, ncol=nch-ncl+1;
	float	**m;

	m = (float **)malloc((size_t)((nrow+NR_END)*sizeof(float*)));
	if (!m) nrerror("allocation failure 1 in matrix()");
	m += NR_END;
	m -= nrl;
	m[nrl] = (float *)malloc((size_t)((nrow*ncol+NR_END)*sizeof(float)));
	if (!m[nrl]) nrerror("allocate failure 2 in matrix()");
	m[nrl] += NR_END;
	m[nrl] -= ncl;

	for (i=nrl+1 ; i <= nrh ; i++ )
		m[i] = m[i-1] + ncol;

	return m;
}


float	***f3tensor(long nrl, long nrh, long ncl, long nch, long ndl, long ndh )
{
	long 	i, j, nrow=nrh-nrl+1, ncol=nch-ncl+1, ndep = ndh-ndl+1;
	float	***t;

	t=(float ***)malloc((size_t)((nrow+NR_END)*sizeof(float**)));
	if (!t) nrerror("allocation failure 1 in f3tensor()");
	t += NR_END;
	t -= nrl;

	t[nrl] = (float **)malloc((size_t)((nrow*ncol+NR_END)*sizeof(float *)));
	if ( !t[nrl] ) nrerror("allocation failure 2 in f3tensor()");
	t[nrl] += NR_END;
	t[nrl] -= ncl;
	
	t[nrl][ncl] = (float *)malloc((size_t)((nrow*ncol*ndep + NR_END)*sizeof(float)));
	if (!t[nrl][ncl] ) nrerror("allocation failure 3 in f3tensor()");
	t[nrl][ncl] += NR_END;
	t[nrl][ncl] -= ndl;

	for( j=ncl+1 ; j <= nch ; j++ )
		t[nrl][j] = t[nrl][j-1] + ndep;
	for ( i=nrl+1 ; i <= nrh ; i++ )
		{
		t[i] = t[i-1] + ncol;
		t[i][ncl] = t[i-1][ncl] + ncol * ndep;
		for ( j=ncl+1 ; j <= nch ; j++ )
			t[i][j] = t[i][j-1] + ndep;
                                              	}

	return t;
}





void free_matrix(float **m, long nrl, long nrh, long ncl, long nch)
/* free a float matrix allocated by matrix() */
{
        free((FREE_ARG) (m[nrl]+ncl-NR_END));
        free((FREE_ARG) (m+nrl-NR_END));
}


void free_f3tensor(float ***t, long nrl, long nrh, long ncl, long nch,
        long ndl, long ndh)
/* free a float f3tensor allocated by f3tensor() */
{
        free((FREE_ARG) (t[nrl][ncl]+ndl-NR_END));
        free((FREE_ARG) (t[nrl]+ncl-NR_END));
        free((FREE_ARG) (t+nrl-NR_END));
}




















/*********************************************************************************************************************************/
/** Normal probability plot calculation and plotting 									 	**/
/*********************************************************************************************************************************/


void	normprob( in )
FILE 	*in;
{

        char    j[200];
        float   **refl;
        float   *finpp;
	float	*plot1;
	int	saving[MAX_NOF_REFL];
        int     nref;
        int     i, m;
        int     step;
        float   aver_s, aver_df, aver_gof;
        float   v1, v2, v3;
        FILE	*out;
        float   px;
        double  x, y, ylast;
        double  d1;
        float   r1, r2;
        float   bdiv;
        float   sig_mul;
        int     test;

	float	minx, maxx, miny, maxy;



	refl = matrix( 0, 6, 0, MAX_NOF_REFL );
	finpp = vector( 0, MAX_NOF_REFL );
	plot1 = vector( 0, MAX_NOF_REFL );

        m=0;
        for ( x = 0.0 ; x <= 4.095 ; x += 0.0010 )
        {

        y = 1.0;
        ylast = 1.0;
        i = 1;
        while( 1 )
                {
                if ( i % 2 )
                        y -= pow( x , 2.0 * i ) / ( (1+2*i) * pow( 2.0, (double)(i)) * fact(i) );
                else
                        y += pow( x , 2.0 * i ) / ( (1+2*i) * pow( 2.0, (double)(i)) * fact(i) );
                                        
                if ( fabs( y - ylast ) < 0.0000000000001 )
                        break;
                i++;
                ylast=y;
                }
        
        y *= 2.0 * x * 0.398942280402;
        normtab[0][m] = x;
        normtab[1][m] = y;

        m++;


        
        }


	rewind(in);
	fgets( j, 299, in );

        nref = 0;
        while ( fscanf( in, "%f %f %f %f %f %f %f"
                ,&refl[4][nref],&refl[5][nref],&refl[6][nref],&refl[0][nref],&refl[1][nref],&refl[2][nref],&refl[3][nref]) == 7 )
		{
			plot1[nref] = (refl[0][nref]-refl[2][nref])/ sqrt( refl[1][nref]*refl[1][nref] + refl[3][nref]*refl[3][nref] );
                        nref++;
                        if ( nref > MAX_NOF_REFL-2 )
				{
					fprintf(stderr, "\n\n\n\033[31m\033[1mToo many reflections (limit %d). Abort.\033[0m\n\n\n", MAX_NOF_REFL);
					exit( 0 );
									}
				}
				
	for ( i=0 ; i < nref ; i++ )
		saving[i] = i;
		
	if ( nref > 2 )
	{
        unsigned long n, i,ir,j,l;
	float	rra, *ra;
	int	*sav, s1;
	
	ra = &plot1[0] - 1;
	sav = &saving[0] - 1;
	
	n = nref;
        l=(n >> 1)+1;
        ir=n;
        for (;;) {
                if (l > 1) {
                        rra=ra[--l];
			s1 = sav[l];
                } else {
                        rra=ra[ir];
			s1 = sav[ir];
                        ra[ir]=ra[1];
			sav[ir] = sav[1];
                        if (--ir == 1) {
                                ra[1]=rra;
				sav[1] = s1;
                                break;
                        }
                }
                i=l;
                j=l+l;
                while (j <= ir) {
                        if (j < ir && ra[j] < ra[j+1]) j++;
                        if (rra < ra[j]) {
                                ra[i]=ra[j];
				sav[i] = sav[j];
                                i=j;
                                j <<= 1;
                        } else j=ir+1;
                }
                ra[i]=rra;
		sav[i] = s1;
        }
	}
	else
	{
		fprintf(stderr, "\n\n\n\033[31m\033[1mLess than two reflections (???). Abort.\n\n");
		exit(1);
				}
				


	rewind(in);
	fgets( j, 299, in );

	if ( nref % 2 == 0 )
		{
			for ( i = nref/2 ; i < nref ; i++ )
				{
				plot1[i-1] = plot1[i];
				saving[i-1] = saving[i];
				}

			nref--;
		}			
	
	
        for ( i=1 ; i <= (int)(nref/2)+1 ; i++ )
                {
                        px = ((double)(nref) - 2.0 * i + 1.0) / (double)(nref) ;
                        d1 = (float)(findx( px ));
                        finpp[i-1] = -d1;
                        finpp[nref-i] = d1;
                                                }

#ifdef NOPGPLOT
	out = fopen( "MAXENT_normal_prob_plot.dat", "w");
	for ( i=0 ; i < nref ; i++ )
		fprintf(out, " % 15.5f % 15.5f\n",  finpp[i], plot1[i] );
	fclose(out);
#endif

	out = fopen( "Normplot_tails.dat", "w");
	for ( i=0 ; i < 2*(int)(nref*0.020) ; i++ )
		fprintf(out, " % 5d % 5d % 5d     % +15.5f % +15.5f\n", nearint(refl[4][saving[i]])
			, nearint(refl[5][saving[i]]), nearint(refl[6][saving[i]]), finpp[i], plot1[i] );
	for ( i=nref - 2*(int)(nref*0.020)  ; i < nref ; i++ )
		fprintf(out, " % 5d % 5d % 5d     % +15.5f % +15.5f\n", nearint(refl[4][saving[i]])
			, nearint(refl[5][saving[i]]), nearint(refl[6][saving[i]]), finpp[i], plot1[i] );
	fclose(out);


	



#ifndef NOPGPLOT


	minx = finpp[0];
	maxx = finpp[0];
	miny = plot1[0];
	maxy = plot1[0];
	for ( i=0 ; i < nref ; i++ )
		{
			if ( finpp[i] > maxx )
				maxx = finpp[i];
			if ( finpp[i] < minx )
				minx = finpp[i];
			if ( plot1[i] > maxy )
				maxy = plot1[i];
			if ( plot1[i] < miny )
				miny = plot1[i];
					}
					

	
	if ( ( VT125 == NO && cpgopen("/XWIN") <= 0 ) || ( VT125 == YES && cpgopen("/VT125") <= 0 ) )
		{
			fprintf(stderr, "\033[31m\033[1mCan not open graphics window.\033[0m\n");
			DO_PLOT = NO;
					}
	else
		{
			if ( GRAPH_WAIT == YES )
				cpgask(1);
			else
				cpgask(0);

			cpgslw(1);
    			cpgsci(2);
			cpgswin( -1.0250*max2(fabs(minx),fabs(maxx)), 1.0250*max2(fabs(minx),fabs(maxx)), 
					-1.0250*max2(fabs(miny),fabs(maxy)), 1.0250*max2(fabs(miny),fabs(maxy)) );
			cpgbox("bcts", 0.0, 0, "bcts", 0.0, 0);
    			cpgsci(2);
			cpgmtxt("t", 1.0, 0.0, 0.0, "Normal probability plot");

    			cpgsci(3);
    			cpgsls(1);
    			cpgslw(10);
			for ( i=0 ; i < nref ; i++ )
				{
				if ( i < 2*(int)(nref*0.020) || i >= (nref - 2*(int)(nref*0.020)) )
					cpgsci(6);
				else
					cpgsci(3);					
				cpgpt1( (float)(finpp[i]), plot1[i], -2 );
					}
					
			cpgslw(3);
			cpgsls(4);
    			cpgsci(2);
			cpgmove( -max2(fabs(miny),fabs(maxy)), -max2(fabs(miny),fabs(maxy)) );
			cpgdraw( max2(fabs(miny),fabs(maxy)), max2(fabs(miny),fabs(maxy)) );

			cpgslw(1);
			cpgsls(1);
    			cpgsci(1);
			cpgmove( 0, -max2(fabs(miny),fabs(maxy)) );
			cpgdraw( 0,  max2(fabs(miny),fabs(maxy)) );
			cpgmove( -max2(fabs(minx),fabs(maxx)), 0.0 );
			cpgdraw(  max2(fabs(minx),fabs(maxx)), 0.0 );


								}

	if( cpgopen("Normal_probability.ps/cps") <= 0 )
		{
			fprintf(stderr, "\033[31m\033[1mCan not open postscript file for plot.\033[0m\n");
			DO_PLOT = NO;
					}
	else
		{

			cpgslw(1);
    			cpgsci(2);
			cpgswin( -1.0250*max2(fabs(minx),fabs(maxx)), 1.0250*max2(fabs(minx),fabs(maxx)), 
					-1.0250*max2(fabs(miny),fabs(maxy)), 1.0250*max2(fabs(miny),fabs(maxy)) );
			cpgbox("bcts", 0.0, 0, "bcts", 0.0, 0);
    			cpgsci(2);
			cpgmtxt("t", 1.0, 0.0, 0.0, "Normal probability plot");

    			cpgsci(3);
    			cpgsls(1);
    			cpgslw(10);
			for ( i=0 ; i < nref ; i++ )
				{
				if ( i < 2*(int)(nref*0.020) || i >= (nref - 2*(int)(nref*0.020)) )
					cpgsci(6);
				else
					cpgsci(3);					
				cpgpt1( (float)(finpp[i]), plot1[i], -2 );
					}
			
			cpgslw(3);
			cpgsls(4);
    			cpgsci(2);
			cpgmove( -max2(fabs(miny),fabs(maxy)), -max2(fabs(miny),fabs(maxy)) );
			cpgdraw( max2(fabs(miny),fabs(maxy)), max2(fabs(miny),fabs(maxy)) );

			cpgslw(1);
			cpgsls(1);
    			cpgsci(1);
			cpgmove( 0, -max2(fabs(miny),fabs(maxy)) );
			cpgdraw( 0,  max2(fabs(miny),fabs(maxy)) );
			cpgmove( -max2(fabs(minx),fabs(maxx)), 0.0 );
			cpgdraw(  max2(fabs(minx),fabs(maxx)), 0.0 );
			cpgclos();
						}



#endif	



	free_matrix(refl,  0, 6, 0, MAX_NOF_REFL );
	free_vector(finpp, 0, MAX_NOF_REFL );
	free_vector(plot1, 0, MAX_NOF_REFL );


	

}
	

















double  fact(i)
int     i;
{
        double f;
        
        f=i;
        i--;
        for ( ; i>1 ; i-- )
                f *= i;
        
        return(f);
}


double  findx( px )
double  px;
{

        int     i;
        double  res;


        for ( i=1 ; i < 4096 ; i++ )
                if ( px >= normtab[1][i-1] && px <= normtab[1][i] )
                {
                res = normtab[0][i-1] + (normtab[0][i]-normtab[0][i-1])*( (px-normtab[1][i-1]) / ( normtab[1][i]-normtab[1][i-1] ) );
                return( res );
                                }
        
        printf("\033[31mPROBLEM in findx().\n");
	if ( px < normtab[1][0] )
		return( normtab[0][0] );
	else
		return( normtab[0][4095] );
		
	
}




int	get_grid( number )
float	number;
{
	int	pointer;
	
	if ( number < 0.0 )
		{
			fprintf(stderr, "\033[31m\033[1mNegative number for grid size determination? Panic.\033[0m\n\n");
			exit(1);
					}			
	if ( number < 1.0 )
		return(1);
	if ( number > 1024.0 )
		{
			fprintf(stderr, "\n\n\n\033[31m\033[1mGrid size greater than 1024 ??? Abort.\033[0m\n\n");
			exit(1);
					}
	pointer = 0;
	while ( number > good_numbers[pointer] )
		pointer++;
	
	return( good_numbers[pointer] );
}

	





void 	control_Z( ignore )
int 	ignore;
{

  	fprintf(stderr, "\n\n\033[35mReceived TSTP signal. Exiting gracefully ...\033[0m\n\n");
	TARGET_CHI = 3.40E+38F;
    	signal(SIGTSTP, SIG_IGN);

}











/*****************************************************************************************************************************************/
/** Window-based .mtz column (and synthesis) selection	 										**/
/*****************************************************************************************************************************************/

#ifndef NOCCP4
#ifndef NOPGPLOT

void gui( file )
char *file;
{
        int     mindx;
        int     iprint;
        int     ifail;
        float   resol;
        float   adata[40];
        int     eof;
        int     i;
	int	ncolx;
	int	missing[40];
	char	clabs[40][30];
	char	ctyps[40][1];
	int	more_col;
	char	all[20];
	int	type;
	char	type_d[300];
	FILE	*out, *out2, *out3;
	int	IER;
	char	l1[31];
	int	selected[40];
	char	ttps[40];
	int	g;
	char 	c;
	int	tot;	
	int	colid[10];
	int	idprev;
		

	for (i=0 ; i < 40 ; i++ )
		selected[i] = -1;
		

	/*********************************************************************************************************************************/
	/**  MTZ stuff. Open mtz file, get column types and start comparing with supported modes of operation				**/
	/*********************************************************************************************************************************/

#ifndef NONEWCCP4
        mindx = -1;
        iprint = -1;
	ccp4h_init_lib_( &mindx, &iprint );
#endif

        mindx = 1;
        iprint = 0;
        mtzini_();
        lropen_( &mindx, file,  &iprint, &ifail, strlen(file) );

	if ( ifail == -1 )
		{
			fprintf(stderr, "\n\n\033[31m\033[1mMTZ error (lropen()). Abort.\033[0m\n\n");
			exit(1);
					}
	lrcell_( &mindx, &cell[0] );
	lrncol_( &mindx, &ncolx );
	if ( ncolx > 28 )
		{
			fprintf(stderr, "\n\n\033[31m\033[1mToo many columns in .mtz. Abort.\033[0m\n\n");
			exit(1);
					}
	more_col = 30;
	lrclab_( &mindx, &clabs[0][0], &ctyps[0][0], &more_col );
	for ( i=0 ; i < more_col ; i++ )
		all[i] = ctyps[i][0];
	
	all[i] = 0;

	lrclos_(&mindx);


	/* PGPLOT stuff */
	
	
	if ( ( idprev = cpgopen("/XWIN")) <= 0 )
		{
			fprintf(stderr, "\033[31m\033[1mCan not open graphics window. Graphics set to OFF.\033[0m\n");
			DO_PLOT = NO;
			return;
					}
	
	cpgscrn( 0, "DarkSlateGray", &IER);
	cpgscrn( 1, "Orange", &IER);
	cpgscrn( 2, "Red", &IER);
	cpgscrn( 3, "Blue", &IER);
	cpgscrn( 4, "Yellow", &IER);
	cpgscrn( 5, "White", &IER);


	cpgpap( 4.0, (more_col > 10 ? 2.0 : 1.0) );
	cpgpage();
	cpgsvp(0.0,1.0,0.0,1.0);
	cpgswin(0.0,1.0, (more_col > 10 ? -1.0 : 0.0), 1.0 );
	cpgask(0);
	cpgsave();
	cpgeras();
	cpgsci(1);
	cpgslw(1);
	cpgsfs(1);
	cpgscf(1);
	cpgsch(1.5);

	cpgsci(2);
	cpgscf(2);
	cpgtext(0.0,0.95,"Select columns for synthesis :");
	cpgtext(0.0,(more_col > 10 ? -0.980 : 0.020),"[HELP]");
	cpgsch(1.5);
	cpgscf(1);
	cpgsci(1);

	for ( i=3 ; i < more_col ; i++ )
		{
			strncpy( l1, clabs[i], 30 );
			l1[30]=0;
			sprintf( type_d, "Column %3d is of type %c with label %s", i, ctyps[i][0], l1 );
			cpgtext(0.0, 0.85-0.050*(i-3), type_d );
				}
	
	cpgsci(3);
	cpgscf(2);
	cpgtext(0.0, 0.85-0.050*(i-2), "Click here when finished." );				

	tot = 1;
	while( 1 )
		{
			float	x, y;
			char c;
			
			cpgscf(1);
			cpgcurs( &x, &y, &c );
			if ( y < 0.90 && y > 0.85-0.050*(more_col-4) )
				{
					float	hh;
					
					i = (int)( (y - (0.85-0.050*(more_col-4))) / 0.050 )  ;	
					i = more_col -i -1 ;
					if ( selected[i] < 0 )
					{
					selected[i] = tot;
					tot++;
					cpgsci(4);
					strncpy( l1, clabs[i], 30 );
					l1[30]=0;
					sprintf( type_d, "Column %3d is of type %c with label %s", i, ctyps[i][0], l1 );
					cpgtext(0.0, 0.85-0.050*(i-3), type_d );
					}
					else
					{
					selected[i] = -1;
					tot--;
					cpgsci(1);
					strncpy( l1, clabs[i], 30 );
					l1[30]=0;
					sprintf( type_d, "Column %3d is of type %c with label %s", i, ctyps[i][0], l1 );
					cpgtext(0.0, 0.85-0.050*(i-3), type_d );
					}
					
					
						}
		
		
			if ( y > (0.85-0.050*(more_col-2)) && y < ( (0.85-0.050*(more_col-2)) + 0.050 ) )
				break;

			if ( (more_col > 10 && y > -1.0 && y < -0.930) || ( more_col <= 10 && y > 0.0 && y < 0.070 ) )
			{
				cpgopen("/XWIN");

				cpgscrn( 0, "DarkSlateGray", &IER);
				cpgscrn( 1, "Orange", &IER);
				cpgscrn( 2, "Red", &IER);
				cpgscrn( 3, "Blue", &IER);
				cpgscrn( 4, "Yellow", &IER);
				cpgscrn( 5, "White", &IER);
				cpgpap( 4.0, 1.0 );
				cpgpage();
				cpgsvp(0.0,1.0,0.0,1.0);
				cpgswin(0.0,1.0,0.0,1.0 );
				cpgask(0);
				cpgsave();
				cpgeras();
				cpgsci(1);
				cpgslw(1);
				cpgsfs(1);
				cpgscf(1);
				cpgsch(1.5);
			
				cpgsci(1);
				cpgscf(1);

				cpgtext(0.0,0.95,"Select (by clicking on them) the various columns");
				cpgtext(0.0,0.90,"that should be used for the synthesis you have ");
				cpgtext(0.0,0.85,"in mind.");
				cpgtext(0.0,0.80,"The order with which you select the columns needed");
				cpgtext(0.0,0.75,"for the synthesis is important : you should be ");
				cpgtext(0.0,0.70,"selecting amplitudes with their standard deviation");
				cpgtext(0.0,0.65,"first, followed by phases and finally weights.");
				cpgtext(0.0,0.60,"For example : ");
				cpgtext(0.0,0.55," - For a difference Patterson calculation choose");
				cpgtext(0.0,0.50,"|F1|, sig(|F1|), |F2|, sig(|F2|) in that order.");
				cpgtext(0.0,0.45," - For a m*(|F1|-|F2|)exp(iPHI) synthesis, choose");
				cpgtext(0.0,0.40,"|F1|,sig(|F1|),|F2|,sig(|F2|),PHI,FOM in that order.");
				cpgtext(0.0,0.35," - For m*|Fo|exp(iPHI) synthesis, select");
				cpgtext(0.0,0.30,"|Fo|, sig(|Fo|), PHI, and finally FOM.");
				cpgtext(0.0,0.25,"The following combinations of column types are ");
				cpgtext(0.0,0.20,"recognised : FQ, FQP, FQPW, FQFQ, DQ, GLGL, DQP,");
				cpgtext(0.0,0.15,"DQPW, FQFQP, FQFQPW, FQFP, FQFPW.");
				cpgsci(2);
				cpgtext(0.0,0.05,"Press any key to continue. ");

				cpgcurs( &x, &y, &c );
				cpgclos();
				cpgslct( idprev );
							
			}

			
			}
			

	cpgsci(0);
	cpgscf(2);
	cpgtext(0.0, 0.85-0.050*(more_col-2), "Click here when finished." );				

	g = 0;			
	for ( i=0 ; i < 40 ; i++ )
		if ( selected[i] > 0 )
			{
				ttps[selected[i]-1] =  ctyps[i][0];
				colid[selected[i]-1] = i - 2;
							}
	g = tot-1;
	ttps[g] = 0;
	if ( g == 0 )
		{
			fprintf(stderr, "\033[31m\033[1mNo columns selected ? Aborting..\033[0m\n");
			exit(1);
					}

	if ( g == 1 )
		{
			fprintf(stderr, "\033[31m\033[1mOnly one column selected ? Aborting..\033[0m\n");
			exit(1);
					}
			
			
	sprintf( type_d, "Column types for synthesis are %s", ttps );
	cpgsci(5);
	cpgscf(2);
	cpgtext(0.0, 0.85-0.050*(more_col-2), type_d );				

	if ( strchr(ttps, 'A') != NULL )
		{
			cpgclos();
			fprintf(stderr, "\033[31m\033[1m\nGraphEnt can only handle unimodal phase probability distributions.\033[0m\n");
			fprintf(stderr, "\033[37m\033[1mPlease use phase and figure of merit instead of H/L coefficients.\033[0m\n");
			exit(1);
					}			

	if ( strcmp( ttps, "KMKM" ) == 0 )
		{
			cpgclos();
			fprintf(stderr, "\033[31m\033[1m\nFor an anomalous difference Patterson function please use either\033[0m\n");
			fprintf(stderr, "\033[31m\033[1mthe F(+),F(-) columns, or the DFano column (and not the I(+) and I(-)).\033[0m\n");
			exit(1);
					}			

	if ( strchr(ttps, 'K') != NULL || strchr(ttps, 'J') != NULL )
		{
			cpgclos();
			fprintf(stderr, "\033[31m\033[1m\nPlease define the synthesis you have in mind using amplitude terms\033[0m\n");
			fprintf(stderr, "\033[31m\033[1m(instead of the intensities you have chosen).\033[0m\n");
			exit(1);
					}			
	
	
	system("/bin/rm -rf from_graphent.mtz");
	
	if ( strcmp( ttps, "FQ" ) == 0 )
		{
			cpgtext(0.0, 0.85-0.050*(more_col-1), "Patterson function defined." );

			out = fopen( "MAXENT_script_for_sftools.in", "w" );
			fprintf( out, "\n\nsftools > MAXENT_sftools.log<< eof\n");
			fprintf( out, "read %s\n", file);
			fprintf( out, "write from_graphent.mtz col ");
			for (i=0 ; i < g ; i++ )
				fprintf( out, "%d ", colid[i]);
			fprintf( out, "\ny\nquit\n");
			fprintf( out, "eof\n");
			fclose(out);
			system("/bin/chmod 755 MAXENT_script_for_sftools.in ; ./MAXENT_script_for_sftools.in");
			system("/bin/rm -rf ./MAXENT_sftools.log ./MAXENT_script_for_sftools.in");


			cpgtext(0.0, 0.85-0.050*(more_col+0), "Is this a native Patterson calculation with");
			cpgtext(0.0, 0.85-0.050*(more_col+1), "the data on an absolute scale ? (y/n)" );
			cpgtext(0.0, 0.85-0.050*(more_col+2), "[answering 'y' will force the program to" );
			cpgtext(0.0, 0.85-0.050*(more_col+3), "estimate a suitable value for the F000 term]" );

			while( 1 )
				{
					float	x, y;
					
					cpgcurs( &x, &y, &c );
					if ( c == 'y' || c == 'Y' )
						{
							FORCE_F000 = YES;
							break;
								}
					
					if ( c == 'n' || c == 'N' )
						break;
									}

						
						
			cpgtext(0.0, 0.85-0.050*(more_col+4), "Written file 'from_graphent.mtz'." );
			cpgtext(0.0, 0.85-0.050*(more_col+5), "Ready to roll ..." );
			sleep(2);
			cpgclos();
			return;			
			
				}
/*	else if ( strcmp( ttps, "JQ" ) == 0 )
	                {
	                
	                cpgtext(0.0, 0.85-0.050*(more_col-1), "Patterson function with intensities." );

			out = fopen( "MAXENT_script_for_sftools.in", "w" );
			fprintf( out, "\n\nsftools > MAXENT_sftools.log<< eof\n");
			fprintf( out, "read %s\n", file);
			fprintf( out, "expand\n");
			fprintf( out, "calc f col %d = col %d\n", colid[0], colid[0]);
			fprintf( out, "calc p col Zero_phases = 0.0\n");
			fprintf( out, "write from_graphent.mtz col ");
			for (i=0 ; i < g ; i++ )
				fprintf( out, "%d ", colid[i]);
			fprintf( out, " Zero_phases");
			fprintf( out, "\ny\nquit\n");
			fprintf( out, "eof\n");
			fclose(out);
			system("/bin/chmod 755 MAXENT_script_for_sftools.in ; ./MAXENT_script_for_sftools.in");
			system("/bin/rm -rf ./MAXENT_sftools.log ./MAXENT_script_for_sftools.in");

			cpgtext(0.0, 0.85-0.050*(more_col+0), "Is this a native Patterson calculation ? (y/n)" );
			cpgtext(0.0, 0.85-0.050*(more_col+1), "[answering 'y' will force the program to" );
			cpgtext(0.0, 0.85-0.050*(more_col+2), "estimate a suitable value for the F000 term]" );


			while( 1 )
				{
					float	x, y;
					
					cpgcurs( &x, &y, &c );
					if ( c == 'y' || c == 'Y' )
						{
							FORCE_SQUARE_F000 = YES;
							FORCE_F000 = YES;
							break;
								}
					
					if ( c == 'n' || c == 'N' )
						break;
									}

			cpgtext(0.0, 0.85-0.050*(more_col+3), "Written file 'from_graphent.mtz'." );
			cpgtext(0.0, 0.85-0.050*(more_col+4), "Ready to roll ..." );
			sleep(2);
			cpgclos();
			return;
	                		}
*/	else if ( strcmp( ttps, "FQP" ) == 0 )
	                {
	                cpgtext(0.0, 0.85-0.050*(more_col-1), "Fourier synthesis defined." );

			out = fopen( "MAXENT_script_for_sftools.in", "w" );
			fprintf( out, "\n\nsftools > MAXENT_sftools.log<< eof\n");
			fprintf( out, "read %s\n", file);
			fprintf( out, "write from_graphent.mtz col ");
			for (i=0 ; i < g ; i++ )
				fprintf( out, "%d ", colid[i]);
			fprintf( out, "\ny\nquit\n");
			fprintf( out, "eof\n");
			fclose(out);
			system("/bin/chmod 755 MAXENT_script_for_sftools.in ; ./MAXENT_script_for_sftools.in");
			system("/bin/rm -rf ./MAXENT_sftools.log ./MAXENT_script_for_sftools.in");
			
			cpgtext(0.0, 0.85-0.050*(more_col+0), "Written file 'from_graphent.mtz'." );
			cpgtext(0.0, 0.85-0.050*(more_col+1), "Ready to roll ..." );
			sleep(2);
			cpgclos();
			return;
	                		}
	else if ( strcmp( ttps, "FQPW" ) == 0 )
	                {
	                cpgtext(0.0, 0.85-0.050*(more_col-1), "Fourier synthesis with FOM." );

			out = fopen( "MAXENT_script_for_sftools.in", "w" );
			fprintf( out, "\n\nsftools > MAXENT_sftools.log<< eof\n");
			fprintf( out, "read %s\n", file);
			fprintf( out, "write from_graphent.mtz col ");
			for (i=0 ; i < g ; i++ )
				fprintf( out, "%d ", colid[i]);
			fprintf( out, "\ny\nquit\n");
			fprintf( out, "eof\n");
			fclose(out);
			system("/bin/chmod 755 MAXENT_script_for_sftools.in ; ./MAXENT_script_for_sftools.in");
			system("/bin/rm -rf ./MAXENT_sftools.log ./MAXENT_script_for_sftools.in");
			
			cpgtext(0.0, 0.85-0.050*(more_col+0), "Written file 'from_graphent.mtz'." );
			cpgtext(0.0, 0.85-0.050*(more_col+1), "Ready to roll ..." );
			sleep(2);
			cpgclos();
			return;
	                		}
	else if ( strcmp( ttps, "FQFQ" ) == 0 )
	                {

	                cpgtext(0.0, 0.85-0.050*(more_col-1), "Difference Patterson function." );

			out = fopen( "MAXENT_script_for_sftools.in", "w" );
			fprintf( out, "\n\nsftools > MAXENT_sftools.log<< eof\n");
			fprintf( out, "read %s\n", file);
			fprintf( out, "write from_graphent.mtz col ");
			for (i=0 ; i < g ; i++ )
				fprintf( out, "%d ", colid[i]);
			fprintf( out, "\ny\nquit\n");
			fprintf( out, "eof\n");
			fclose(out);
			system("/bin/chmod 755 MAXENT_script_for_sftools.in ; ./MAXENT_script_for_sftools.in");
			system("/bin/rm -rf ./MAXENT_sftools.log ./MAXENT_script_for_sftools.in");
			
			cpgtext(0.0, 0.85-0.050*(more_col+0), "Written file 'from_graphent.mtz'." );
			cpgtext(0.0, 0.85-0.050*(more_col+1), "Ready to roll ..." );
			sleep(2);
			cpgclos();
			return;

	                		}
	else if ( strcmp( ttps, "DQ" ) == 0 )
	                {
	                cpgtext(0.0, 0.85-0.050*(more_col-1), "Anomalous difference Patterson function." );

			out = fopen( "MAXENT_script_for_sftools.in", "w" );
			fprintf( out, "\n\nsftools > MAXENT_sftools.log<< eof\n");
			fprintf( out, "read %s\n", file);
			fprintf( out, "write from_graphent.mtz col ");
			for (i=0 ; i < g ; i++ )
				fprintf( out, "%d ", colid[i]);
			fprintf( out, "\ny\nquit\n");
			fprintf( out, "eof\n");
			fclose(out);
			system("/bin/chmod 755 MAXENT_script_for_sftools.in ; ./MAXENT_script_for_sftools.in");
			system("/bin/rm -rf ./MAXENT_sftools.log ./MAXENT_script_for_sftools.in");


			cpgtext(0.0, 0.85-0.050*(more_col+0), "For anomalous difference Patterson functions," );
			cpgtext(0.0, 0.85-0.050*(more_col+1), "practise has shown that it may be advantageous" );
			cpgtext(0.0, 0.85-0.050*(more_col+2), "to overfit the data. Would you be prepared to");
			cpgtext(0.0, 0.85-0.050*(more_col+3), "overfit your data ? (y/n)" );

			while( 1 )
				{
					float	x, y;
					
					cpgcurs( &x, &y, &c );
					if ( c == 'y' || c == 'Y' )
						{
							OVERFIT = YES;
							break;
								}
					
					if ( c == 'n' || c == 'N' )
						break;
									}

			
			cpgtext(0.0, 0.85-0.050*(more_col+4), "Written file 'from_graphent.mtz'." );
			cpgtext(0.0, 0.85-0.050*(more_col+5), "Ready to roll ..." );
			sleep(2);
			cpgclos();
			return;
	                		}
	else if ( strcmp( ttps, "GLGL" ) == 0 )
	                {
	                cpgtext(0.0, 0.85-0.050*(more_col-1), "Anomalous differences Patterson function." );

			out = fopen( "MAXENT_script_for_sftools.in", "w" );
			fprintf( out, "\n\nsftools > MAXENT_sftools.log<< eof\n");
			fprintf( out, "read %s\n", file);
								/* Do not include centrosymmetrics (because we will have to fit exactly */
								/* all these zeros */
			fprintf( out, "select not centro\n");
			fprintf( out, "write from_graphent.mtz col ");
			for (i=0 ; i < g ; i++ )
				fprintf( out, "%d ", colid[i]);
			fprintf( out, "\ny\nquit\n");
			fprintf( out, "eof\n");
			fclose(out);
			system("/bin/chmod 755 MAXENT_script_for_sftools.in ; ./MAXENT_script_for_sftools.in");
			system("/bin/rm -rf ./MAXENT_sftools.log ./MAXENT_script_for_sftools.in");

			cpgtext(0.0, 0.85-0.050*(more_col+0), "For anomalous difference Patterson functions," );
			cpgtext(0.0, 0.85-0.050*(more_col+1), "practise has shown that it may be advantageous" );
			cpgtext(0.0, 0.85-0.050*(more_col+2), "to overfit the data. Would you be prepared to");
			cpgtext(0.0, 0.85-0.050*(more_col+3), "overfit your data ? (y/n)" );

			while( 1 )
				{
					float	x, y;
					
					cpgcurs( &x, &y, &c );
					if ( c == 'y' || c == 'Y' )
						{
							OVERFIT = YES;
							break;
								}
					
					if ( c == 'n' || c == 'N' )
						break;
									}
			
			cpgtext(0.0, 0.85-0.050*(more_col+4), "Written file 'from_graphent.mtz'." );
			cpgtext(0.0, 0.85-0.050*(more_col+5), "Ready to roll ..." );
			sleep(2);
			cpgclos();
			return;
	                		}
	else if ( strcmp( ttps, "DQP" ) == 0 )
	                {
	                cpgtext(0.0, 0.85-0.050*(more_col-1), "Anomalous differences phased synthesis." );
	                cpgtext(0.0, 0.85-0.050*(more_col+0), "Phases retarded by 90 degrees." );

			out = fopen( "MAXENT_script_for_sftools.in", "w" );
			fprintf( out, "\n\nsftools > MAXENT_sftools.log<< eof\n");
			fprintf( out, "read %s\n", file);
			fprintf( out, "calc f col %d = col %d\n", colid[0], colid[0] );

			/* Select only acentric, retard phase by 90 degrees */
			
			fprintf( out, "select not centro\n");
			fprintf( out, "calc col %d = col %d 90.0 -\n", colid[2], colid[2]);

			fprintf( out, "write from_graphent.mtz col ");
			for (i=0 ; i < g ; i++ )
				fprintf( out, "%d ", colid[i]);
			fprintf( out, "\ny\nquit\n");
			fprintf( out, "eof\n");
			fclose(out);
			system("/bin/chmod 755 MAXENT_script_for_sftools.in ; ./MAXENT_script_for_sftools.in");
			system("/bin/rm -rf ./MAXENT_sftools.log ./MAXENT_script_for_sftools.in");
			
			cpgtext(0.0, 0.85-0.050*(more_col+1), "Written file 'from_graphent.mtz'." );
			cpgtext(0.0, 0.85-0.050*(more_col+2), "Ready to roll ..." );
			sleep(2);
			cpgclos();
			return;
	                		}
	else if ( strcmp( ttps, "DQPW" ) == 0 )
	                {
	                cpgtext(0.0, 0.85-0.050*(more_col-1), "Anomalous differences phased synthesis with FOM." );
	                cpgtext(0.0, 0.85-0.050*(more_col+0), "Phases retarded by 90 degrees." );

			out = fopen( "MAXENT_script_for_sftools.in", "w" );
			fprintf( out, "\n\nsftools > MAXENT_sftools.log<< eof\n");
			fprintf( out, "read %s\n", file);
			fprintf( out, "calc f col %d = col %d\n", colid[0], colid[0] );

			/* Select only acentric, retard phase by 90 degrees */
			
			fprintf( out, "select not centro\n");
			fprintf( out, "calc col %d = col %d 90.0 -\n", colid[2], colid[2]);

			fprintf( out, "write from_graphent.mtz col ");
			for (i=0 ; i < g ; i++ )
				fprintf( out, "%d ", colid[i]);
			fprintf( out, "\ny\nquit\n");
			fprintf( out, "eof\n");
			fclose(out);
			system("/bin/chmod 755 MAXENT_script_for_sftools.in ; ./MAXENT_script_for_sftools.in");
			system("/bin/rm -rf ./MAXENT_sftools.log ./MAXENT_script_for_sftools.in");
			
			cpgtext(0.0, 0.85-0.050*(more_col+1), "Written file 'from_graphent.mtz'." );
			cpgtext(0.0, 0.85-0.050*(more_col+2), "Ready to roll ..." );
			sleep(2);
			cpgclos();
			return;

	                		}
	else if ( strcmp( ttps, "FQFQP" ) == 0 )
	                {
	                	cpgtext(0.0, 0.85-0.050*(more_col-1), "Difference Fourier synthesis." );
	                	cpgtext(0.0, 0.85-0.050*(more_col+0), "Press '2' for a 2F1-F2, '1' for a F1-F2" );
				while( 1 )
				{
					float	x, y;
					
					cpgcurs( &x, &y, &c );
					if ( c == '1' || c == '2' )
						break;
					}

				if ( c == '1' )
				{
				cpgtext(0.0, 0.85-0.050*(more_col+1), "A (|F1|-|F2|)exp(iPHI) synthesis." );

				out = fopen( "MAXENT_script_for_sftools.in", "w" );
				fprintf( out, "\n\nsftools > ./MAXENT_sftools.log << eof\n");
				fprintf( out, "read %s\n", file);
				fprintf( out, "calc f col F1-F2 = col %d col %d -\n", colid[0], colid[2]);
				fprintf( out, "calc q col sigF1-F2 = col %d col %d +\n", colid[1], colid[3]);
				fprintf( out, "write from_graphent.mtz col F1-F2 sigF1-F2 %d", colid[4]);
				fprintf( out, "\ny\nquit\n");
				fprintf( out, "eof\n");
				fclose(out);
				system("/bin/chmod 755 MAXENT_script_for_sftools.in ; ./MAXENT_script_for_sftools.in");
				system("/bin/rm -rf ./MAXENT_sftools.log ./MAXENT_script_for_sftools.in");
			
				cpgtext(0.0, 0.85-0.050*(more_col+2), "Written file 'from_graphent.mtz'." );
				cpgtext(0.0, 0.85-0.050*(more_col+3), "Ready to roll ..." );
				sleep(2);
				cpgclos();
				return;
				
				
					}
				if ( c == '2' )
				{
				cpgtext(0.0, 0.85-0.050*(more_col+1), "A (2|F1|-|F2|)exp(iPHI) synthesis." );

				out = fopen( "MAXENT_script_for_sftools.in", "w" );
				fprintf( out, "\n\nsftools > ./MAXENT_sftools.log << eof\n");
				fprintf( out, "read %s\n", file);
				fprintf( out, "calc f col 2F1-F2 = col %d 2.0 * col %d -\n", colid[0], colid[2]);
				fprintf( out, "calc q col sig2F1-F2 = col %d 2.0 * col %d +\n", colid[1], colid[3]);
				fprintf( out, "write from_graphent.mtz col 2F1-F2 sig2F1-F2 %d", colid[4]);
				fprintf( out, "\ny\nquit\n");
				fprintf( out, "eof\n");
				fclose(out);
				system("/bin/chmod 755 MAXENT_script_for_sftools.in ; ./MAXENT_script_for_sftools.in");
				system("/bin/rm -rf ./MAXENT_sftools.log ./MAXENT_script_for_sftools.in");
			
				cpgtext(0.0, 0.85-0.050*(more_col+2), "Written file 'from_graphent.mtz'." );
				cpgtext(0.0, 0.85-0.050*(more_col+3), "Ready to roll ..." );
				sleep(2);
				cpgclos();
				return;
	                		}
	                		}

	else if ( strcmp( ttps, "FQFQPW" ) == 0 )
	                {
	                	cpgtext(0.0, 0.85-0.050*(more_col-1), "Difference Fourier synthesis with FOM.." );
	                	cpgtext(0.0, 0.85-0.050*(more_col+0), "Press '2' for a 2F1-F2, '1' for a F1-F2" );
				while( 1 )
				{
					float	x, y;
					
					cpgcurs( &x, &y, &c );
					if ( c == '1' || c == '2' )
						break;
					}

				if ( c == '1' )
				{
				cpgtext(0.0, 0.85-0.050*(more_col+1), "A m(|F1|-|F2|)exp(iPHI) synthesis." );

				out = fopen( "MAXENT_script_for_sftools.in", "w" );
				fprintf( out, "\n\nsftools > ./MAXENT_sftools.log << eof\n");
				fprintf( out, "read %s\n", file);
				fprintf( out, "calc f col F1-F2 = col %d col %d -\n", colid[0], colid[2]);
				fprintf( out, "calc q col sigF1-F2 = col %d col %d +\n", colid[1], colid[3]);
				fprintf( out, "write from_graphent.mtz col F1-F2 sigF1-F2 %d %d", colid[4], colid[5]);
				fprintf( out, "\ny\nquit\n");
				fprintf( out, "eof\n");
				fclose(out);
				system("/bin/chmod 755 MAXENT_script_for_sftools.in ; ./MAXENT_script_for_sftools.in");
				system("/bin/rm -rf ./MAXENT_sftools.log ./MAXENT_script_for_sftools.in");
			
				cpgtext(0.0, 0.85-0.050*(more_col+2), "Written file 'from_graphent.mtz'." );
				cpgtext(0.0, 0.85-0.050*(more_col+3), "Ready to roll ..." );
				sleep(2);
				cpgclos();
				return;
				

				}
				if ( c == '2' )
				{
				cpgtext(0.0, 0.85-0.050*(more_col+1), "A m(2|F1|-|F2|)exp(iPHI) synthesis." );

				out = fopen( "MAXENT_script_for_sftools.in", "w" );
				fprintf( out, "\n\nsftools > ./MAXENT_sftools.log << eof\n");
				fprintf( out, "read %s\n", file);
				fprintf( out, "calc f col 2F1-F2 = col %d 2.0 * col %d -\n", colid[0], colid[2]);
				fprintf( out, "calc q col sig2F1-F2 = col %d 2.0 * col %d +\n", colid[1], colid[3]);
				fprintf( out, "write from_graphent.mtz col 2F1-F2 sig2F1-F2 %d %d", colid[4], colid[5]);
				fprintf( out, "\ny\nquit\n");
				fprintf( out, "eof\n");
				fclose(out);
				system("/bin/chmod 755 MAXENT_script_for_sftools.in ; ./MAXENT_script_for_sftools.in");
				system("/bin/rm -rf ./MAXENT_sftools.log ./MAXENT_script_for_sftools.in");
			
				cpgtext(0.0, 0.85-0.050*(more_col+2), "Written file 'from_graphent.mtz'." );
				cpgtext(0.0, 0.85-0.050*(more_col+3), "Ready to roll ..." );
				sleep(2);
				cpgclos();
				return;

					}
	                		}



	else if ( strcmp( ttps, "FQFP" ) == 0 )
	                {
	                	cpgtext(0.0, 0.85-0.050*(more_col-1), "Difference Fo-Fc Fourier synthesis." );
	                	cpgtext(0.0, 0.85-0.050*(more_col+0), "Press '2' for a 2Fo-Fc, '1' for a Fo-Fc" );
				while( 1 )
				{
					float	x, y;
					
					cpgcurs( &x, &y, &c );
					if ( c == '1' || c == '2' )
						break;
					}

				if ( c == '1' )
				{
				cpgtext(0.0, 0.85-0.050*(more_col+1), "A (|Fo|-|Fc|)exp(iPHI) synthesis." );

				out = fopen( "MAXENT_script_for_sftools.in", "w" );
				fprintf( out, "\n\nsftools > ./MAXENT_sftools.log << eof\n");
				fprintf( out, "read %s\n", file);
				fprintf( out, "calc f col Fo-Fc = col %d col %d -\n", colid[0], colid[2]);
				fprintf( out, "calc q col sigFo-Fc = col %d\n", colid[1]);
				fprintf( out, "write from_graphent.mtz col Fo-Fc sigFo-Fc %d", colid[3]);
				fprintf( out, "\ny\nquit\n");
				fprintf( out, "eof\n");
				fclose(out);
				system("/bin/chmod 755 MAXENT_script_for_sftools.in ; ./MAXENT_script_for_sftools.in");
				system("/bin/rm -rf ./MAXENT_sftools.log ./MAXENT_script_for_sftools.in");
			
				cpgtext(0.0, 0.85-0.050*(more_col+2), "Written file 'from_graphent.mtz'." );
				cpgtext(0.0, 0.85-0.050*(more_col+3), "Ready to roll ..." );
				sleep(2);
				cpgclos();
				return;
				
				
					}
				if ( c == '2' )
				{
				cpgtext(0.0, 0.85-0.050*(more_col+1), "A (2|Fo|-|Fc|)exp(iPHI) synthesis." );

				out = fopen( "MAXENT_script_for_sftools.in", "w" );
				fprintf( out, "\n\nsftools > ./MAXENT_sftools.log << eof\n");
				fprintf( out, "read %s\n", file);
				fprintf( out, "calc f col 2Fo-Fc = col %d 2.0 * col %d -\n", colid[0], colid[2]);
				fprintf( out, "calc q col sig2Fo-Fc = col %d 2.0 *\n", colid[1]);
				fprintf( out, "write from_graphent.mtz col 2Fo-Fc sig2Fo-Fc %d", colid[3]);
				fprintf( out, "\ny\nquit\n");
				fprintf( out, "eof\n");
				fclose(out);
				system("/bin/chmod 755 MAXENT_script_for_sftools.in ; ./MAXENT_script_for_sftools.in");
				system("/bin/rm -rf ./MAXENT_sftools.log ./MAXENT_script_for_sftools.in");
			
				cpgtext(0.0, 0.85-0.050*(more_col+2), "Written file 'from_graphent.mtz'." );
				cpgtext(0.0, 0.85-0.050*(more_col+3), "Ready to roll ..." );
				sleep(2);
				cpgclos();
				return;
	                		}
	                		}

	else if ( strcmp( ttps, "FQFPW" ) == 0 )
	                {
	                	cpgtext(0.0, 0.85-0.050*(more_col-1), "Difference Fo-Fc Fourier synthesis with FOM." );
	                	cpgtext(0.0, 0.85-0.050*(more_col+0), "Press '2' for a 2Fo-Fc, '1' for a Fo-Fc" );
				while( 1 )
				{
					float	x, y;
					
					cpgcurs( &x, &y, &c );
					if ( c == '1' || c == '2' )
						break;
					}

				if ( c == '1' )
				{
				cpgtext(0.0, 0.85-0.050*(more_col+1), "A m(|Fo|-|Fc|)exp(iPHI) synthesis." );

				out = fopen( "MAXENT_script_for_sftools.in", "w" );
				fprintf( out, "\n\nsftools > ./MAXENT_sftools.log << eof\n");
				fprintf( out, "read %s\n", file);
				fprintf( out, "calc f col Fo-Fc = col %d col %d -\n", colid[0], colid[2]);
				fprintf( out, "calc q col sigFo-Fc = col %d\n", colid[1]);
				fprintf( out, "write from_graphent.mtz col Fo-Fc sigFo-Fc %d %d", colid[3], colid[4]);
				fprintf( out, "\ny\nquit\n");
				fprintf( out, "eof\n");
				fclose(out);
				system("/bin/chmod 755 MAXENT_script_for_sftools.in ; ./MAXENT_script_for_sftools.in");
				system("/bin/rm -rf ./MAXENT_sftools.log ./MAXENT_script_for_sftools.in");
			
				cpgtext(0.0, 0.85-0.050*(more_col+2), "Written file 'from_graphent.mtz'." );
				cpgtext(0.0, 0.85-0.050*(more_col+3), "Ready to roll ..." );
				sleep(2);
				cpgclos();
				return;
				

				}
				if ( c == '2' )
				{
				cpgtext(0.0, 0.85-0.050*(more_col+1), "A m(2|Fo|-|Fc|)exp(iPHI) synthesis." );

				out = fopen( "MAXENT_script_for_sftools.in", "w" );
				fprintf( out, "\n\nsftools > ./MAXENT_sftools.log << eof\n");
				fprintf( out, "read %s\n", file);
				fprintf( out, "calc f col 2Fo-Fc = col %d 2.0 * col %d -\n", colid[0], colid[2]);
				fprintf( out, "calc q col sig2Fo-Fc = col %d 2.0 *\n", colid[1]);
				fprintf( out, "write from_graphent.mtz col 2Fo-Fc sig2Fo-Fc %d %d", colid[3], colid[4]);
				fprintf( out, "\ny\nquit\n");
				fprintf( out, "eof\n");
				fclose(out);
				system("/bin/chmod 755 MAXENT_script_for_sftools.in ; ./MAXENT_script_for_sftools.in");
				system("/bin/rm -rf ./MAXENT_sftools.log ./MAXENT_script_for_sftools.in");
			
				cpgtext(0.0, 0.85-0.050*(more_col+2), "Written file 'from_graphent.mtz'." );
				cpgtext(0.0, 0.85-0.050*(more_col+3), "Ready to roll ..." );
				sleep(2);
				cpgclos();
				return;

					}
	                		}



	else
		{
			cpgclos();
			fprintf(stderr, "\033[31m\033[1m\nThe synthesis you have in mind failed to cross my mind.\033[0m\n");
			fprintf(stderr, "\033[37m\033[1mPlease use a program like sftools to prepare a .mtz file\033[0m\n");
			fprintf(stderr, "\033[37m\033[1mcontaining a recognisable set of column types (as described\033[0m\n");
			fprintf(stderr, "\033[37m\033[1min the program's documentation).\033[0m\n\n");
			exit(1);
		}	
						


}





#endif
#endif








#ifndef NOPGPLOT

/*********************************************************************************************************************************/
/** Expected (gaussian) vs observed chi**2 distribution 								 	**/
/*********************************************************************************************************************************/


void	chidist()
{

        char    j[200];
        float   **refl;
        float   *finpp;
	float	*plot1;
	int	saving[MAX_NOF_REFL];
        int     nref;
        int     i, m;
        int     step;
        float   aver_s, aver_df, aver_gof;
        float   v1, v2, v3;
        FILE	*out;
        float   px;
        double  x, y, ylast;
        double  d1;
        float   r1, r2;
        float   bdiv;
        float   sig_mul;
        int     test;
	float	minx, maxx, miny, maxy;
	int	bins;
	


					/* Doesn't worth doing a histogram with few reflections */
	if ( chitable < 180 )
		return;


	refl = matrix( 0, 6, 0, 2*MAX_NOF_REFL );
	finpp = vector( 0, 2*MAX_NOF_REFL );
	plot1 = vector( 0, 2*MAX_NOF_REFL );

        m=0;
        for ( x = 0.0 ; x <= 4.095 ; x += 0.0010 )
        {

        y = 1.0;
        ylast = 1.0;
        i = 1;
        while( 1 )
                {
                if ( i % 2 )
                        y -= pow( x , 2.0 * i ) / ( (1+2*i) * pow( 2.0, (double)(i)) * fact(i) );
                else
                        y += pow( x , 2.0 * i ) / ( (1+2*i) * pow( 2.0, (double)(i)) * fact(i) );
                                        
                if ( fabs( y - ylast ) < 0.0000000000001 )
                        break;
                i++;
                ylast=y;
                }
        
        y *= 2.0 * x * 0.398942280402;
        normtab[0][m] = x;
        normtab[1][m] = y;

        m++;


        
        }


	for ( i = 0 ; i < chitable ; i++ )
		plot1[i] = chicontrib[i];		

	nref = chitable;


				
	for ( i=0 ; i < nref ; i++ )
		saving[i] = i;
		
	if ( nref > 2 )
	{
        unsigned long n, i,ir,j,l;
	float	rra, *ra;
	int	*sav, s1;
	
	ra = &plot1[0] - 1;
	sav = &saving[0] - 1;
	
	n = nref;
        l=(n >> 1)+1;
        ir=n;
        for (;;) {
                if (l > 1) {
                        rra=ra[--l];
			s1 = sav[l];
                } else {
                        rra=ra[ir];
			s1 = sav[ir];
                        ra[ir]=ra[1];
			sav[ir] = sav[1];
                        if (--ir == 1) {
                                ra[1]=rra;
				sav[1] = s1;
                                break;
                        }
                }
                i=l;
                j=l+l;
                while (j <= ir) {
                        if (j < ir && ra[j] < ra[j+1]) j++;
                        if (rra < ra[j]) {
                                ra[i]=ra[j];
				sav[i] = sav[j];
                                i=j;
                                j <<= 1;
                        } else j=ir+1;
                }
                ra[i]=rra;
		sav[i] = s1;
        }
	}
	else
	{
		fprintf(stderr, "\n\n\n\033[31m\033[1mLess than two reflections (???). Abort.\n\n");
		exit(1);
				}
				


	if ( nref % 2 == 0 )
		{
			for ( i = nref/2 ; i < nref ; i++ )
				{
				plot1[i-1] = plot1[i];
				saving[i-1] = saving[i];
				}

			nref--;
		}			
	
	
        for ( i=1 ; i <= (int)(nref/2)+1 ; i++ )
                {
                        px = ((double)(nref) - 2.0 * i + 1.0) / (double)(nref) ;
                        d1 = (float)(findx( px ));
                        finpp[i-1] = -d1;
                        finpp[nref-i] = d1;
                                                }





	minx = finpp[0];
	maxx = finpp[0];
	miny = plot1[0];
	maxy = plot1[0];
	for ( i=0 ; i < nref ; i++ )
		{
			if ( finpp[i] > maxx )
				maxx = finpp[i];
			if ( finpp[i] < minx )
				minx = finpp[i];
			if ( plot1[i] > maxy )
				maxy = plot1[i];
			if ( plot1[i] < miny )
				miny = plot1[i];
					}
					


	maxy = 0.0;
	bins = (int)(nref / 30) > 100 ? 100 : (int)(nref / 30);
	for ( i=0 ; i < nref ; i++ )
		if ( finpp[i] >= -( 8.190 / (2.0 *bins)) && finpp[i] <= ( 8.190 / (2.0 *bins)) )
			maxy += 1.0;

	
	if ( ( VT125 == NO && cpgopen("/XWIN") <= 0 ) || ( VT125 == YES && cpgopen("/VT125") <= 0 ) )
		{
			fprintf(stderr, "\033[31m\033[1mCan not open graphics window.\033[0m\n");
			DO_PLOT = NO;
					}
	else
		{
			float	x, y;
			char	c;
		
			if ( GRAPH_WAIT == YES )
				cpgask(1);
			else
				cpgask(0);

			cpgslw(1);
    			cpgsci(2);
			cpgswin( -1.0250*max2(fabs(minx),fabs(maxx)), 1.0250*max2(fabs(minx),fabs(maxx)), 
					0.0, 1.250 * maxy );
			cpgbox("bc", 0.0, 0, "bc", 0.0, 0);
    			cpgsci(2);
			cpgmtxt("t", 1.0, 0.0, 0.0, "Distribution of (|Fo|-|Fmaxent|)/sigma(|Fo|)");

    			

    			cpgsci(8);
    			cpgsls(1);
    			cpgslw(5);
    			cpghist( nref, &plot1[0], -4.095, 4.095, bins, 3 );

    			cpgsci(3);
    			cpgsls(1);
    			cpgslw(5);
    			cpghist( nref, &finpp[0], -4.095, 4.095, bins, 1 );

			if ( HAVE_CCP4 != YES )
				cpgcurs( &x, &y, &c );



								}


	free_matrix(refl,  0, 6, 0, MAX_NOF_REFL );
	free_vector(finpp, 0, MAX_NOF_REFL );
	free_vector(plot1, 0, MAX_NOF_REFL );


	

}
	



#endif
